--------------------------------------------------------------------------------
-- Copyright (c) 1995-2005 Xilinx, Inc.  All rights reserved.
--------------------------------------------------------------------------------
--   ____  ____
--  /   /\/   /
-- /___/  \  /    Vendor: Xilinx
-- \   \   \/     Version: H.42
--  \   \         Application: netgen
--  /   /         Filename: cpu_map.vhd
-- /___/   /\     Timestamp: TUE 1 NOV 12:16:49 2005
-- \   \  /  \ 
--  \___\/\___\
--             
-- Command	: -intstyle ise -s 5 -pcf cpu.pcf -rpw 100 -tpw 0 -ar Structure -xon true -w -ofmt vhdl -sim cpu_map.ncd cpu_map.vhd 
-- Device	: 2v1000ff896-5 (PRODUCTION 1.121 2005-07-22)
-- Input file	: cpu_map.ncd
-- Output file	: cpu_map.vhd
-- # of Entities	: 1
-- Design Name	: cpu
-- Xilinx	: C:/Xilinx
--             
-- Purpose:    
--     This VHDL netlist is a verification model and uses simulation 
--     primitives which may not represent the true implementation of the 
--     device, however the netlist is functionally correct and should not 
--     be modified. This file cannot be synthesized and should only be used 
--     with supported simulation tools.
--             
-- Reference:  
--     Development System Reference Guide, Chapter 23
--     Synthesis and Verification Design Guide, Chapter 6
--             
--------------------------------------------------------------------------------

library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
library SIMPRIM;
use SIMPRIM.VCOMPONENTS.ALL;
use SIMPRIM.VPACKAGE.ALL;

entity cpu is
  port (
    CLK : in STD_LOGIC := 'X'; 
    USBTXEX : in STD_LOGIC := 'X'; 
    USBRXFX : in STD_LOGIC := 'X'; 
    CEHA1X : out STD_LOGIC; 
    LBOA : out STD_LOGIC; 
    XRWA : out STD_LOGIC; 
    USBWR : out STD_LOGIC; 
    OEAX : out STD_LOGIC; 
    CEA2 : out STD_LOGIC; 
    ADVLDA : out STD_LOGIC; 
    ZZA : out STD_LOGIC; 
    CLKMA0 : out STD_LOGIC; 
    CLKMA1 : out STD_LOGIC; 
    USBRSTX : out STD_LOGIC; 
    CELA1X : out STD_LOGIC; 
    USBRDX : out STD_LOGIC; 
    CEA : out STD_LOGIC; 
    CEA2X : out STD_LOGIC; 
    IOA : inout STD_LOGIC_VECTOR ( 31 downto 0 ); 
    USBD : inout STD_LOGIC_VECTOR ( 7 downto 0 ); 
    IOPA : inout STD_LOGIC_VECTOR ( 3 downto 0 ); 
    AA : out STD_LOGIC_VECTOR ( 19 downto 0 ); 
    BWA : out STD_LOGIC_VECTOR ( 3 downto 0 ); 
    LED : out STD_LOGIC_VECTOR ( 7 downto 0 ) 
  );
end cpu;

architecture Structure of cpu is
  signal IOA_17_IBUF : STD_LOGIC; 
  signal USBTXEX_IBUF : STD_LOGIC; 
  signal GLOBAL_LOGIC0 : STD_LOGIC; 
  signal BCLK1 : STD_LOGIC; 
  signal GLOBAL_LOGIC1 : STD_LOGIC; 
  signal BCLK : STD_LOGIC; 
  signal IOA_20_IBUF : STD_LOGIC; 
  signal N22_0 : STD_LOGIC; 
  signal IOA_19_IBUF : STD_LOGIC; 
  signal CHOICE45_0 : STD_LOGIC; 
  signal CHOICE51 : STD_LOGIC; 
  signal Q_n0002_0 : STD_LOGIC; 
  signal IOA_25_IBUF : STD_LOGIC; 
  signal IOA_26_IBUF : STD_LOGIC; 
  signal IOA_27_IBUF : STD_LOGIC; 
  signal IOA_28_IBUF : STD_LOGIC; 
  signal IOA_31_IBUF : STD_LOGIC; 
  signal IOA_22_IBUF : STD_LOGIC; 
  signal IOA_23_IBUF : STD_LOGIC; 
  signal IOA_24_IBUF : STD_LOGIC; 
  signal CHOICE50_0 : STD_LOGIC; 
  signal IOA_29_IBUF : STD_LOGIC; 
  signal IOA_30_IBUF : STD_LOGIC; 
  signal IOA_21_IBUF : STD_LOGIC; 
  signal IOA_0_IBUF : STD_LOGIC; 
  signal A_inst_cy_1 : STD_LOGIC; 
  signal IOA_1_IBUF : STD_LOGIC; 
  signal IOA_2_IBUF : STD_LOGIC; 
  signal A_inst_cy_3 : STD_LOGIC; 
  signal IOA_3_IBUF : STD_LOGIC; 
  signal IOA_4_IBUF : STD_LOGIC; 
  signal A_inst_cy_5 : STD_LOGIC; 
  signal IOA_5_IBUF : STD_LOGIC; 
  signal IOA_6_IBUF : STD_LOGIC; 
  signal A_inst_cy_7 : STD_LOGIC; 
  signal IOA_7_IBUF : STD_LOGIC; 
  signal IOA_8_IBUF : STD_LOGIC; 
  signal A_inst_cy_9 : STD_LOGIC; 
  signal IOA_9_IBUF : STD_LOGIC; 
  signal IOA_10_IBUF : STD_LOGIC; 
  signal A_inst_cy_11 : STD_LOGIC; 
  signal IOA_11_IBUF : STD_LOGIC; 
  signal IOA_12_IBUF : STD_LOGIC; 
  signal A_inst_cy_13 : STD_LOGIC; 
  signal IOA_13_IBUF : STD_LOGIC; 
  signal IOA_14_IBUF : STD_LOGIC; 
  signal A_inst_cy_15 : STD_LOGIC; 
  signal IOA_15_IBUF : STD_LOGIC; 
  signal IOA_16_IBUF : STD_LOGIC; 
  signal A_inst_cy_17 : STD_LOGIC; 
  signal IOA_18_IBUF : STD_LOGIC; 
  signal cpu_R_n0000_1_cyo : STD_LOGIC; 
  signal cpu_R_n0000_3_cyo : STD_LOGIC; 
  signal USBD_3_IBUF : STD_LOGIC; 
  signal USBD_4_IBUF : STD_LOGIC; 
  signal USBD_5_IBUF : STD_LOGIC; 
  signal IOPA_0_IBUF : STD_LOGIC; 
  signal USBD_6_IBUF : STD_LOGIC; 
  signal IOPA_1_IBUF : STD_LOGIC; 
  signal USBD_7_IBUF : STD_LOGIC; 
  signal IOPA_2_IBUF : STD_LOGIC; 
  signal IOPA_3_IBUF : STD_LOGIC; 
  signal USBRXFX_IBUF : STD_LOGIC; 
  signal USBD_0_IBUF : STD_LOGIC; 
  signal USBD_1_IBUF : STD_LOGIC; 
  signal USBD_2_IBUF : STD_LOGIC; 
  signal GSR : STD_LOGIC; 
  signal GTS : STD_LOGIC; 
  signal A_7_DXMUX : STD_LOGIC; 
  signal A_7_XORF : STD_LOGIC; 
  signal A_7_CYINIT : STD_LOGIC; 
  signal A_inst_lut3_71_O : STD_LOGIC; 
  signal A_7_DYMUX : STD_LOGIC; 
  signal A_7_XORG : STD_LOGIC; 
  signal A_inst_cy_8 : STD_LOGIC; 
  signal A_7_CYSELF : STD_LOGIC; 
  signal A_7_CYMUXFAST : STD_LOGIC; 
  signal A_7_CYAND : STD_LOGIC; 
  signal A_7_FASTCARRY : STD_LOGIC; 
  signal A_7_CYMUXG2 : STD_LOGIC; 
  signal A_7_CYMUXF2 : STD_LOGIC; 
  signal A_7_LOGIC_ZERO : STD_LOGIC; 
  signal A_7_CYSELG : STD_LOGIC; 
  signal A_inst_lut3_81_O : STD_LOGIC; 
  signal A_7_CLKINV : STD_LOGIC; 
  signal A_9_DXMUX : STD_LOGIC; 
  signal A_9_XORF : STD_LOGIC; 
  signal A_9_CYINIT : STD_LOGIC; 
  signal A_inst_lut3_91_O : STD_LOGIC; 
  signal A_9_DYMUX : STD_LOGIC; 
  signal A_9_XORG : STD_LOGIC; 
  signal A_inst_cy_10 : STD_LOGIC; 
  signal A_9_CYSELF : STD_LOGIC; 
  signal A_9_CYMUXFAST : STD_LOGIC; 
  signal A_9_CYAND : STD_LOGIC; 
  signal A_9_FASTCARRY : STD_LOGIC; 
  signal A_9_CYMUXG2 : STD_LOGIC; 
  signal A_9_CYMUXF2 : STD_LOGIC; 
  signal A_9_LOGIC_ZERO : STD_LOGIC; 
  signal A_9_CYSELG : STD_LOGIC; 
  signal A_inst_lut3_101_O : STD_LOGIC; 
  signal A_9_CLKINV : STD_LOGIC; 
  signal A_11_DXMUX : STD_LOGIC; 
  signal A_11_XORF : STD_LOGIC; 
  signal A_11_CYINIT : STD_LOGIC; 
  signal A_inst_lut3_111_O : STD_LOGIC; 
  signal A_11_DYMUX : STD_LOGIC; 
  signal A_11_XORG : STD_LOGIC; 
  signal A_inst_cy_12 : STD_LOGIC; 
  signal A_11_CYSELF : STD_LOGIC; 
  signal A_11_CYMUXFAST : STD_LOGIC; 
  signal A_11_CYAND : STD_LOGIC; 
  signal A_11_FASTCARRY : STD_LOGIC; 
  signal A_11_CYMUXG2 : STD_LOGIC; 
  signal A_11_CYMUXF2 : STD_LOGIC; 
  signal A_11_LOGIC_ZERO : STD_LOGIC; 
  signal A_11_CYSELG : STD_LOGIC; 
  signal A_inst_lut3_121_O : STD_LOGIC; 
  signal A_11_CLKINV : STD_LOGIC; 
  signal A_13_DXMUX : STD_LOGIC; 
  signal A_13_XORF : STD_LOGIC; 
  signal A_13_CYINIT : STD_LOGIC; 
  signal A_inst_lut3_131_O : STD_LOGIC; 
  signal A_13_DYMUX : STD_LOGIC; 
  signal A_13_XORG : STD_LOGIC; 
  signal A_inst_cy_14 : STD_LOGIC; 
  signal A_13_CYSELF : STD_LOGIC; 
  signal A_13_CYMUXFAST : STD_LOGIC; 
  signal A_13_CYAND : STD_LOGIC; 
  signal A_13_FASTCARRY : STD_LOGIC; 
  signal A_13_CYMUXG2 : STD_LOGIC; 
  signal A_13_CYMUXF2 : STD_LOGIC; 
  signal A_13_LOGIC_ZERO : STD_LOGIC; 
  signal A_13_CYSELG : STD_LOGIC; 
  signal A_inst_lut3_141_O : STD_LOGIC; 
  signal A_13_CLKINV : STD_LOGIC; 
  signal A_15_DXMUX : STD_LOGIC; 
  signal A_15_XORF : STD_LOGIC; 
  signal A_15_CYINIT : STD_LOGIC; 
  signal A_inst_lut3_151_O : STD_LOGIC; 
  signal A_15_DYMUX : STD_LOGIC; 
  signal A_15_XORG : STD_LOGIC; 
  signal A_inst_cy_16 : STD_LOGIC; 
  signal A_15_CYSELF : STD_LOGIC; 
  signal A_15_CYMUXFAST : STD_LOGIC; 
  signal A_15_CYAND : STD_LOGIC; 
  signal A_15_FASTCARRY : STD_LOGIC; 
  signal A_15_CYMUXG2 : STD_LOGIC; 
  signal A_15_CYMUXF2 : STD_LOGIC; 
  signal A_15_LOGIC_ZERO : STD_LOGIC; 
  signal A_15_CYSELG : STD_LOGIC; 
  signal A_inst_lut3_161_O : STD_LOGIC; 
  signal A_15_CLKINV : STD_LOGIC; 
  signal A_17_DXMUX : STD_LOGIC; 
  signal A_17_XORF : STD_LOGIC; 
  signal A_17_CYINIT : STD_LOGIC; 
  signal A_inst_lut3_171_O : STD_LOGIC; 
  signal A_17_DYMUX : STD_LOGIC; 
  signal A_17_XORG : STD_LOGIC; 
  signal A_inst_cy_18 : STD_LOGIC; 
  signal A_17_CYSELF : STD_LOGIC; 
  signal A_17_CYMUXFAST : STD_LOGIC; 
  signal A_17_CYAND : STD_LOGIC; 
  signal A_17_FASTCARRY : STD_LOGIC; 
  signal A_17_CYMUXG2 : STD_LOGIC; 
  signal A_17_CYMUXF2 : STD_LOGIC; 
  signal A_17_LOGIC_ZERO : STD_LOGIC; 
  signal A_17_CYSELG : STD_LOGIC; 
  signal A_inst_lut3_181_O : STD_LOGIC; 
  signal A_17_CLKINV : STD_LOGIC; 
  signal R_0_DXMUX : STD_LOGIC; 
  signal R_0_CYINIT : STD_LOGIC; 
  signal R_0_CY0F : STD_LOGIC; 
  signal R_0_CYSELF : STD_LOGIC; 
  signal cpu_R_n0000_0_lut_O_pack_1 : STD_LOGIC; 
  signal R_0_DYMUX : STD_LOGIC; 
  signal R_0_XORG : STD_LOGIC; 
  signal R_0_CYMUXG : STD_LOGIC; 
  signal cpu_R_n0000_0_cyo : STD_LOGIC; 
  signal R_0_CY0G : STD_LOGIC; 
  signal R_0_CYSELG : STD_LOGIC; 
  signal cpu_R_n0000_1_lut_O : STD_LOGIC; 
  signal R_0_CLKINV : STD_LOGIC; 
  signal R_0_CEINV : STD_LOGIC; 
  signal IOA_17_INBUF : STD_LOGIC; 
  signal USBTXEX_INBUF : STD_LOGIC; 
  signal ZZA_ENABLE : STD_LOGIC; 
  signal ZZA_O : STD_LOGIC; 
  signal BCLK_BUFG_S_INVNOT : STD_LOGIC; 
  signal A_19_DXMUX : STD_LOGIC; 
  signal A_19_XORF : STD_LOGIC; 
  signal A_19_CYINIT : STD_LOGIC; 
  signal A_inst_lut3_191_O : STD_LOGIC; 
  signal Q_n0002 : STD_LOGIC; 
  signal A_19_CLKINV : STD_LOGIC; 
  signal CHOICE45 : STD_LOGIC; 
  signal CHOICE50 : STD_LOGIC; 
  signal N22 : STD_LOGIC; 
  signal CHOICE51_pack_1 : STD_LOGIC; 
  signal A_0_CYINIT : STD_LOGIC; 
  signal A_0_CYSELF : STD_LOGIC; 
  signal Q_n0005 : STD_LOGIC; 
  signal A_0_DYMUX : STD_LOGIC; 
  signal A_0_XORG : STD_LOGIC; 
  signal A_0_CYMUXG : STD_LOGIC; 
  signal A_inst_cy_0 : STD_LOGIC; 
  signal A_0_LOGIC_ZERO : STD_LOGIC; 
  signal A_0_CYSELG : STD_LOGIC; 
  signal A_inst_lut3_01_O : STD_LOGIC; 
  signal A_0_CLKINV : STD_LOGIC; 
  signal A_1_DXMUX : STD_LOGIC; 
  signal A_1_XORF : STD_LOGIC; 
  signal A_1_CYINIT : STD_LOGIC; 
  signal A_inst_lut3_110_O : STD_LOGIC; 
  signal A_1_DYMUX : STD_LOGIC; 
  signal A_1_XORG : STD_LOGIC; 
  signal A_inst_cy_2 : STD_LOGIC; 
  signal A_1_CYSELF : STD_LOGIC; 
  signal A_1_CYMUXFAST : STD_LOGIC; 
  signal A_1_CYAND : STD_LOGIC; 
  signal A_1_FASTCARRY : STD_LOGIC; 
  signal A_1_CYMUXG2 : STD_LOGIC; 
  signal A_1_CYMUXF2 : STD_LOGIC; 
  signal A_1_LOGIC_ZERO : STD_LOGIC; 
  signal A_1_CYSELG : STD_LOGIC; 
  signal A_inst_lut3_21_O : STD_LOGIC; 
  signal A_1_CLKINV : STD_LOGIC; 
  signal A_3_DXMUX : STD_LOGIC; 
  signal A_3_XORF : STD_LOGIC; 
  signal A_3_CYINIT : STD_LOGIC; 
  signal A_inst_lut3_31_O : STD_LOGIC; 
  signal A_3_DYMUX : STD_LOGIC; 
  signal A_3_XORG : STD_LOGIC; 
  signal A_inst_cy_4 : STD_LOGIC; 
  signal A_3_CYSELF : STD_LOGIC; 
  signal A_3_CYMUXFAST : STD_LOGIC; 
  signal A_3_CYAND : STD_LOGIC; 
  signal A_3_FASTCARRY : STD_LOGIC; 
  signal A_3_CYMUXG2 : STD_LOGIC; 
  signal A_3_CYMUXF2 : STD_LOGIC; 
  signal A_3_LOGIC_ZERO : STD_LOGIC; 
  signal A_3_CYSELG : STD_LOGIC; 
  signal A_inst_lut3_41_O : STD_LOGIC; 
  signal A_3_CLKINV : STD_LOGIC; 
  signal A_5_DXMUX : STD_LOGIC; 
  signal A_5_XORF : STD_LOGIC; 
  signal A_5_CYINIT : STD_LOGIC; 
  signal A_inst_lut3_51_O : STD_LOGIC; 
  signal A_5_DYMUX : STD_LOGIC; 
  signal A_5_XORG : STD_LOGIC; 
  signal A_inst_cy_6 : STD_LOGIC; 
  signal A_5_CYSELF : STD_LOGIC; 
  signal A_5_CYMUXFAST : STD_LOGIC; 
  signal A_5_CYAND : STD_LOGIC; 
  signal A_5_FASTCARRY : STD_LOGIC; 
  signal A_5_CYMUXG2 : STD_LOGIC; 
  signal A_5_CYMUXF2 : STD_LOGIC; 
  signal A_5_LOGIC_ZERO : STD_LOGIC; 
  signal A_5_CYSELG : STD_LOGIC; 
  signal A_inst_lut3_61_O : STD_LOGIC; 
  signal A_5_CLKINV : STD_LOGIC; 
  signal BWA_0_ENABLE : STD_LOGIC; 
  signal BWA_0_O : STD_LOGIC; 
  signal IOA_3_INBUF : STD_LOGIC; 
  signal BWA_1_ENABLE : STD_LOGIC; 
  signal BWA_1_O : STD_LOGIC; 
  signal IOA_4_INBUF : STD_LOGIC; 
  signal BWA_2_ENABLE : STD_LOGIC; 
  signal BWA_2_O : STD_LOGIC; 
  signal CEA2_ENABLE : STD_LOGIC; 
  signal CEA2_O : STD_LOGIC; 
  signal IOA_5_INBUF : STD_LOGIC; 
  signal BWA_3_ENABLE : STD_LOGIC; 
  signal BWA_3_O : STD_LOGIC; 
  signal LBOA_ENABLE : STD_LOGIC; 
  signal LBOA_O : STD_LOGIC; 
  signal IOA_10_INBUF : STD_LOGIC; 
  signal USBRXFX_INBUF : STD_LOGIC; 
  signal IOA_6_INBUF : STD_LOGIC; 
  signal IOA_11_INBUF : STD_LOGIC; 
  signal IOA_7_INBUF : STD_LOGIC; 
  signal IOA_20_INBUF : STD_LOGIC; 
  signal IOA_12_INBUF : STD_LOGIC; 
  signal IOA_8_INBUF : STD_LOGIC; 
  signal IOA_21_INBUF : STD_LOGIC; 
  signal IOA_13_INBUF : STD_LOGIC; 
  signal CLK_INBUF : STD_LOGIC; 
  signal IOA_9_INBUF : STD_LOGIC; 
  signal IOA_30_INBUF : STD_LOGIC; 
  signal AA_0_ENABLE : STD_LOGIC; 
  signal AA_0_O : STD_LOGIC; 
  signal LED_3_ENABLE : STD_LOGIC; 
  signal LED_3_O : STD_LOGIC; 
  signal AA_1_ENABLE : STD_LOGIC; 
  signal AA_1_O : STD_LOGIC; 
  signal LED_4_ENABLE : STD_LOGIC; 
  signal LED_4_O : STD_LOGIC; 
  signal AA_2_ENABLE : STD_LOGIC; 
  signal AA_2_O : STD_LOGIC; 
  signal LED_5_ENABLE : STD_LOGIC; 
  signal LED_5_O : STD_LOGIC; 
  signal AA_3_ENABLE : STD_LOGIC; 
  signal AA_3_O : STD_LOGIC; 
  signal LED_6_ENABLE : STD_LOGIC; 
  signal LED_6_O : STD_LOGIC; 
  signal AA_4_ENABLE : STD_LOGIC; 
  signal AA_4_O : STD_LOGIC; 
  signal LED_7_ENABLE : STD_LOGIC; 
  signal LED_7_O : STD_LOGIC; 
  signal AA_5_ENABLE : STD_LOGIC; 
  signal AA_5_O : STD_LOGIC; 
  signal AA_6_ENABLE : STD_LOGIC; 
  signal AA_6_O : STD_LOGIC; 
  signal CEA2X_ENABLE : STD_LOGIC; 
  signal CEA2X_O : STD_LOGIC; 
  signal AA_7_ENABLE : STD_LOGIC; 
  signal AA_7_O : STD_LOGIC; 
  signal AA_8_ENABLE : STD_LOGIC; 
  signal AA_8_O : STD_LOGIC; 
  signal AA_9_ENABLE : STD_LOGIC; 
  signal AA_9_O : STD_LOGIC; 
  signal XRWA_ENABLE : STD_LOGIC; 
  signal XRWA_O : STD_LOGIC; 
  signal CELA1X_ENABLE : STD_LOGIC; 
  signal CELA1X_O : STD_LOGIC; 
  signal CEA_ENABLE : STD_LOGIC; 
  signal CEA_O : STD_LOGIC; 
  signal IOA_0_INBUF : STD_LOGIC; 
  signal IOA_1_INBUF : STD_LOGIC; 
  signal USBRDX_ENABLE : STD_LOGIC; 
  signal USBRDX_O : STD_LOGIC; 
  signal IOA_2_INBUF : STD_LOGIC; 
  signal IOA_29_INBUF : STD_LOGIC; 
  signal IOPA_1_INBUF : STD_LOGIC; 
  signal USBD_7_INBUF : STD_LOGIC; 
  signal IOPA_2_INBUF : STD_LOGIC; 
  signal IOPA_3_INBUF : STD_LOGIC; 
  signal AA_10_ENABLE : STD_LOGIC; 
  signal AA_10_O : STD_LOGIC; 
  signal OEAX_ENABLE : STD_LOGIC; 
  signal OEAX_O : STD_LOGIC; 
  signal AA_11_ENABLE : STD_LOGIC; 
  signal AA_11_O : STD_LOGIC; 
  signal ADVLDA_ENABLE : STD_LOGIC; 
  signal ADVLDA_O : STD_LOGIC; 
  signal AA_12_ENABLE : STD_LOGIC; 
  signal AA_12_O : STD_LOGIC; 
  signal USBWR_ENABLE : STD_LOGIC; 
  signal USBWR_O : STD_LOGIC; 
  signal AA_13_ENABLE : STD_LOGIC; 
  signal AA_13_O : STD_LOGIC; 
  signal AA_14_ENABLE : STD_LOGIC; 
  signal AA_14_O : STD_LOGIC; 
  signal AA_15_ENABLE : STD_LOGIC; 
  signal AA_15_O : STD_LOGIC; 
  signal AA_16_ENABLE : STD_LOGIC; 
  signal AA_16_O : STD_LOGIC; 
  signal CEHA1X_ENABLE : STD_LOGIC; 
  signal CEHA1X_O : STD_LOGIC; 
  signal AA_17_ENABLE : STD_LOGIC; 
  signal AA_17_O : STD_LOGIC; 
  signal AA_18_ENABLE : STD_LOGIC; 
  signal AA_18_O : STD_LOGIC; 
  signal AA_19_ENABLE : STD_LOGIC; 
  signal AA_19_O : STD_LOGIC; 
  signal LED_0_ENABLE : STD_LOGIC; 
  signal LED_0_O : STD_LOGIC; 
  signal LED_1_ENABLE : STD_LOGIC; 
  signal LED_1_O : STD_LOGIC; 
  signal LED_2_ENABLE : STD_LOGIC; 
  signal LED_2_O : STD_LOGIC; 
  signal R_2_DXMUX : STD_LOGIC; 
  signal R_2_XORF : STD_LOGIC; 
  signal R_2_CYINIT : STD_LOGIC; 
  signal R_2_CY0F : STD_LOGIC; 
  signal cpu_R_n0000_2_lut_O : STD_LOGIC; 
  signal R_2_DYMUX : STD_LOGIC; 
  signal R_2_XORG : STD_LOGIC; 
  signal cpu_R_n0000_2_cyo : STD_LOGIC; 
  signal R_2_CYSELF : STD_LOGIC; 
  signal R_2_CYMUXFAST : STD_LOGIC; 
  signal R_2_CYAND : STD_LOGIC; 
  signal R_2_FASTCARRY : STD_LOGIC; 
  signal R_2_CYMUXG2 : STD_LOGIC; 
  signal R_2_CYMUXF2 : STD_LOGIC; 
  signal R_2_CY0G : STD_LOGIC; 
  signal R_2_CYSELG : STD_LOGIC; 
  signal cpu_R_n0000_3_lut_O : STD_LOGIC; 
  signal R_2_CLKINV : STD_LOGIC; 
  signal R_2_CEINV : STD_LOGIC; 
  signal R_4_DXMUX : STD_LOGIC; 
  signal R_4_XORF : STD_LOGIC; 
  signal R_4_CYINIT : STD_LOGIC; 
  signal R_4_CY0F : STD_LOGIC; 
  signal cpu_R_n0000_4_lut_O : STD_LOGIC; 
  signal R_4_DYMUX : STD_LOGIC; 
  signal R_4_XORG : STD_LOGIC; 
  signal cpu_R_n0000_4_cyo : STD_LOGIC; 
  signal R_4_CYSELF : STD_LOGIC; 
  signal R_4_CYMUXFAST : STD_LOGIC; 
  signal R_4_CYAND : STD_LOGIC; 
  signal R_4_FASTCARRY : STD_LOGIC; 
  signal R_4_CYMUXG2 : STD_LOGIC; 
  signal R_4_CYMUXF2 : STD_LOGIC; 
  signal R_4_CY0G : STD_LOGIC; 
  signal R_4_CYSELG : STD_LOGIC; 
  signal cpu_R_n0000_5_lut_O : STD_LOGIC; 
  signal R_4_CLKINV : STD_LOGIC; 
  signal R_4_CEINV : STD_LOGIC; 
  signal R_6_DXMUX : STD_LOGIC; 
  signal R_6_XORF : STD_LOGIC; 
  signal R_6_CYINIT : STD_LOGIC; 
  signal R_6_CY0F : STD_LOGIC; 
  signal R_6_CYSELF : STD_LOGIC; 
  signal cpu_R_n0000_6_lut_O : STD_LOGIC; 
  signal R_6_DYMUX : STD_LOGIC; 
  signal R_6_XORG : STD_LOGIC; 
  signal cpu_R_n0000_6_cyo : STD_LOGIC; 
  signal cpu_R_n0000_7_lut_O : STD_LOGIC; 
  signal R_6_CLKINV : STD_LOGIC; 
  signal R_6_CEINV : STD_LOGIC; 
  signal USBD_3_INBUF : STD_LOGIC; 
  signal IOA_26_INBUF : STD_LOGIC; 
  signal IOA_18_INBUF : STD_LOGIC; 
  signal USBD_4_INBUF : STD_LOGIC; 
  signal CLKMA0_ENABLE : STD_LOGIC; 
  signal CLKMA0_O : STD_LOGIC; 
  signal IOA_27_INBUF : STD_LOGIC; 
  signal IOA_19_INBUF : STD_LOGIC; 
  signal CLKMA1_ENABLE : STD_LOGIC; 
  signal CLKMA1_O : STD_LOGIC; 
  signal USBD_5_INBUF : STD_LOGIC; 
  signal IOA_28_INBUF : STD_LOGIC; 
  signal IOPA_0_INBUF : STD_LOGIC; 
  signal USBD_6_INBUF : STD_LOGIC; 
  signal IOA_22_INBUF : STD_LOGIC; 
  signal IOA_14_INBUF : STD_LOGIC; 
  signal USBRSTX_ENABLE : STD_LOGIC; 
  signal USBRSTX_O : STD_LOGIC; 
  signal USBD_0_INBUF : STD_LOGIC; 
  signal IOA_31_INBUF : STD_LOGIC; 
  signal IOA_23_INBUF : STD_LOGIC; 
  signal IOA_15_INBUF : STD_LOGIC; 
  signal USBD_1_INBUF : STD_LOGIC; 
  signal IOA_24_INBUF : STD_LOGIC; 
  signal IOA_16_INBUF : STD_LOGIC; 
  signal USBD_2_INBUF : STD_LOGIC; 
  signal IOA_25_INBUF : STD_LOGIC; 
  signal A_0_FFY_RST : STD_LOGIC; 
  signal R_6_FFY_RST : STD_LOGIC; 
  signal A_19_FFX_RST : STD_LOGIC; 
  signal R_4_FFX_RST : STD_LOGIC; 
  signal R_6_FFX_RST : STD_LOGIC; 
  signal A_1_FFY_RST : STD_LOGIC; 
  signal A_1_FFX_RST : STD_LOGIC; 
  signal A_3_FFY_RST : STD_LOGIC; 
  signal A_3_FFX_RST : STD_LOGIC; 
  signal A_5_FFY_RST : STD_LOGIC; 
  signal A_5_FFX_RST : STD_LOGIC; 
  signal A_7_FFY_RST : STD_LOGIC; 
  signal A_7_FFX_RST : STD_LOGIC; 
  signal A_9_FFY_RST : STD_LOGIC; 
  signal A_9_FFX_RST : STD_LOGIC; 
  signal A_11_FFY_RST : STD_LOGIC; 
  signal A_11_FFX_RST : STD_LOGIC; 
  signal A_13_FFY_RST : STD_LOGIC; 
  signal A_13_FFX_RST : STD_LOGIC; 
  signal A_15_FFY_RST : STD_LOGIC; 
  signal A_15_FFX_RST : STD_LOGIC; 
  signal A_17_FFY_RST : STD_LOGIC; 
  signal A_17_FFX_RST : STD_LOGIC; 
  signal R_0_FFY_RST : STD_LOGIC; 
  signal R_0_FFX_RST : STD_LOGIC; 
  signal R_2_FFY_RST : STD_LOGIC; 
  signal R_2_FFX_RST : STD_LOGIC; 
  signal R_4_FFY_RST : STD_LOGIC; 
  signal GND : STD_LOGIC; 
  signal VCC : STD_LOGIC; 
  signal A : STD_LOGIC_VECTOR ( 19 downto 0 ); 
  signal R : STD_LOGIC_VECTOR ( 7 downto 0 ); 
begin
  A_7_LOGIC_ZERO_0 : X_ZERO
    port map (
      O => A_7_LOGIC_ZERO
    );
  A_7_DXMUX_1 : X_BUF_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => A_7_XORF,
      O => A_7_DXMUX
    );
  A_7_XORF_2 : X_XOR2
    port map (
      I0 => A_7_CYINIT,
      I1 => A_inst_lut3_71_O,
      O => A_7_XORF
    );
  A_7_CYMUXF2_3 : X_MUX2
    port map (
      IA => A_7_LOGIC_ZERO,
      IB => A_7_LOGIC_ZERO,
      SEL => A_7_CYSELF,
      O => A_7_CYMUXF2
    );
  A_7_CYMUXF : X_MUX2
    port map (
      IA => A_7_LOGIC_ZERO,
      IB => A_7_CYINIT,
      SEL => A_7_CYSELF,
      O => A_inst_cy_8
    );
  A_7_CYINIT_4 : X_BUF_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => A_inst_cy_7,
      O => A_7_CYINIT
    );
  A_7_CYSELF_5 : X_BUF_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => A_inst_lut3_71_O,
      O => A_7_CYSELF
    );
  A_7_DYMUX_6 : X_BUF_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => A_7_XORG,
      O => A_7_DYMUX
    );
  A_7_XORG_7 : X_XOR2
    port map (
      I0 => A_inst_cy_8,
      I1 => A_inst_lut3_81_O,
      O => A_7_XORG
    );
  A_7_COUTUSED : X_BUF_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => A_7_CYMUXFAST,
      O => A_inst_cy_9
    );
  A_7_FASTCARRY_8 : X_BUF_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => A_inst_cy_7,
      O => A_7_FASTCARRY
    );
  A_7_CYAND_9 : X_AND2
    port map (
      I0 => A_7_CYSELG,
      I1 => A_7_CYSELF,
      O => A_7_CYAND
    );
  A_7_CYMUXFAST_10 : X_MUX2
    port map (
      IA => A_7_CYMUXG2,
      IB => A_7_FASTCARRY,
      SEL => A_7_CYAND,
      O => A_7_CYMUXFAST
    );
  A_7_CYMUXG2_11 : X_MUX2
    port map (
      IA => A_7_LOGIC_ZERO,
      IB => A_7_CYMUXF2,
      SEL => A_7_CYSELG,
      O => A_7_CYMUXG2
    );
  A_7_CYSELG_12 : X_BUF_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => A_inst_lut3_81_O,
      O => A_7_CYSELG
    );
  A_7_CLKINV_13 : X_BUF_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => BCLK,
      O => A_7_CLKINV
    );
  A_inst_lut3_81 : X_LUT4
    generic map(
      INIT => X"F0E2"
    )
    port map (
      ADR0 => IOA_8_IBUF,
      ADR1 => N22_0,
      ADR2 => A(8),
      ADR3 => IOA_20_IBUF,
      O => A_inst_lut3_81_O
    );
  A_9_LOGIC_ZERO_14 : X_ZERO
    port map (
      O => A_9_LOGIC_ZERO
    );
  A_9_DXMUX_15 : X_BUF_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => A_9_XORF,
      O => A_9_DXMUX
    );
  A_9_XORF_16 : X_XOR2
    port map (
      I0 => A_9_CYINIT,
      I1 => A_inst_lut3_91_O,
      O => A_9_XORF
    );
  A_9_CYMUXF2_17 : X_MUX2
    port map (
      IA => A_9_LOGIC_ZERO,
      IB => A_9_LOGIC_ZERO,
      SEL => A_9_CYSELF,
      O => A_9_CYMUXF2
    );
  A_9_CYMUXF : X_MUX2
    port map (
      IA => A_9_LOGIC_ZERO,
      IB => A_9_CYINIT,
      SEL => A_9_CYSELF,
      O => A_inst_cy_10
    );
  A_9_CYINIT_18 : X_BUF_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => A_inst_cy_9,
      O => A_9_CYINIT
    );
  A_9_CYSELF_19 : X_BUF_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => A_inst_lut3_91_O,
      O => A_9_CYSELF
    );
  A_9_DYMUX_20 : X_BUF_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => A_9_XORG,
      O => A_9_DYMUX
    );
  A_9_XORG_21 : X_XOR2
    port map (
      I0 => A_inst_cy_10,
      I1 => A_inst_lut3_101_O,
      O => A_9_XORG
    );
  A_9_COUTUSED : X_BUF_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => A_9_CYMUXFAST,
      O => A_inst_cy_11
    );
  A_9_FASTCARRY_22 : X_BUF_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => A_inst_cy_9,
      O => A_9_FASTCARRY
    );
  A_9_CYAND_23 : X_AND2
    port map (
      I0 => A_9_CYSELG,
      I1 => A_9_CYSELF,
      O => A_9_CYAND
    );
  A_9_CYMUXFAST_24 : X_MUX2
    port map (
      IA => A_9_CYMUXG2,
      IB => A_9_FASTCARRY,
      SEL => A_9_CYAND,
      O => A_9_CYMUXFAST
    );
  A_9_CYMUXG2_25 : X_MUX2
    port map (
      IA => A_9_LOGIC_ZERO,
      IB => A_9_CYMUXF2,
      SEL => A_9_CYSELG,
      O => A_9_CYMUXG2
    );
  A_9_CYSELG_26 : X_BUF_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => A_inst_lut3_101_O,
      O => A_9_CYSELG
    );
  A_9_CLKINV_27 : X_BUF_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => BCLK,
      O => A_9_CLKINV
    );
  A_inst_lut3_101 : X_LUT4
    generic map(
      INIT => X"F0E2"
    )
    port map (
      ADR0 => IOA_10_IBUF,
      ADR1 => N22_0,
      ADR2 => A(10),
      ADR3 => IOA_20_IBUF,
      O => A_inst_lut3_101_O
    );
  A_11_LOGIC_ZERO_28 : X_ZERO
    port map (
      O => A_11_LOGIC_ZERO
    );
  A_11_DXMUX_29 : X_BUF_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => A_11_XORF,
      O => A_11_DXMUX
    );
  A_11_XORF_30 : X_XOR2
    port map (
      I0 => A_11_CYINIT,
      I1 => A_inst_lut3_111_O,
      O => A_11_XORF
    );
  A_11_CYMUXF2_31 : X_MUX2
    port map (
      IA => A_11_LOGIC_ZERO,
      IB => A_11_LOGIC_ZERO,
      SEL => A_11_CYSELF,
      O => A_11_CYMUXF2
    );
  A_11_CYMUXF : X_MUX2
    port map (
      IA => A_11_LOGIC_ZERO,
      IB => A_11_CYINIT,
      SEL => A_11_CYSELF,
      O => A_inst_cy_12
    );
  A_11_CYINIT_32 : X_BUF_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => A_inst_cy_11,
      O => A_11_CYINIT
    );
  A_11_CYSELF_33 : X_BUF_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => A_inst_lut3_111_O,
      O => A_11_CYSELF
    );
  A_11_DYMUX_34 : X_BUF_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => A_11_XORG,
      O => A_11_DYMUX
    );
  A_11_XORG_35 : X_XOR2
    port map (
      I0 => A_inst_cy_12,
      I1 => A_inst_lut3_121_O,
      O => A_11_XORG
    );
  A_11_COUTUSED : X_BUF_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => A_11_CYMUXFAST,
      O => A_inst_cy_13
    );
  A_11_FASTCARRY_36 : X_BUF_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => A_inst_cy_11,
      O => A_11_FASTCARRY
    );
  A_11_CYAND_37 : X_AND2
    port map (
      I0 => A_11_CYSELG,
      I1 => A_11_CYSELF,
      O => A_11_CYAND
    );
  A_11_CYMUXFAST_38 : X_MUX2
    port map (
      IA => A_11_CYMUXG2,
      IB => A_11_FASTCARRY,
      SEL => A_11_CYAND,
      O => A_11_CYMUXFAST
    );
  A_11_CYMUXG2_39 : X_MUX2
    port map (
      IA => A_11_LOGIC_ZERO,
      IB => A_11_CYMUXF2,
      SEL => A_11_CYSELG,
      O => A_11_CYMUXG2
    );
  A_11_CYSELG_40 : X_BUF_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => A_inst_lut3_121_O,
      O => A_11_CYSELG
    );
  A_11_CLKINV_41 : X_BUF_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => BCLK,
      O => A_11_CLKINV
    );
  A_inst_lut3_121 : X_LUT4
    generic map(
      INIT => X"F0E2"
    )
    port map (
      ADR0 => IOA_12_IBUF,
      ADR1 => N22_0,
      ADR2 => A(12),
      ADR3 => IOA_20_IBUF,
      O => A_inst_lut3_121_O
    );
  A_13_LOGIC_ZERO_42 : X_ZERO
    port map (
      O => A_13_LOGIC_ZERO
    );
  A_13_DXMUX_43 : X_BUF_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => A_13_XORF,
      O => A_13_DXMUX
    );
  A_13_XORF_44 : X_XOR2
    port map (
      I0 => A_13_CYINIT,
      I1 => A_inst_lut3_131_O,
      O => A_13_XORF
    );
  A_13_CYMUXF2_45 : X_MUX2
    port map (
      IA => A_13_LOGIC_ZERO,
      IB => A_13_LOGIC_ZERO,
      SEL => A_13_CYSELF,
      O => A_13_CYMUXF2
    );
  A_13_CYMUXF : X_MUX2
    port map (
      IA => A_13_LOGIC_ZERO,
      IB => A_13_CYINIT,
      SEL => A_13_CYSELF,
      O => A_inst_cy_14
    );
  A_13_CYINIT_46 : X_BUF_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => A_inst_cy_13,
      O => A_13_CYINIT
    );
  A_13_CYSELF_47 : X_BUF_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => A_inst_lut3_131_O,
      O => A_13_CYSELF
    );
  A_13_DYMUX_48 : X_BUF_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => A_13_XORG,
      O => A_13_DYMUX
    );
  A_13_XORG_49 : X_XOR2
    port map (
      I0 => A_inst_cy_14,
      I1 => A_inst_lut3_141_O,
      O => A_13_XORG
    );
  A_13_COUTUSED : X_BUF_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => A_13_CYMUXFAST,
      O => A_inst_cy_15
    );
  A_13_FASTCARRY_50 : X_BUF_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => A_inst_cy_13,
      O => A_13_FASTCARRY
    );
  A_13_CYAND_51 : X_AND2
    port map (
      I0 => A_13_CYSELG,
      I1 => A_13_CYSELF,
      O => A_13_CYAND
    );
  A_13_CYMUXFAST_52 : X_MUX2
    port map (
      IA => A_13_CYMUXG2,
      IB => A_13_FASTCARRY,
      SEL => A_13_CYAND,
      O => A_13_CYMUXFAST
    );
  A_13_CYMUXG2_53 : X_MUX2
    port map (
      IA => A_13_LOGIC_ZERO,
      IB => A_13_CYMUXF2,
      SEL => A_13_CYSELG,
      O => A_13_CYMUXG2
    );
  A_13_CYSELG_54 : X_BUF_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => A_inst_lut3_141_O,
      O => A_13_CYSELG
    );
  A_13_CLKINV_55 : X_BUF_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => BCLK,
      O => A_13_CLKINV
    );
  A_inst_lut3_141 : X_LUT4
    generic map(
      INIT => X"F0E2"
    )
    port map (
      ADR0 => IOA_14_IBUF,
      ADR1 => N22_0,
      ADR2 => A(14),
      ADR3 => IOA_20_IBUF,
      O => A_inst_lut3_141_O
    );
  A_15_LOGIC_ZERO_56 : X_ZERO
    port map (
      O => A_15_LOGIC_ZERO
    );
  A_15_DXMUX_57 : X_BUF_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => A_15_XORF,
      O => A_15_DXMUX
    );
  A_15_XORF_58 : X_XOR2
    port map (
      I0 => A_15_CYINIT,
      I1 => A_inst_lut3_151_O,
      O => A_15_XORF
    );
  A_15_CYMUXF2_59 : X_MUX2
    port map (
      IA => A_15_LOGIC_ZERO,
      IB => A_15_LOGIC_ZERO,
      SEL => A_15_CYSELF,
      O => A_15_CYMUXF2
    );
  A_15_CYMUXF : X_MUX2
    port map (
      IA => A_15_LOGIC_ZERO,
      IB => A_15_CYINIT,
      SEL => A_15_CYSELF,
      O => A_inst_cy_16
    );
  A_15_CYINIT_60 : X_BUF_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => A_inst_cy_15,
      O => A_15_CYINIT
    );
  A_15_CYSELF_61 : X_BUF_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => A_inst_lut3_151_O,
      O => A_15_CYSELF
    );
  A_15_DYMUX_62 : X_BUF_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => A_15_XORG,
      O => A_15_DYMUX
    );
  A_15_XORG_63 : X_XOR2
    port map (
      I0 => A_inst_cy_16,
      I1 => A_inst_lut3_161_O,
      O => A_15_XORG
    );
  A_15_COUTUSED : X_BUF_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => A_15_CYMUXFAST,
      O => A_inst_cy_17
    );
  A_15_FASTCARRY_64 : X_BUF_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => A_inst_cy_15,
      O => A_15_FASTCARRY
    );
  A_15_CYAND_65 : X_AND2
    port map (
      I0 => A_15_CYSELG,
      I1 => A_15_CYSELF,
      O => A_15_CYAND
    );
  A_15_CYMUXFAST_66 : X_MUX2
    port map (
      IA => A_15_CYMUXG2,
      IB => A_15_FASTCARRY,
      SEL => A_15_CYAND,
      O => A_15_CYMUXFAST
    );
  A_15_CYMUXG2_67 : X_MUX2
    port map (
      IA => A_15_LOGIC_ZERO,
      IB => A_15_CYMUXF2,
      SEL => A_15_CYSELG,
      O => A_15_CYMUXG2
    );
  A_15_CYSELG_68 : X_BUF_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => A_inst_lut3_161_O,
      O => A_15_CYSELG
    );
  A_15_CLKINV_69 : X_BUF_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => BCLK,
      O => A_15_CLKINV
    );
  A_inst_lut3_161 : X_LUT4
    generic map(
      INIT => X"F0E2"
    )
    port map (
      ADR0 => IOA_16_IBUF,
      ADR1 => N22_0,
      ADR2 => A(16),
      ADR3 => IOA_20_IBUF,
      O => A_inst_lut3_161_O
    );
  A_17_LOGIC_ZERO_70 : X_ZERO
    port map (
      O => A_17_LOGIC_ZERO
    );
  A_17_DXMUX_71 : X_BUF_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => A_17_XORF,
      O => A_17_DXMUX
    );
  A_17_XORF_72 : X_XOR2
    port map (
      I0 => A_17_CYINIT,
      I1 => A_inst_lut3_171_O,
      O => A_17_XORF
    );
  A_17_CYMUXF2_73 : X_MUX2
    port map (
      IA => A_17_LOGIC_ZERO,
      IB => A_17_LOGIC_ZERO,
      SEL => A_17_CYSELF,
      O => A_17_CYMUXF2
    );
  A_17_CYMUXF : X_MUX2
    port map (
      IA => A_17_LOGIC_ZERO,
      IB => A_17_CYINIT,
      SEL => A_17_CYSELF,
      O => A_inst_cy_18
    );
  A_17_CYINIT_74 : X_BUF_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => A_inst_cy_17,
      O => A_17_CYINIT
    );
  A_17_CYSELF_75 : X_BUF_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => A_inst_lut3_171_O,
      O => A_17_CYSELF
    );
  A_17_DYMUX_76 : X_BUF_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => A_17_XORG,
      O => A_17_DYMUX
    );
  A_17_XORG_77 : X_XOR2
    port map (
      I0 => A_inst_cy_18,
      I1 => A_inst_lut3_181_O,
      O => A_17_XORG
    );
  A_17_FASTCARRY_78 : X_BUF_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => A_inst_cy_17,
      O => A_17_FASTCARRY
    );
  A_17_CYAND_79 : X_AND2
    port map (
      I0 => A_17_CYSELG,
      I1 => A_17_CYSELF,
      O => A_17_CYAND
    );
  A_17_CYMUXFAST_80 : X_MUX2
    port map (
      IA => A_17_CYMUXG2,
      IB => A_17_FASTCARRY,
      SEL => A_17_CYAND,
      O => A_17_CYMUXFAST
    );
  A_17_CYMUXG2_81 : X_MUX2
    port map (
      IA => A_17_LOGIC_ZERO,
      IB => A_17_CYMUXF2,
      SEL => A_17_CYSELG,
      O => A_17_CYMUXG2
    );
  A_17_CYSELG_82 : X_BUF_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => A_inst_lut3_181_O,
      O => A_17_CYSELG
    );
  A_17_CLKINV_83 : X_BUF_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => BCLK,
      O => A_17_CLKINV
    );
  A_inst_lut3_181 : X_LUT4
    generic map(
      INIT => X"F0E2"
    )
    port map (
      ADR0 => IOA_18_IBUF,
      ADR1 => N22_0,
      ADR2 => A(18),
      ADR3 => IOA_20_IBUF,
      O => A_inst_lut3_181_O
    );
  R_0_DXMUX_84 : X_BUF_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => cpu_R_n0000_0_lut_O_pack_1,
      O => R_0_DXMUX
    );
  R_0_CYMUXF : X_MUX2
    port map (
      IA => R_0_CY0F,
      IB => R_0_CYINIT,
      SEL => R_0_CYSELF,
      O => cpu_R_n0000_0_cyo
    );
  R_0_CYINIT_85 : X_BUF_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => GLOBAL_LOGIC0,
      O => R_0_CYINIT
    );
  R_0_CY0F_86 : X_BUF_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => R(0),
      O => R_0_CY0F
    );
  R_0_CYSELF_87 : X_BUF_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => cpu_R_n0000_0_lut_O_pack_1,
      O => R_0_CYSELF
    );
  R_0_DYMUX_88 : X_BUF_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => R_0_XORG,
      O => R_0_DYMUX
    );
  R_0_XORG_89 : X_XOR2
    port map (
      I0 => cpu_R_n0000_0_cyo,
      I1 => cpu_R_n0000_1_lut_O,
      O => R_0_XORG
    );
  R_0_COUTUSED : X_BUF_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => R_0_CYMUXG,
      O => cpu_R_n0000_1_cyo
    );
  R_0_CYMUXG_90 : X_MUX2
    port map (
      IA => R_0_CY0G,
      IB => cpu_R_n0000_0_cyo,
      SEL => R_0_CYSELG,
      O => R_0_CYMUXG
    );
  R_0_CY0G_91 : X_BUF_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => R(1),
      O => R_0_CY0G
    );
  R_0_CYSELG_92 : X_BUF_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => cpu_R_n0000_1_lut_O,
      O => R_0_CYSELG
    );
  R_0_CLKINV_93 : X_BUF_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => BCLK,
      O => R_0_CLKINV
    );
  R_0_CEINV_94 : X_BUF_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => Q_n0002_0,
      O => R_0_CEINV
    );
  IOA_17_IBUF_95 : X_BUF_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => IOA(17),
      O => IOA_17_INBUF
    );
  IOA_17_IFF_IMUX : X_BUF_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => IOA_17_INBUF,
      O => IOA_17_IBUF
    );
  USBTXEX_IBUF_96 : X_BUF_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => USBTXEX,
      O => USBTXEX_INBUF
    );
  USBTXEX_IFF_IMUX : X_BUF_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => USBTXEX_INBUF,
      O => USBTXEX_IBUF
    );
  ZZA_OBUF : X_TRI_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => ZZA_O,
      CTL => ZZA_ENABLE,
      O => ZZA
    );
  ZZA_ENABLEINV : X_INV_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => GTS,
      O => ZZA_ENABLE
    );
  BCLK_BUFG : X_BUFGMUX
    port map (
      I0 => BCLK1,
      I1 => GND,
      S => BCLK_BUFG_S_INVNOT,
      O => BCLK,
      GSR => GSR
    );
  BCLK_BUFG_SINV : X_INV_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => GLOBAL_LOGIC1,
      O => BCLK_BUFG_S_INVNOT
    );
  A_19_DXMUX_97 : X_BUF_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => A_19_XORF,
      O => A_19_DXMUX
    );
  A_19_XORF_98 : X_XOR2
    port map (
      I0 => A_19_CYINIT,
      I1 => A_inst_lut3_191_O,
      O => A_19_XORF
    );
  A_19_CYINIT_99 : X_BUF_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => A_17_CYMUXFAST,
      O => A_19_CYINIT
    );
  A_19_YUSED : X_BUF_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => Q_n0002,
      O => Q_n0002_0
    );
  A_19_CLKINV_100 : X_BUF_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => BCLK,
      O => A_19_CLKINV
    );
  Q_n000211 : X_LUT4
    generic map(
      INIT => X"1010"
    )
    port map (
      ADR0 => CHOICE45_0,
      ADR1 => CHOICE51,
      ADR2 => IOA_20_IBUF,
      ADR3 => VCC,
      O => Q_n0002
    );
  CHOICE45_XUSED : X_BUF_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => CHOICE45,
      O => CHOICE45_0
    );
  Q_n000224 : X_LUT4
    generic map(
      INIT => X"FFFE"
    )
    port map (
      ADR0 => IOA_25_IBUF,
      ADR1 => IOA_26_IBUF,
      ADR2 => IOA_27_IBUF,
      ADR3 => IOA_28_IBUF,
      O => CHOICE45
    );
  CHOICE50_XUSED : X_BUF_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => CHOICE50,
      O => CHOICE50_0
    );
  Q_n0002212 : X_LUT4
    generic map(
      INIT => X"FFFE"
    )
    port map (
      ADR0 => IOA_31_IBUF,
      ADR1 => IOA_22_IBUF,
      ADR2 => IOA_23_IBUF,
      ADR3 => IOA_24_IBUF,
      O => CHOICE50
    );
  N22_XUSED : X_BUF_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => N22,
      O => N22_0
    );
  N22_YUSED : X_BUF_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => CHOICE51_pack_1,
      O => CHOICE51
    );
  Q_n0002215 : X_LUT4
    generic map(
      INIT => X"FFFE"
    )
    port map (
      ADR0 => IOA_29_IBUF,
      ADR1 => IOA_30_IBUF,
      ADR2 => IOA_21_IBUF,
      ADR3 => CHOICE50_0,
      O => CHOICE51_pack_1
    );
  A_0_LOGIC_ZERO_101 : X_ZERO
    port map (
      O => A_0_LOGIC_ZERO
    );
  A_0_CYMUXF : X_MUX2
    port map (
      IA => A_0_LOGIC_ZERO,
      IB => A_0_CYINIT,
      SEL => A_0_CYSELF,
      O => A_inst_cy_0
    );
  A_0_CYINIT_102 : X_BUF_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => GLOBAL_LOGIC1,
      O => A_0_CYINIT
    );
  A_0_CYSELF_103 : X_BUF_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => Q_n0005,
      O => A_0_CYSELF
    );
  A_0_DYMUX_104 : X_BUF_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => A_0_XORG,
      O => A_0_DYMUX
    );
  A_0_XORG_105 : X_XOR2
    port map (
      I0 => A_inst_cy_0,
      I1 => A_inst_lut3_01_O,
      O => A_0_XORG
    );
  A_0_COUTUSED : X_BUF_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => A_0_CYMUXG,
      O => A_inst_cy_1
    );
  A_0_CYMUXG_106 : X_MUX2
    port map (
      IA => A_0_LOGIC_ZERO,
      IB => A_inst_cy_0,
      SEL => A_0_CYSELG,
      O => A_0_CYMUXG
    );
  A_0_CYSELG_107 : X_BUF_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => A_inst_lut3_01_O,
      O => A_0_CYSELG
    );
  A_0_CLKINV_108 : X_BUF_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => BCLK,
      O => A_0_CLKINV
    );
  A_inst_lut3_01 : X_LUT4
    generic map(
      INIT => X"F0E2"
    )
    port map (
      ADR0 => IOA_0_IBUF,
      ADR1 => N22_0,
      ADR2 => A(0),
      ADR3 => IOA_20_IBUF,
      O => A_inst_lut3_01_O
    );
  A_1_LOGIC_ZERO_109 : X_ZERO
    port map (
      O => A_1_LOGIC_ZERO
    );
  A_1_DXMUX_110 : X_BUF_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => A_1_XORF,
      O => A_1_DXMUX
    );
  A_1_XORF_111 : X_XOR2
    port map (
      I0 => A_1_CYINIT,
      I1 => A_inst_lut3_110_O,
      O => A_1_XORF
    );
  A_1_CYMUXF2_112 : X_MUX2
    port map (
      IA => A_1_LOGIC_ZERO,
      IB => A_1_LOGIC_ZERO,
      SEL => A_1_CYSELF,
      O => A_1_CYMUXF2
    );
  A_1_CYMUXF : X_MUX2
    port map (
      IA => A_1_LOGIC_ZERO,
      IB => A_1_CYINIT,
      SEL => A_1_CYSELF,
      O => A_inst_cy_2
    );
  A_1_CYINIT_113 : X_BUF_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => A_inst_cy_1,
      O => A_1_CYINIT
    );
  A_1_CYSELF_114 : X_BUF_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => A_inst_lut3_110_O,
      O => A_1_CYSELF
    );
  A_1_DYMUX_115 : X_BUF_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => A_1_XORG,
      O => A_1_DYMUX
    );
  A_1_XORG_116 : X_XOR2
    port map (
      I0 => A_inst_cy_2,
      I1 => A_inst_lut3_21_O,
      O => A_1_XORG
    );
  A_1_COUTUSED : X_BUF_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => A_1_CYMUXFAST,
      O => A_inst_cy_3
    );
  A_1_FASTCARRY_117 : X_BUF_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => A_inst_cy_1,
      O => A_1_FASTCARRY
    );
  A_1_CYAND_118 : X_AND2
    port map (
      I0 => A_1_CYSELG,
      I1 => A_1_CYSELF,
      O => A_1_CYAND
    );
  A_1_CYMUXFAST_119 : X_MUX2
    port map (
      IA => A_1_CYMUXG2,
      IB => A_1_FASTCARRY,
      SEL => A_1_CYAND,
      O => A_1_CYMUXFAST
    );
  A_1_CYMUXG2_120 : X_MUX2
    port map (
      IA => A_1_LOGIC_ZERO,
      IB => A_1_CYMUXF2,
      SEL => A_1_CYSELG,
      O => A_1_CYMUXG2
    );
  A_1_CYSELG_121 : X_BUF_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => A_inst_lut3_21_O,
      O => A_1_CYSELG
    );
  A_1_CLKINV_122 : X_BUF_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => BCLK,
      O => A_1_CLKINV
    );
  A_3_LOGIC_ZERO_123 : X_ZERO
    port map (
      O => A_3_LOGIC_ZERO
    );
  A_3_DXMUX_124 : X_BUF_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => A_3_XORF,
      O => A_3_DXMUX
    );
  A_3_XORF_125 : X_XOR2
    port map (
      I0 => A_3_CYINIT,
      I1 => A_inst_lut3_31_O,
      O => A_3_XORF
    );
  A_3_CYMUXF2_126 : X_MUX2
    port map (
      IA => A_3_LOGIC_ZERO,
      IB => A_3_LOGIC_ZERO,
      SEL => A_3_CYSELF,
      O => A_3_CYMUXF2
    );
  A_3_CYMUXF : X_MUX2
    port map (
      IA => A_3_LOGIC_ZERO,
      IB => A_3_CYINIT,
      SEL => A_3_CYSELF,
      O => A_inst_cy_4
    );
  A_3_CYINIT_127 : X_BUF_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => A_inst_cy_3,
      O => A_3_CYINIT
    );
  A_3_CYSELF_128 : X_BUF_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => A_inst_lut3_31_O,
      O => A_3_CYSELF
    );
  A_3_DYMUX_129 : X_BUF_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => A_3_XORG,
      O => A_3_DYMUX
    );
  A_3_XORG_130 : X_XOR2
    port map (
      I0 => A_inst_cy_4,
      I1 => A_inst_lut3_41_O,
      O => A_3_XORG
    );
  A_3_COUTUSED : X_BUF_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => A_3_CYMUXFAST,
      O => A_inst_cy_5
    );
  A_3_FASTCARRY_131 : X_BUF_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => A_inst_cy_3,
      O => A_3_FASTCARRY
    );
  A_3_CYAND_132 : X_AND2
    port map (
      I0 => A_3_CYSELG,
      I1 => A_3_CYSELF,
      O => A_3_CYAND
    );
  A_3_CYMUXFAST_133 : X_MUX2
    port map (
      IA => A_3_CYMUXG2,
      IB => A_3_FASTCARRY,
      SEL => A_3_CYAND,
      O => A_3_CYMUXFAST
    );
  A_3_CYMUXG2_134 : X_MUX2
    port map (
      IA => A_3_LOGIC_ZERO,
      IB => A_3_CYMUXF2,
      SEL => A_3_CYSELG,
      O => A_3_CYMUXG2
    );
  A_3_CYSELG_135 : X_BUF_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => A_inst_lut3_41_O,
      O => A_3_CYSELG
    );
  A_3_CLKINV_136 : X_BUF_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => BCLK,
      O => A_3_CLKINV
    );
  A_inst_lut3_41 : X_LUT4
    generic map(
      INIT => X"F0E2"
    )
    port map (
      ADR0 => IOA_4_IBUF,
      ADR1 => N22_0,
      ADR2 => A(4),
      ADR3 => IOA_20_IBUF,
      O => A_inst_lut3_41_O
    );
  A_5_LOGIC_ZERO_137 : X_ZERO
    port map (
      O => A_5_LOGIC_ZERO
    );
  A_5_DXMUX_138 : X_BUF_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => A_5_XORF,
      O => A_5_DXMUX
    );
  A_5_XORF_139 : X_XOR2
    port map (
      I0 => A_5_CYINIT,
      I1 => A_inst_lut3_51_O,
      O => A_5_XORF
    );
  A_5_CYMUXF2_140 : X_MUX2
    port map (
      IA => A_5_LOGIC_ZERO,
      IB => A_5_LOGIC_ZERO,
      SEL => A_5_CYSELF,
      O => A_5_CYMUXF2
    );
  A_5_CYMUXF : X_MUX2
    port map (
      IA => A_5_LOGIC_ZERO,
      IB => A_5_CYINIT,
      SEL => A_5_CYSELF,
      O => A_inst_cy_6
    );
  A_5_CYINIT_141 : X_BUF_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => A_inst_cy_5,
      O => A_5_CYINIT
    );
  A_5_CYSELF_142 : X_BUF_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => A_inst_lut3_51_O,
      O => A_5_CYSELF
    );
  A_5_DYMUX_143 : X_BUF_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => A_5_XORG,
      O => A_5_DYMUX
    );
  A_5_XORG_144 : X_XOR2
    port map (
      I0 => A_inst_cy_6,
      I1 => A_inst_lut3_61_O,
      O => A_5_XORG
    );
  A_5_COUTUSED : X_BUF_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => A_5_CYMUXFAST,
      O => A_inst_cy_7
    );
  A_5_FASTCARRY_145 : X_BUF_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => A_inst_cy_5,
      O => A_5_FASTCARRY
    );
  A_5_CYAND_146 : X_AND2
    port map (
      I0 => A_5_CYSELG,
      I1 => A_5_CYSELF,
      O => A_5_CYAND
    );
  A_5_CYMUXFAST_147 : X_MUX2
    port map (
      IA => A_5_CYMUXG2,
      IB => A_5_FASTCARRY,
      SEL => A_5_CYAND,
      O => A_5_CYMUXFAST
    );
  A_5_CYMUXG2_148 : X_MUX2
    port map (
      IA => A_5_LOGIC_ZERO,
      IB => A_5_CYMUXF2,
      SEL => A_5_CYSELG,
      O => A_5_CYMUXG2
    );
  A_5_CYSELG_149 : X_BUF_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => A_inst_lut3_61_O,
      O => A_5_CYSELG
    );
  A_5_CLKINV_150 : X_BUF_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => BCLK,
      O => A_5_CLKINV
    );
  A_inst_lut3_61 : X_LUT4
    generic map(
      INIT => X"F0E2"
    )
    port map (
      ADR0 => IOA_6_IBUF,
      ADR1 => N22_0,
      ADR2 => A(6),
      ADR3 => IOA_20_IBUF,
      O => A_inst_lut3_61_O
    );
  BWA_0_OBUF : X_TRI_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => BWA_0_O,
      CTL => BWA_0_ENABLE,
      O => BWA(0)
    );
  BWA_0_ENABLEINV : X_INV_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => GTS,
      O => BWA_0_ENABLE
    );
  IOA_3_IBUF_151 : X_BUF_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => IOA(3),
      O => IOA_3_INBUF
    );
  IOA_3_IFF_IMUX : X_BUF_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => IOA_3_INBUF,
      O => IOA_3_IBUF
    );
  BWA_1_OBUF : X_TRI_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => BWA_1_O,
      CTL => BWA_1_ENABLE,
      O => BWA(1)
    );
  BWA_1_ENABLEINV : X_INV_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => GTS,
      O => BWA_1_ENABLE
    );
  IOA_4_IBUF_152 : X_BUF_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => IOA(4),
      O => IOA_4_INBUF
    );
  IOA_4_IFF_IMUX : X_BUF_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => IOA_4_INBUF,
      O => IOA_4_IBUF
    );
  BWA_2_OBUF : X_TRI_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => BWA_2_O,
      CTL => BWA_2_ENABLE,
      O => BWA(2)
    );
  BWA_2_ENABLEINV : X_INV_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => GTS,
      O => BWA_2_ENABLE
    );
  CEA2_OBUF : X_TRI_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => CEA2_O,
      CTL => CEA2_ENABLE,
      O => CEA2
    );
  CEA2_ENABLEINV : X_INV_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => GTS,
      O => CEA2_ENABLE
    );
  IOA_5_IBUF_153 : X_BUF_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => IOA(5),
      O => IOA_5_INBUF
    );
  IOA_5_IFF_IMUX : X_BUF_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => IOA_5_INBUF,
      O => IOA_5_IBUF
    );
  BWA_3_OBUF : X_TRI_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => BWA_3_O,
      CTL => BWA_3_ENABLE,
      O => BWA(3)
    );
  BWA_3_ENABLEINV : X_INV_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => GTS,
      O => BWA_3_ENABLE
    );
  LBOA_OBUF : X_TRI_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => LBOA_O,
      CTL => LBOA_ENABLE,
      O => LBOA
    );
  LBOA_ENABLEINV : X_INV_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => GTS,
      O => LBOA_ENABLE
    );
  IOA_10_IBUF_154 : X_BUF_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => IOA(10),
      O => IOA_10_INBUF
    );
  IOA_10_IFF_IMUX : X_BUF_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => IOA_10_INBUF,
      O => IOA_10_IBUF
    );
  USBRXFX_IBUF_155 : X_BUF_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => USBRXFX,
      O => USBRXFX_INBUF
    );
  USBRXFX_IFF_IMUX : X_BUF_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => USBRXFX_INBUF,
      O => USBRXFX_IBUF
    );
  IOA_6_IBUF_156 : X_BUF_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => IOA(6),
      O => IOA_6_INBUF
    );
  IOA_6_IFF_IMUX : X_BUF_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => IOA_6_INBUF,
      O => IOA_6_IBUF
    );
  IOA_11_IBUF_157 : X_BUF_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => IOA(11),
      O => IOA_11_INBUF
    );
  IOA_11_IFF_IMUX : X_BUF_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => IOA_11_INBUF,
      O => IOA_11_IBUF
    );
  IOA_7_IBUF_158 : X_BUF_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => IOA(7),
      O => IOA_7_INBUF
    );
  IOA_7_IFF_IMUX : X_BUF_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => IOA_7_INBUF,
      O => IOA_7_IBUF
    );
  IOA_20_IBUF_159 : X_BUF_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => IOA(20),
      O => IOA_20_INBUF
    );
  IOA_20_IFF_IMUX : X_BUF_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => IOA_20_INBUF,
      O => IOA_20_IBUF
    );
  IOA_12_IBUF_160 : X_BUF_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => IOA(12),
      O => IOA_12_INBUF
    );
  IOA_12_IFF_IMUX : X_BUF_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => IOA_12_INBUF,
      O => IOA_12_IBUF
    );
  IOA_8_IBUF_161 : X_BUF_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => IOA(8),
      O => IOA_8_INBUF
    );
  IOA_8_IFF_IMUX : X_BUF_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => IOA_8_INBUF,
      O => IOA_8_IBUF
    );
  IOA_21_IBUF_162 : X_BUF_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => IOA(21),
      O => IOA_21_INBUF
    );
  IOA_21_IFF_IMUX : X_BUF_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => IOA_21_INBUF,
      O => IOA_21_IBUF
    );
  IOA_13_IBUF_163 : X_BUF_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => IOA(13),
      O => IOA_13_INBUF
    );
  IOA_13_IFF_IMUX : X_BUF_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => IOA_13_INBUF,
      O => IOA_13_IBUF
    );
  IBG : X_BUF_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => CLK,
      O => CLK_INBUF
    );
  CLK_IFF_IMUX : X_BUF_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => CLK_INBUF,
      O => BCLK1
    );
  IOA_9_IBUF_164 : X_BUF_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => IOA(9),
      O => IOA_9_INBUF
    );
  IOA_9_IFF_IMUX : X_BUF_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => IOA_9_INBUF,
      O => IOA_9_IBUF
    );
  IOA_30_IBUF_165 : X_BUF_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => IOA(30),
      O => IOA_30_INBUF
    );
  IOA_30_IFF_IMUX : X_BUF_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => IOA_30_INBUF,
      O => IOA_30_IBUF
    );
  AA_0_OBUF : X_TRI_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => AA_0_O,
      CTL => AA_0_ENABLE,
      O => AA(0)
    );
  AA_0_ENABLEINV : X_INV_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => GTS,
      O => AA_0_ENABLE
    );
  LED_3_OBUF : X_TRI_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => LED_3_O,
      CTL => LED_3_ENABLE,
      O => LED(3)
    );
  LED_3_ENABLEINV : X_INV_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => GTS,
      O => LED_3_ENABLE
    );
  AA_1_OBUF : X_TRI_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => AA_1_O,
      CTL => AA_1_ENABLE,
      O => AA(1)
    );
  AA_1_ENABLEINV : X_INV_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => GTS,
      O => AA_1_ENABLE
    );
  LED_4_OBUF : X_TRI_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => LED_4_O,
      CTL => LED_4_ENABLE,
      O => LED(4)
    );
  LED_4_ENABLEINV : X_INV_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => GTS,
      O => LED_4_ENABLE
    );
  AA_2_OBUF : X_TRI_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => AA_2_O,
      CTL => AA_2_ENABLE,
      O => AA(2)
    );
  AA_2_ENABLEINV : X_INV_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => GTS,
      O => AA_2_ENABLE
    );
  LED_5_OBUF : X_TRI_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => LED_5_O,
      CTL => LED_5_ENABLE,
      O => LED(5)
    );
  LED_5_ENABLEINV : X_INV_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => GTS,
      O => LED_5_ENABLE
    );
  AA_3_OBUF : X_TRI_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => AA_3_O,
      CTL => AA_3_ENABLE,
      O => AA(3)
    );
  AA_3_ENABLEINV : X_INV_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => GTS,
      O => AA_3_ENABLE
    );
  LED_6_OBUF : X_TRI_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => LED_6_O,
      CTL => LED_6_ENABLE,
      O => LED(6)
    );
  LED_6_ENABLEINV : X_INV_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => GTS,
      O => LED_6_ENABLE
    );
  AA_4_OBUF : X_TRI_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => AA_4_O,
      CTL => AA_4_ENABLE,
      O => AA(4)
    );
  AA_4_ENABLEINV : X_INV_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => GTS,
      O => AA_4_ENABLE
    );
  LED_7_OBUF : X_TRI_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => LED_7_O,
      CTL => LED_7_ENABLE,
      O => LED(7)
    );
  LED_7_ENABLEINV : X_INV_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => GTS,
      O => LED_7_ENABLE
    );
  AA_5_OBUF : X_TRI_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => AA_5_O,
      CTL => AA_5_ENABLE,
      O => AA(5)
    );
  AA_5_ENABLEINV : X_INV_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => GTS,
      O => AA_5_ENABLE
    );
  AA_6_OBUF : X_TRI_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => AA_6_O,
      CTL => AA_6_ENABLE,
      O => AA(6)
    );
  AA_6_ENABLEINV : X_INV_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => GTS,
      O => AA_6_ENABLE
    );
  CEA2X_OBUF : X_TRI_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => CEA2X_O,
      CTL => CEA2X_ENABLE,
      O => CEA2X
    );
  CEA2X_ENABLEINV : X_INV_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => GTS,
      O => CEA2X_ENABLE
    );
  AA_7_OBUF : X_TRI_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => AA_7_O,
      CTL => AA_7_ENABLE,
      O => AA(7)
    );
  AA_7_ENABLEINV : X_INV_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => GTS,
      O => AA_7_ENABLE
    );
  AA_8_OBUF : X_TRI_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => AA_8_O,
      CTL => AA_8_ENABLE,
      O => AA(8)
    );
  AA_8_ENABLEINV : X_INV_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => GTS,
      O => AA_8_ENABLE
    );
  AA_9_OBUF : X_TRI_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => AA_9_O,
      CTL => AA_9_ENABLE,
      O => AA(9)
    );
  AA_9_ENABLEINV : X_INV_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => GTS,
      O => AA_9_ENABLE
    );
  XRWA_OBUF : X_TRI_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => XRWA_O,
      CTL => XRWA_ENABLE,
      O => XRWA
    );
  XRWA_ENABLEINV : X_INV_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => GTS,
      O => XRWA_ENABLE
    );
  CELA1X_OBUF : X_TRI_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => CELA1X_O,
      CTL => CELA1X_ENABLE,
      O => CELA1X
    );
  CELA1X_ENABLEINV : X_INV_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => GTS,
      O => CELA1X_ENABLE
    );
  CEA_OBUF : X_TRI_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => CEA_O,
      CTL => CEA_ENABLE,
      O => CEA
    );
  CEA_ENABLEINV : X_INV_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => GTS,
      O => CEA_ENABLE
    );
  IOA_0_IBUF_166 : X_BUF_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => IOA(0),
      O => IOA_0_INBUF
    );
  IOA_0_IFF_IMUX : X_BUF_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => IOA_0_INBUF,
      O => IOA_0_IBUF
    );
  IOA_1_IBUF_167 : X_BUF_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => IOA(1),
      O => IOA_1_INBUF
    );
  IOA_1_IFF_IMUX : X_BUF_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => IOA_1_INBUF,
      O => IOA_1_IBUF
    );
  USBRDX_OBUF : X_TRI_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => USBRDX_O,
      CTL => USBRDX_ENABLE,
      O => USBRDX
    );
  USBRDX_ENABLEINV : X_INV_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => GTS,
      O => USBRDX_ENABLE
    );
  IOA_2_IFF_IMUX : X_BUF_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => IOA_2_INBUF,
      O => IOA_2_IBUF
    );
  IOA_2_IBUF_168 : X_BUF_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => IOA(2),
      O => IOA_2_INBUF
    );
  IOA_29_IBUF_169 : X_BUF_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => IOA(29),
      O => IOA_29_INBUF
    );
  IOA_29_IFF_IMUX : X_BUF_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => IOA_29_INBUF,
      O => IOA_29_IBUF
    );
  IOPA_1_IBUF_170 : X_BUF_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => IOPA(1),
      O => IOPA_1_INBUF
    );
  IOPA_1_IFF_IMUX : X_BUF_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => IOPA_1_INBUF,
      O => IOPA_1_IBUF
    );
  USBD_7_IBUF_171 : X_BUF_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => USBD(7),
      O => USBD_7_INBUF
    );
  USBD_7_IFF_IMUX : X_BUF_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => USBD_7_INBUF,
      O => USBD_7_IBUF
    );
  IOPA_2_IBUF_172 : X_BUF_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => IOPA(2),
      O => IOPA_2_INBUF
    );
  IOPA_2_IFF_IMUX : X_BUF_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => IOPA_2_INBUF,
      O => IOPA_2_IBUF
    );
  IOPA_3_IBUF_173 : X_BUF_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => IOPA(3),
      O => IOPA_3_INBUF
    );
  IOPA_3_IFF_IMUX : X_BUF_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => IOPA_3_INBUF,
      O => IOPA_3_IBUF
    );
  AA_10_OBUF : X_TRI_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => AA_10_O,
      CTL => AA_10_ENABLE,
      O => AA(10)
    );
  AA_10_ENABLEINV : X_INV_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => GTS,
      O => AA_10_ENABLE
    );
  OEAX_OBUF : X_TRI_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => OEAX_O,
      CTL => OEAX_ENABLE,
      O => OEAX
    );
  OEAX_ENABLEINV : X_INV_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => GTS,
      O => OEAX_ENABLE
    );
  AA_11_OBUF : X_TRI_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => AA_11_O,
      CTL => AA_11_ENABLE,
      O => AA(11)
    );
  AA_11_ENABLEINV : X_INV_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => GTS,
      O => AA_11_ENABLE
    );
  ADVLDA_OBUF : X_TRI_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => ADVLDA_O,
      CTL => ADVLDA_ENABLE,
      O => ADVLDA
    );
  ADVLDA_ENABLEINV : X_INV_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => GTS,
      O => ADVLDA_ENABLE
    );
  AA_12_OBUF : X_TRI_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => AA_12_O,
      CTL => AA_12_ENABLE,
      O => AA(12)
    );
  AA_12_ENABLEINV : X_INV_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => GTS,
      O => AA_12_ENABLE
    );
  USBWR_OBUF : X_TRI_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => USBWR_O,
      CTL => USBWR_ENABLE,
      O => USBWR
    );
  USBWR_ENABLEINV : X_INV_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => GTS,
      O => USBWR_ENABLE
    );
  AA_13_OBUF : X_TRI_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => AA_13_O,
      CTL => AA_13_ENABLE,
      O => AA(13)
    );
  AA_13_ENABLEINV : X_INV_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => GTS,
      O => AA_13_ENABLE
    );
  AA_14_OBUF : X_TRI_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => AA_14_O,
      CTL => AA_14_ENABLE,
      O => AA(14)
    );
  AA_14_ENABLEINV : X_INV_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => GTS,
      O => AA_14_ENABLE
    );
  AA_15_OBUF : X_TRI_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => AA_15_O,
      CTL => AA_15_ENABLE,
      O => AA(15)
    );
  AA_15_ENABLEINV : X_INV_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => GTS,
      O => AA_15_ENABLE
    );
  AA_16_OBUF : X_TRI_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => AA_16_O,
      CTL => AA_16_ENABLE,
      O => AA(16)
    );
  AA_16_ENABLEINV : X_INV_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => GTS,
      O => AA_16_ENABLE
    );
  CEHA1X_OBUF : X_TRI_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => CEHA1X_O,
      CTL => CEHA1X_ENABLE,
      O => CEHA1X
    );
  CEHA1X_ENABLEINV : X_INV_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => GTS,
      O => CEHA1X_ENABLE
    );
  AA_17_OBUF : X_TRI_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => AA_17_O,
      CTL => AA_17_ENABLE,
      O => AA(17)
    );
  AA_17_ENABLEINV : X_INV_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => GTS,
      O => AA_17_ENABLE
    );
  AA_18_OBUF : X_TRI_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => AA_18_O,
      CTL => AA_18_ENABLE,
      O => AA(18)
    );
  AA_18_ENABLEINV : X_INV_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => GTS,
      O => AA_18_ENABLE
    );
  AA_19_OBUF : X_TRI_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => AA_19_O,
      CTL => AA_19_ENABLE,
      O => AA(19)
    );
  AA_19_ENABLEINV : X_INV_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => GTS,
      O => AA_19_ENABLE
    );
  LED_0_OBUF : X_TRI_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => LED_0_O,
      CTL => LED_0_ENABLE,
      O => LED(0)
    );
  LED_0_ENABLEINV : X_INV_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => GTS,
      O => LED_0_ENABLE
    );
  LED_1_OBUF : X_TRI_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => LED_1_O,
      CTL => LED_1_ENABLE,
      O => LED(1)
    );
  LED_1_ENABLEINV : X_INV_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => GTS,
      O => LED_1_ENABLE
    );
  LED_2_OBUF : X_TRI_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => LED_2_O,
      CTL => LED_2_ENABLE,
      O => LED(2)
    );
  LED_2_ENABLEINV : X_INV_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => GTS,
      O => LED_2_ENABLE
    );
  R_2_DXMUX_174 : X_BUF_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => R_2_XORF,
      O => R_2_DXMUX
    );
  R_2_XORF_175 : X_XOR2
    port map (
      I0 => R_2_CYINIT,
      I1 => cpu_R_n0000_2_lut_O,
      O => R_2_XORF
    );
  R_2_CYMUXF2_176 : X_MUX2
    port map (
      IA => R_2_CY0F,
      IB => R_2_CY0F,
      SEL => R_2_CYSELF,
      O => R_2_CYMUXF2
    );
  R_2_CYMUXF : X_MUX2
    port map (
      IA => R_2_CY0F,
      IB => R_2_CYINIT,
      SEL => R_2_CYSELF,
      O => cpu_R_n0000_2_cyo
    );
  R_2_CYINIT_177 : X_BUF_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => cpu_R_n0000_1_cyo,
      O => R_2_CYINIT
    );
  R_2_CY0F_178 : X_BUF_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => R(2),
      O => R_2_CY0F
    );
  R_2_CYSELF_179 : X_BUF_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => cpu_R_n0000_2_lut_O,
      O => R_2_CYSELF
    );
  R_2_DYMUX_180 : X_BUF_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => R_2_XORG,
      O => R_2_DYMUX
    );
  R_2_XORG_181 : X_XOR2
    port map (
      I0 => cpu_R_n0000_2_cyo,
      I1 => cpu_R_n0000_3_lut_O,
      O => R_2_XORG
    );
  R_2_COUTUSED : X_BUF_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => R_2_CYMUXFAST,
      O => cpu_R_n0000_3_cyo
    );
  R_2_FASTCARRY_182 : X_BUF_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => cpu_R_n0000_1_cyo,
      O => R_2_FASTCARRY
    );
  R_2_CYAND_183 : X_AND2
    port map (
      I0 => R_2_CYSELG,
      I1 => R_2_CYSELF,
      O => R_2_CYAND
    );
  R_2_CYMUXFAST_184 : X_MUX2
    port map (
      IA => R_2_CYMUXG2,
      IB => R_2_FASTCARRY,
      SEL => R_2_CYAND,
      O => R_2_CYMUXFAST
    );
  R_2_CYMUXG2_185 : X_MUX2
    port map (
      IA => R_2_CY0G,
      IB => R_2_CYMUXF2,
      SEL => R_2_CYSELG,
      O => R_2_CYMUXG2
    );
  R_2_CY0G_186 : X_BUF_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => R(3),
      O => R_2_CY0G
    );
  R_2_CYSELG_187 : X_BUF_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => cpu_R_n0000_3_lut_O,
      O => R_2_CYSELG
    );
  R_2_CLKINV_188 : X_BUF_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => BCLK,
      O => R_2_CLKINV
    );
  R_2_CEINV_189 : X_BUF_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => Q_n0002_0,
      O => R_2_CEINV
    );
  cpu_R_n0000_3_lut : X_LUT4
    generic map(
      INIT => X"6666"
    )
    port map (
      ADR0 => R(3),
      ADR1 => IOA_3_IBUF,
      ADR2 => VCC,
      ADR3 => VCC,
      O => cpu_R_n0000_3_lut_O
    );
  R_4_DXMUX_190 : X_BUF_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => R_4_XORF,
      O => R_4_DXMUX
    );
  R_4_XORF_191 : X_XOR2
    port map (
      I0 => R_4_CYINIT,
      I1 => cpu_R_n0000_4_lut_O,
      O => R_4_XORF
    );
  R_4_CYMUXF2_192 : X_MUX2
    port map (
      IA => R_4_CY0F,
      IB => R_4_CY0F,
      SEL => R_4_CYSELF,
      O => R_4_CYMUXF2
    );
  R_4_CYMUXF : X_MUX2
    port map (
      IA => R_4_CY0F,
      IB => R_4_CYINIT,
      SEL => R_4_CYSELF,
      O => cpu_R_n0000_4_cyo
    );
  R_4_CYINIT_193 : X_BUF_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => cpu_R_n0000_3_cyo,
      O => R_4_CYINIT
    );
  R_4_CY0F_194 : X_BUF_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => R(4),
      O => R_4_CY0F
    );
  R_4_CYSELF_195 : X_BUF_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => cpu_R_n0000_4_lut_O,
      O => R_4_CYSELF
    );
  R_4_DYMUX_196 : X_BUF_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => R_4_XORG,
      O => R_4_DYMUX
    );
  R_4_XORG_197 : X_XOR2
    port map (
      I0 => cpu_R_n0000_4_cyo,
      I1 => cpu_R_n0000_5_lut_O,
      O => R_4_XORG
    );
  R_4_FASTCARRY_198 : X_BUF_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => cpu_R_n0000_3_cyo,
      O => R_4_FASTCARRY
    );
  R_4_CYAND_199 : X_AND2
    port map (
      I0 => R_4_CYSELG,
      I1 => R_4_CYSELF,
      O => R_4_CYAND
    );
  R_4_CYMUXFAST_200 : X_MUX2
    port map (
      IA => R_4_CYMUXG2,
      IB => R_4_FASTCARRY,
      SEL => R_4_CYAND,
      O => R_4_CYMUXFAST
    );
  R_4_CYMUXG2_201 : X_MUX2
    port map (
      IA => R_4_CY0G,
      IB => R_4_CYMUXF2,
      SEL => R_4_CYSELG,
      O => R_4_CYMUXG2
    );
  R_4_CY0G_202 : X_BUF_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => R(5),
      O => R_4_CY0G
    );
  R_4_CYSELG_203 : X_BUF_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => cpu_R_n0000_5_lut_O,
      O => R_4_CYSELG
    );
  R_4_CLKINV_204 : X_BUF_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => BCLK,
      O => R_4_CLKINV
    );
  R_4_CEINV_205 : X_BUF_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => Q_n0002_0,
      O => R_4_CEINV
    );
  cpu_R_n0000_5_lut : X_LUT4
    generic map(
      INIT => X"6666"
    )
    port map (
      ADR0 => R(5),
      ADR1 => IOA_5_IBUF,
      ADR2 => VCC,
      ADR3 => VCC,
      O => cpu_R_n0000_5_lut_O
    );
  R_6_DXMUX_206 : X_BUF_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => R_6_XORF,
      O => R_6_DXMUX
    );
  R_6_XORF_207 : X_XOR2
    port map (
      I0 => R_6_CYINIT,
      I1 => cpu_R_n0000_6_lut_O,
      O => R_6_XORF
    );
  R_6_CYMUXF : X_MUX2
    port map (
      IA => R_6_CY0F,
      IB => R_6_CYINIT,
      SEL => R_6_CYSELF,
      O => cpu_R_n0000_6_cyo
    );
  R_6_CYINIT_208 : X_BUF_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => R_4_CYMUXFAST,
      O => R_6_CYINIT
    );
  R_6_CY0F_209 : X_BUF_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => R(6),
      O => R_6_CY0F
    );
  R_6_CYSELF_210 : X_BUF_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => cpu_R_n0000_6_lut_O,
      O => R_6_CYSELF
    );
  R_6_DYMUX_211 : X_BUF_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => R_6_XORG,
      O => R_6_DYMUX
    );
  R_6_XORG_212 : X_XOR2
    port map (
      I0 => cpu_R_n0000_6_cyo,
      I1 => cpu_R_n0000_7_lut_O,
      O => R_6_XORG
    );
  R_6_CLKINV_213 : X_BUF_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => BCLK,
      O => R_6_CLKINV
    );
  R_6_CEINV_214 : X_BUF_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => Q_n0002_0,
      O => R_6_CEINV
    );
  cpu_R_n0000_7_lut : X_LUT4
    generic map(
      INIT => X"6666"
    )
    port map (
      ADR0 => R(7),
      ADR1 => IOA_7_IBUF,
      ADR2 => VCC,
      ADR3 => VCC,
      O => cpu_R_n0000_7_lut_O
    );
  USBD_3_IBUF_215 : X_BUF_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => USBD(3),
      O => USBD_3_INBUF
    );
  USBD_3_IFF_IMUX : X_BUF_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => USBD_3_INBUF,
      O => USBD_3_IBUF
    );
  IOA_26_IBUF_216 : X_BUF_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => IOA(26),
      O => IOA_26_INBUF
    );
  IOA_26_IFF_IMUX : X_BUF_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => IOA_26_INBUF,
      O => IOA_26_IBUF
    );
  IOA_18_IBUF_217 : X_BUF_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => IOA(18),
      O => IOA_18_INBUF
    );
  IOA_18_IFF_IMUX : X_BUF_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => IOA_18_INBUF,
      O => IOA_18_IBUF
    );
  USBD_4_IBUF_218 : X_BUF_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => USBD(4),
      O => USBD_4_INBUF
    );
  USBD_4_IFF_IMUX : X_BUF_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => USBD_4_INBUF,
      O => USBD_4_IBUF
    );
  CLKMA0_OBUF : X_TRI_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => CLKMA0_O,
      CTL => CLKMA0_ENABLE,
      O => CLKMA0
    );
  CLKMA0_ENABLEINV : X_INV_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => GTS,
      O => CLKMA0_ENABLE
    );
  IOA_27_IBUF_219 : X_BUF_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => IOA(27),
      O => IOA_27_INBUF
    );
  IOA_27_IFF_IMUX : X_BUF_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => IOA_27_INBUF,
      O => IOA_27_IBUF
    );
  IOA_19_IBUF_220 : X_BUF_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => IOA(19),
      O => IOA_19_INBUF
    );
  IOA_19_IFF_IMUX : X_BUF_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => IOA_19_INBUF,
      O => IOA_19_IBUF
    );
  CLKMA1_OBUF : X_TRI_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => CLKMA1_O,
      CTL => CLKMA1_ENABLE,
      O => CLKMA1
    );
  CLKMA1_ENABLEINV : X_INV_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => GTS,
      O => CLKMA1_ENABLE
    );
  USBD_5_IBUF_221 : X_BUF_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => USBD(5),
      O => USBD_5_INBUF
    );
  USBD_5_IFF_IMUX : X_BUF_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => USBD_5_INBUF,
      O => USBD_5_IBUF
    );
  IOA_28_IBUF_222 : X_BUF_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => IOA(28),
      O => IOA_28_INBUF
    );
  IOA_28_IFF_IMUX : X_BUF_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => IOA_28_INBUF,
      O => IOA_28_IBUF
    );
  IOPA_0_IBUF_223 : X_BUF_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => IOPA(0),
      O => IOPA_0_INBUF
    );
  IOPA_0_IFF_IMUX : X_BUF_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => IOPA_0_INBUF,
      O => IOPA_0_IBUF
    );
  USBD_6_IFF_IMUX : X_BUF_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => USBD_6_INBUF,
      O => USBD_6_IBUF
    );
  USBD_6_IBUF_224 : X_BUF_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => USBD(6),
      O => USBD_6_INBUF
    );
  IOA_22_IBUF_225 : X_BUF_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => IOA(22),
      O => IOA_22_INBUF
    );
  IOA_22_IFF_IMUX : X_BUF_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => IOA_22_INBUF,
      O => IOA_22_IBUF
    );
  IOA_14_IBUF_226 : X_BUF_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => IOA(14),
      O => IOA_14_INBUF
    );
  IOA_14_IFF_IMUX : X_BUF_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => IOA_14_INBUF,
      O => IOA_14_IBUF
    );
  USBRSTX_OBUF : X_TRI_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => USBRSTX_O,
      CTL => USBRSTX_ENABLE,
      O => USBRSTX
    );
  USBRSTX_ENABLEINV : X_INV_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => GTS,
      O => USBRSTX_ENABLE
    );
  USBD_0_IBUF_227 : X_BUF_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => USBD(0),
      O => USBD_0_INBUF
    );
  USBD_0_IFF_IMUX : X_BUF_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => USBD_0_INBUF,
      O => USBD_0_IBUF
    );
  IOA_31_IBUF_228 : X_BUF_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => IOA(31),
      O => IOA_31_INBUF
    );
  IOA_31_IFF_IMUX : X_BUF_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => IOA_31_INBUF,
      O => IOA_31_IBUF
    );
  IOA_23_IBUF_229 : X_BUF_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => IOA(23),
      O => IOA_23_INBUF
    );
  IOA_23_IFF_IMUX : X_BUF_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => IOA_23_INBUF,
      O => IOA_23_IBUF
    );
  IOA_15_IBUF_230 : X_BUF_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => IOA(15),
      O => IOA_15_INBUF
    );
  IOA_15_IFF_IMUX : X_BUF_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => IOA_15_INBUF,
      O => IOA_15_IBUF
    );
  USBD_1_IBUF_231 : X_BUF_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => USBD(1),
      O => USBD_1_INBUF
    );
  USBD_1_IFF_IMUX : X_BUF_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => USBD_1_INBUF,
      O => USBD_1_IBUF
    );
  IOA_24_IBUF_232 : X_BUF_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => IOA(24),
      O => IOA_24_INBUF
    );
  IOA_24_IFF_IMUX : X_BUF_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => IOA_24_INBUF,
      O => IOA_24_IBUF
    );
  IOA_16_IBUF_233 : X_BUF_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => IOA(16),
      O => IOA_16_INBUF
    );
  IOA_16_IFF_IMUX : X_BUF_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => IOA_16_INBUF,
      O => IOA_16_IBUF
    );
  USBD_2_IBUF_234 : X_BUF_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => USBD(2),
      O => USBD_2_INBUF
    );
  USBD_2_IFF_IMUX : X_BUF_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => USBD_2_INBUF,
      O => USBD_2_IBUF
    );
  IOA_25_IBUF_235 : X_BUF_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => IOA(25),
      O => IOA_25_INBUF
    );
  IOA_25_IFF_IMUX : X_BUF_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => IOA_25_INBUF,
      O => IOA_25_IBUF
    );
  A_inst_lut3_191 : X_LUT4
    generic map(
      INIT => X"CDC8"
    )
    port map (
      ADR0 => IOA_20_IBUF,
      ADR1 => A(19),
      ADR2 => N22_0,
      ADR3 => IOA_19_IBUF,
      O => A_inst_lut3_191_O
    );
  A_0 : X_FF
    generic map(
      INIT => '0'
    )
    port map (
      I => A_0_DYMUX,
      CE => VCC,
      CLK => A_0_CLKINV,
      SET => GND,
      RST => A_0_FFY_RST,
      O => A(0)
    );
  A_0_FFY_RSTOR : X_BUF_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => GSR,
      O => A_0_FFY_RST
    );
  A_inst_lut3_21 : X_LUT4
    generic map(
      INIT => X"F0E2"
    )
    port map (
      ADR0 => IOA_2_IBUF,
      ADR1 => N22_0,
      ADR2 => A(2),
      ADR3 => IOA_20_IBUF,
      O => A_inst_lut3_21_O
    );
  R_7 : X_FF
    generic map(
      INIT => '0'
    )
    port map (
      I => R_6_DYMUX,
      CE => R_6_CEINV,
      CLK => R_6_CLKINV,
      SET => GND,
      RST => R_6_FFY_RST,
      O => R(7)
    );
  R_6_FFY_RSTOR : X_BUF_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => GSR,
      O => R_6_FFY_RST
    );
  cpu_R_n0000_1_lut : X_LUT4
    generic map(
      INIT => X"6666"
    )
    port map (
      ADR0 => R(1),
      ADR1 => IOA_1_IBUF,
      ADR2 => VCC,
      ADR3 => VCC,
      O => cpu_R_n0000_1_lut_O
    );
  A_19 : X_FF
    generic map(
      INIT => '0'
    )
    port map (
      I => A_19_DXMUX,
      CE => VCC,
      CLK => A_19_CLKINV,
      SET => GND,
      RST => A_19_FFX_RST,
      O => A(19)
    );
  A_19_FFX_RSTOR : X_BUF_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => GSR,
      O => A_19_FFX_RST
    );
  Q_n0002219 : X_LUT4
    generic map(
      INIT => X"EEEE"
    )
    port map (
      ADR0 => CHOICE45_0,
      ADR1 => CHOICE51,
      ADR2 => VCC,
      ADR3 => VCC,
      O => N22
    );
  Q_n000511 : X_LUT4
    generic map(
      INIT => X"FEFE"
    )
    port map (
      ADR0 => IOA_20_IBUF,
      ADR1 => CHOICE45_0,
      ADR2 => CHOICE51,
      ADR3 => VCC,
      O => Q_n0005
    );
  R_4 : X_FF
    generic map(
      INIT => '0'
    )
    port map (
      I => R_4_DXMUX,
      CE => R_4_CEINV,
      CLK => R_4_CLKINV,
      SET => GND,
      RST => R_4_FFX_RST,
      O => R(4)
    );
  R_4_FFX_RSTOR : X_BUF_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => GSR,
      O => R_4_FFX_RST
    );
  cpu_R_n0000_6_lut : X_LUT4
    generic map(
      INIT => X"6666"
    )
    port map (
      ADR0 => R(6),
      ADR1 => IOA_6_IBUF,
      ADR2 => VCC,
      ADR3 => VCC,
      O => cpu_R_n0000_6_lut_O
    );
  R_6 : X_FF
    generic map(
      INIT => '0'
    )
    port map (
      I => R_6_DXMUX,
      CE => R_6_CEINV,
      CLK => R_6_CLKINV,
      SET => GND,
      RST => R_6_FFX_RST,
      O => R(6)
    );
  R_6_FFX_RSTOR : X_BUF_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => GSR,
      O => R_6_FFX_RST
    );
  A_2 : X_FF
    generic map(
      INIT => '0'
    )
    port map (
      I => A_1_DYMUX,
      CE => VCC,
      CLK => A_1_CLKINV,
      SET => GND,
      RST => A_1_FFY_RST,
      O => A(2)
    );
  A_1_FFY_RSTOR : X_BUF_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => GSR,
      O => A_1_FFY_RST
    );
  A_inst_lut3_110 : X_LUT4
    generic map(
      INIT => X"F0E2"
    )
    port map (
      ADR0 => IOA_1_IBUF,
      ADR1 => N22_0,
      ADR2 => A(1),
      ADR3 => IOA_20_IBUF,
      O => A_inst_lut3_110_O
    );
  A_1 : X_FF
    generic map(
      INIT => '0'
    )
    port map (
      I => A_1_DXMUX,
      CE => VCC,
      CLK => A_1_CLKINV,
      SET => GND,
      RST => A_1_FFX_RST,
      O => A(1)
    );
  A_1_FFX_RSTOR : X_BUF_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => GSR,
      O => A_1_FFX_RST
    );
  A_4 : X_FF
    generic map(
      INIT => '0'
    )
    port map (
      I => A_3_DYMUX,
      CE => VCC,
      CLK => A_3_CLKINV,
      SET => GND,
      RST => A_3_FFY_RST,
      O => A(4)
    );
  A_3_FFY_RSTOR : X_BUF_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => GSR,
      O => A_3_FFY_RST
    );
  A_inst_lut3_31 : X_LUT4
    generic map(
      INIT => X"F0E2"
    )
    port map (
      ADR0 => IOA_3_IBUF,
      ADR1 => N22_0,
      ADR2 => A(3),
      ADR3 => IOA_20_IBUF,
      O => A_inst_lut3_31_O
    );
  A_3 : X_FF
    generic map(
      INIT => '0'
    )
    port map (
      I => A_3_DXMUX,
      CE => VCC,
      CLK => A_3_CLKINV,
      SET => GND,
      RST => A_3_FFX_RST,
      O => A(3)
    );
  A_3_FFX_RSTOR : X_BUF_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => GSR,
      O => A_3_FFX_RST
    );
  A_6 : X_FF
    generic map(
      INIT => '0'
    )
    port map (
      I => A_5_DYMUX,
      CE => VCC,
      CLK => A_5_CLKINV,
      SET => GND,
      RST => A_5_FFY_RST,
      O => A(6)
    );
  A_5_FFY_RSTOR : X_BUF_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => GSR,
      O => A_5_FFY_RST
    );
  A_inst_lut3_51 : X_LUT4
    generic map(
      INIT => X"F0E2"
    )
    port map (
      ADR0 => IOA_5_IBUF,
      ADR1 => N22_0,
      ADR2 => A(5),
      ADR3 => IOA_20_IBUF,
      O => A_inst_lut3_51_O
    );
  A_5 : X_FF
    generic map(
      INIT => '0'
    )
    port map (
      I => A_5_DXMUX,
      CE => VCC,
      CLK => A_5_CLKINV,
      SET => GND,
      RST => A_5_FFX_RST,
      O => A(5)
    );
  A_5_FFX_RSTOR : X_BUF_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => GSR,
      O => A_5_FFX_RST
    );
  A_8 : X_FF
    generic map(
      INIT => '0'
    )
    port map (
      I => A_7_DYMUX,
      CE => VCC,
      CLK => A_7_CLKINV,
      SET => GND,
      RST => A_7_FFY_RST,
      O => A(8)
    );
  A_7_FFY_RSTOR : X_BUF_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => GSR,
      O => A_7_FFY_RST
    );
  A_inst_lut3_71 : X_LUT4
    generic map(
      INIT => X"F0E2"
    )
    port map (
      ADR0 => IOA_7_IBUF,
      ADR1 => N22_0,
      ADR2 => A(7),
      ADR3 => IOA_20_IBUF,
      O => A_inst_lut3_71_O
    );
  A_7 : X_FF
    generic map(
      INIT => '0'
    )
    port map (
      I => A_7_DXMUX,
      CE => VCC,
      CLK => A_7_CLKINV,
      SET => GND,
      RST => A_7_FFX_RST,
      O => A(7)
    );
  A_7_FFX_RSTOR : X_BUF_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => GSR,
      O => A_7_FFX_RST
    );
  A_10 : X_FF
    generic map(
      INIT => '0'
    )
    port map (
      I => A_9_DYMUX,
      CE => VCC,
      CLK => A_9_CLKINV,
      SET => GND,
      RST => A_9_FFY_RST,
      O => A(10)
    );
  A_9_FFY_RSTOR : X_BUF_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => GSR,
      O => A_9_FFY_RST
    );
  A_inst_lut3_91 : X_LUT4
    generic map(
      INIT => X"F0E2"
    )
    port map (
      ADR0 => IOA_9_IBUF,
      ADR1 => N22_0,
      ADR2 => A(9),
      ADR3 => IOA_20_IBUF,
      O => A_inst_lut3_91_O
    );
  A_9 : X_FF
    generic map(
      INIT => '0'
    )
    port map (
      I => A_9_DXMUX,
      CE => VCC,
      CLK => A_9_CLKINV,
      SET => GND,
      RST => A_9_FFX_RST,
      O => A(9)
    );
  A_9_FFX_RSTOR : X_BUF_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => GSR,
      O => A_9_FFX_RST
    );
  A_12 : X_FF
    generic map(
      INIT => '0'
    )
    port map (
      I => A_11_DYMUX,
      CE => VCC,
      CLK => A_11_CLKINV,
      SET => GND,
      RST => A_11_FFY_RST,
      O => A(12)
    );
  A_11_FFY_RSTOR : X_BUF_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => GSR,
      O => A_11_FFY_RST
    );
  A_inst_lut3_111 : X_LUT4
    generic map(
      INIT => X"F0E2"
    )
    port map (
      ADR0 => IOA_11_IBUF,
      ADR1 => N22_0,
      ADR2 => A(11),
      ADR3 => IOA_20_IBUF,
      O => A_inst_lut3_111_O
    );
  A_11 : X_FF
    generic map(
      INIT => '0'
    )
    port map (
      I => A_11_DXMUX,
      CE => VCC,
      CLK => A_11_CLKINV,
      SET => GND,
      RST => A_11_FFX_RST,
      O => A(11)
    );
  A_11_FFX_RSTOR : X_BUF_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => GSR,
      O => A_11_FFX_RST
    );
  A_14 : X_FF
    generic map(
      INIT => '0'
    )
    port map (
      I => A_13_DYMUX,
      CE => VCC,
      CLK => A_13_CLKINV,
      SET => GND,
      RST => A_13_FFY_RST,
      O => A(14)
    );
  A_13_FFY_RSTOR : X_BUF_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => GSR,
      O => A_13_FFY_RST
    );
  A_inst_lut3_131 : X_LUT4
    generic map(
      INIT => X"F0E2"
    )
    port map (
      ADR0 => IOA_13_IBUF,
      ADR1 => N22_0,
      ADR2 => A(13),
      ADR3 => IOA_20_IBUF,
      O => A_inst_lut3_131_O
    );
  A_13 : X_FF
    generic map(
      INIT => '0'
    )
    port map (
      I => A_13_DXMUX,
      CE => VCC,
      CLK => A_13_CLKINV,
      SET => GND,
      RST => A_13_FFX_RST,
      O => A(13)
    );
  A_13_FFX_RSTOR : X_BUF_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => GSR,
      O => A_13_FFX_RST
    );
  A_16 : X_FF
    generic map(
      INIT => '0'
    )
    port map (
      I => A_15_DYMUX,
      CE => VCC,
      CLK => A_15_CLKINV,
      SET => GND,
      RST => A_15_FFY_RST,
      O => A(16)
    );
  A_15_FFY_RSTOR : X_BUF_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => GSR,
      O => A_15_FFY_RST
    );
  A_inst_lut3_151 : X_LUT4
    generic map(
      INIT => X"F0E2"
    )
    port map (
      ADR0 => IOA_15_IBUF,
      ADR1 => N22_0,
      ADR2 => A(15),
      ADR3 => IOA_20_IBUF,
      O => A_inst_lut3_151_O
    );
  A_15 : X_FF
    generic map(
      INIT => '0'
    )
    port map (
      I => A_15_DXMUX,
      CE => VCC,
      CLK => A_15_CLKINV,
      SET => GND,
      RST => A_15_FFX_RST,
      O => A(15)
    );
  A_15_FFX_RSTOR : X_BUF_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => GSR,
      O => A_15_FFX_RST
    );
  A_18 : X_FF
    generic map(
      INIT => '0'
    )
    port map (
      I => A_17_DYMUX,
      CE => VCC,
      CLK => A_17_CLKINV,
      SET => GND,
      RST => A_17_FFY_RST,
      O => A(18)
    );
  A_17_FFY_RSTOR : X_BUF_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => GSR,
      O => A_17_FFY_RST
    );
  A_inst_lut3_171 : X_LUT4
    generic map(
      INIT => X"F0E2"
    )
    port map (
      ADR0 => IOA_17_IBUF,
      ADR1 => N22_0,
      ADR2 => A(17),
      ADR3 => IOA_20_IBUF,
      O => A_inst_lut3_171_O
    );
  A_17 : X_FF
    generic map(
      INIT => '0'
    )
    port map (
      I => A_17_DXMUX,
      CE => VCC,
      CLK => A_17_CLKINV,
      SET => GND,
      RST => A_17_FFX_RST,
      O => A(17)
    );
  A_17_FFX_RSTOR : X_BUF_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => GSR,
      O => A_17_FFX_RST
    );
  R_1 : X_FF
    generic map(
      INIT => '0'
    )
    port map (
      I => R_0_DYMUX,
      CE => R_0_CEINV,
      CLK => R_0_CLKINV,
      SET => GND,
      RST => R_0_FFY_RST,
      O => R(1)
    );
  R_0_FFY_RSTOR : X_BUF_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => GSR,
      O => R_0_FFY_RST
    );
  cpu_R_n0000_0_lut : X_LUT4
    generic map(
      INIT => X"6666"
    )
    port map (
      ADR0 => R(0),
      ADR1 => IOA_0_IBUF,
      ADR2 => VCC,
      ADR3 => VCC,
      O => cpu_R_n0000_0_lut_O_pack_1
    );
  R_0 : X_FF
    generic map(
      INIT => '0'
    )
    port map (
      I => R_0_DXMUX,
      CE => R_0_CEINV,
      CLK => R_0_CLKINV,
      SET => GND,
      RST => R_0_FFX_RST,
      O => R(0)
    );
  R_0_FFX_RSTOR : X_BUF_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => GSR,
      O => R_0_FFX_RST
    );
  R_3 : X_FF
    generic map(
      INIT => '0'
    )
    port map (
      I => R_2_DYMUX,
      CE => R_2_CEINV,
      CLK => R_2_CLKINV,
      SET => GND,
      RST => R_2_FFY_RST,
      O => R(3)
    );
  R_2_FFY_RSTOR : X_BUF_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => GSR,
      O => R_2_FFY_RST
    );
  cpu_R_n0000_2_lut : X_LUT4
    generic map(
      INIT => X"6666"
    )
    port map (
      ADR0 => R(2),
      ADR1 => IOA_2_IBUF,
      ADR2 => VCC,
      ADR3 => VCC,
      O => cpu_R_n0000_2_lut_O
    );
  R_2 : X_FF
    generic map(
      INIT => '0'
    )
    port map (
      I => R_2_DXMUX,
      CE => R_2_CEINV,
      CLK => R_2_CLKINV,
      SET => GND,
      RST => R_2_FFX_RST,
      O => R(2)
    );
  R_2_FFX_RSTOR : X_BUF_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => GSR,
      O => R_2_FFX_RST
    );
  R_5 : X_FF
    generic map(
      INIT => '0'
    )
    port map (
      I => R_4_DYMUX,
      CE => R_4_CEINV,
      CLK => R_4_CLKINV,
      SET => GND,
      RST => R_4_FFY_RST,
      O => R(5)
    );
  R_4_FFY_RSTOR : X_BUF_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => GSR,
      O => R_4_FFY_RST
    );
  cpu_R_n0000_4_lut : X_LUT4
    generic map(
      INIT => X"6666"
    )
    port map (
      ADR0 => R(4),
      ADR1 => IOA_4_IBUF,
      ADR2 => VCC,
      ADR3 => VCC,
      O => cpu_R_n0000_4_lut_O
    );
  GLOBAL_LOGIC0_GND : X_ZERO
    port map (
      O => GLOBAL_LOGIC0
    );
  GLOBAL_LOGIC1_VCC : X_ONE
    port map (
      O => GLOBAL_LOGIC1
    );
  ZZA_OUTPUT_OFF_OMUX : X_BUF_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => GLOBAL_LOGIC0,
      O => ZZA_O
    );
  BWA_0_OUTPUT_OFF_OMUX : X_BUF_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => GLOBAL_LOGIC1,
      O => BWA_0_O
    );
  BWA_1_OUTPUT_OFF_OMUX : X_BUF_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => GLOBAL_LOGIC1,
      O => BWA_1_O
    );
  BWA_2_OUTPUT_OFF_OMUX : X_BUF_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => GLOBAL_LOGIC1,
      O => BWA_2_O
    );
  CEA2_OUTPUT_OFF_OMUX : X_BUF_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => GLOBAL_LOGIC1,
      O => CEA2_O
    );
  BWA_3_OUTPUT_OFF_OMUX : X_BUF_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => GLOBAL_LOGIC1,
      O => BWA_3_O
    );
  LBOA_OUTPUT_OFF_OMUX : X_BUF_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => GLOBAL_LOGIC1,
      O => LBOA_O
    );
  AA_0_OUTPUT_OFF_OMUX : X_BUF_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => A(0),
      O => AA_0_O
    );
  LED_3_OUTPUT_OFF_OMUX : X_INV_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => R(3),
      O => LED_3_O
    );
  AA_1_OUTPUT_OFF_OMUX : X_BUF_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => A(1),
      O => AA_1_O
    );
  LED_4_OUTPUT_OFF_OMUX : X_INV_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => R(4),
      O => LED_4_O
    );
  AA_2_OUTPUT_OFF_OMUX : X_BUF_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => A(2),
      O => AA_2_O
    );
  LED_5_OUTPUT_OFF_OMUX : X_INV_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => R(5),
      O => LED_5_O
    );
  AA_3_OUTPUT_OFF_OMUX : X_BUF_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => A(3),
      O => AA_3_O
    );
  LED_6_OUTPUT_OFF_OMUX : X_INV_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => R(6),
      O => LED_6_O
    );
  AA_4_OUTPUT_OFF_OMUX : X_BUF_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => A(4),
      O => AA_4_O
    );
  LED_7_OUTPUT_OFF_OMUX : X_INV_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => R(7),
      O => LED_7_O
    );
  AA_5_OUTPUT_OFF_OMUX : X_BUF_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => A(5),
      O => AA_5_O
    );
  AA_6_OUTPUT_OFF_OMUX : X_BUF_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => A(6),
      O => AA_6_O
    );
  CEA2X_OUTPUT_OFF_OMUX : X_BUF_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => GLOBAL_LOGIC0,
      O => CEA2X_O
    );
  AA_7_OUTPUT_OFF_OMUX : X_BUF_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => A(7),
      O => AA_7_O
    );
  AA_8_OUTPUT_OFF_OMUX : X_BUF_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => A(8),
      O => AA_8_O
    );
  AA_9_OUTPUT_OFF_OMUX : X_BUF_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => A(9),
      O => AA_9_O
    );
  XRWA_OUTPUT_OFF_OMUX : X_BUF_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => GLOBAL_LOGIC1,
      O => XRWA_O
    );
  CELA1X_OUTPUT_OFF_OMUX : X_BUF_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => GLOBAL_LOGIC0,
      O => CELA1X_O
    );
  CEA_OUTPUT_OFF_OMUX : X_BUF_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => GLOBAL_LOGIC0,
      O => CEA_O
    );
  USBRDX_OUTPUT_OFF_OMUX : X_BUF_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => GLOBAL_LOGIC1,
      O => USBRDX_O
    );
  AA_10_OUTPUT_OFF_OMUX : X_BUF_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => A(10),
      O => AA_10_O
    );
  OEAX_OUTPUT_OFF_OMUX : X_BUF_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => GLOBAL_LOGIC0,
      O => OEAX_O
    );
  AA_11_OUTPUT_OFF_OMUX : X_BUF_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => A(11),
      O => AA_11_O
    );
  ADVLDA_OUTPUT_OFF_OMUX : X_BUF_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => GLOBAL_LOGIC0,
      O => ADVLDA_O
    );
  AA_12_OUTPUT_OFF_OMUX : X_BUF_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => A(12),
      O => AA_12_O
    );
  USBWR_OUTPUT_OFF_OMUX : X_BUF_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => GLOBAL_LOGIC0,
      O => USBWR_O
    );
  AA_13_OUTPUT_OFF_OMUX : X_BUF_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => A(13),
      O => AA_13_O
    );
  AA_14_OUTPUT_OFF_OMUX : X_BUF_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => A(14),
      O => AA_14_O
    );
  AA_15_OUTPUT_OFF_OMUX : X_BUF_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => A(15),
      O => AA_15_O
    );
  AA_16_OUTPUT_OFF_OMUX : X_BUF_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => A(16),
      O => AA_16_O
    );
  CEHA1X_OUTPUT_OFF_OMUX : X_BUF_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => GLOBAL_LOGIC0,
      O => CEHA1X_O
    );
  AA_17_OUTPUT_OFF_OMUX : X_BUF_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => A(17),
      O => AA_17_O
    );
  AA_18_OUTPUT_OFF_OMUX : X_BUF_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => A(18),
      O => AA_18_O
    );
  AA_19_OUTPUT_OFF_OMUX : X_BUF_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => A(19),
      O => AA_19_O
    );
  LED_0_OUTPUT_OFF_OMUX : X_INV_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => R(0),
      O => LED_0_O
    );
  LED_1_OUTPUT_OFF_OMUX : X_INV_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => R(1),
      O => LED_1_O
    );
  LED_2_OUTPUT_OFF_OMUX : X_INV_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => R(2),
      O => LED_2_O
    );
  CLKMA0_OUTPUT_OFF_OMUX : X_INV_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => BCLK,
      O => CLKMA0_O
    );
  CLKMA1_OUTPUT_OFF_OMUX : X_INV_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => BCLK,
      O => CLKMA1_O
    );
  USBRSTX_OUTPUT_OFF_OMUX : X_BUF_PP
    generic map(
      PATHPULSE => 665 ps
    )
    port map (
      I => GLOBAL_LOGIC1,
      O => USBRSTX_O
    );
  NlwBlock_cpu_GND : X_ZERO
    port map (
      O => GND
    );
  NlwBlock_cpu_VCC : X_ONE
    port map (
      O => VCC
    );
  NlwBlockROC : X_ROC
    generic map (ROC_WIDTH => 100 ns)
    port map (O => GSR);
  NlwBlockTOC : X_TOC
    port map (O => GTS);

end Structure;

