--------------------------------------------------------------------------------
-- Copyright (c) 1995-2005 Xilinx, Inc.  All rights reserved.
--------------------------------------------------------------------------------
--   ____  ____
--  /   /\/   /
-- /___/  \  /    Vendor: Xilinx
-- \   \   \/     Version: H.42
--  \   \         Application: netgen
--  /   /         Filename: cpu_synthesis.vhd
-- /___/   /\     Timestamp: SAT 5 NOV 2:31:50 2005
-- \   \  /  \ 
--  \___\/\___\
--             
-- Command	: -intstyle ise -ar Structure -w -ofmt vhdl -sim cpu.ngc cpu_synthesis.vhd 
-- Device	: xc2v1000-5-ff896
-- Input file	: cpu.ngc
-- Output file	: cpu_synthesis.vhd
-- # of Entities	: 1
-- Design Name	: cpu
-- Xilinx	: C:/Xilinx
--             
-- Purpose:    
--     This VHDL netlist is a verification model and uses simulation 
--     primitives which may not represent the true implementation of the 
--     device, however the netlist is functionally correct and should not 
--     be modified. This file cannot be synthesized and should only be used 
--     with supported simulation tools.
--             
-- Reference:  
--     Development System Reference Guide, Chapter 23
--     Synthesis and Verification Design Guide, Chapter 6
--             
--------------------------------------------------------------------------------

library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
library UNISIM;
use UNISIM.VCOMPONENTS.ALL;

entity cpu is
  port (
    CLK : in STD_LOGIC := 'X'; 
    CEHA1X : out STD_LOGIC; 
    LBOA : out STD_LOGIC; 
    XRWA : out STD_LOGIC; 
    OEAX : out STD_LOGIC; 
    CEA2 : out STD_LOGIC; 
    ADVLDA : out STD_LOGIC; 
    ZZA : out STD_LOGIC; 
    CLKMA0 : out STD_LOGIC; 
    CLKMA1 : out STD_LOGIC; 
    CELA1X : out STD_LOGIC; 
    CEA : out STD_LOGIC; 
    CEA2X : out STD_LOGIC; 
    IOA : inout STD_LOGIC_VECTOR ( 31 downto 0 ); 
    IOPA : inout STD_LOGIC_VECTOR ( 3 downto 0 ); 
    AA : out STD_LOGIC_VECTOR ( 19 downto 0 ); 
    BWA : out STD_LOGIC_VECTOR ( 3 downto 0 ); 
    LED : out STD_LOGIC_VECTOR ( 7 downto 0 ) 
  );
end cpu;

architecture Structure of cpu is
  component ROC
    port (
      O : out STD_LOGIC 
    );
  end component;
  signal IOA_0_IBUF : STD_LOGIC; 
  signal IOA_1_IBUF : STD_LOGIC; 
  signal IOA_2_IBUF : STD_LOGIC; 
  signal IOA_3_IBUF : STD_LOGIC; 
  signal IOA_4_IBUF : STD_LOGIC; 
  signal IOA_10_IBUF : STD_LOGIC; 
  signal IOA_5_IBUF : STD_LOGIC; 
  signal IOA_11_IBUF : STD_LOGIC; 
  signal IOA_6_IBUF : STD_LOGIC; 
  signal IOA_12_IBUF : STD_LOGIC; 
  signal IOA_7_IBUF : STD_LOGIC; 
  signal IOA_13_IBUF : STD_LOGIC; 
  signal IOA_8_IBUF : STD_LOGIC; 
  signal IOA_14_IBUF : STD_LOGIC; 
  signal IOA_9_IBUF : STD_LOGIC; 
  signal IOA_15_IBUF : STD_LOGIC; 
  signal MUX_BLOCK_FNC_1_MUXF56 : STD_LOGIC; 
  signal IOA_16_IBUF : STD_LOGIC; 
  signal IOA_21_IBUF : STD_LOGIC; 
  signal IOA_17_IBUF : STD_LOGIC; 
  signal IOA_22_IBUF : STD_LOGIC; 
  signal IOA_18_IBUF : STD_LOGIC; 
  signal IOA_23_IBUF : STD_LOGIC; 
  signal IOA_19_IBUF : STD_LOGIC; 
  signal IOA_24_IBUF : STD_LOGIC; 
  signal IOA_26_IBUF : STD_LOGIC; 
  signal N35 : STD_LOGIC; 
  signal IOA_27_IBUF : STD_LOGIC; 
  signal MUX_BLOCK_FNC_1_MUXF511 : STD_LOGIC; 
  signal CLK_BUFGP : STD_LOGIC; 
  signal CEA2_OBUF : STD_LOGIC; 
  signal CUR_6_rt : STD_LOGIC; 
  signal CLKMA1_OBUF : STD_LOGIC; 
  signal CUR_8_rt : STD_LOGIC; 
  signal CEA2X_OBUF : STD_LOGIC; 
  signal CHOICE3072 : STD_LOGIC; 
  signal RST : STD_LOGIC; 
  signal Q_n0003 : STD_LOGIC; 
  signal CUR_7_rt : STD_LOGIC; 
  signal CUR_5_rt : STD_LOGIC; 
  signal Q_n0005 : STD_LOGIC; 
  signal MUX_BLOCK_FNC_1_MUXF57 : STD_LOGIC; 
  signal CHOICE2956 : STD_LOGIC; 
  signal CHOICE3141 : STD_LOGIC; 
  signal CUR_9_rt : STD_LOGIC; 
  signal N29 : STD_LOGIC; 
  signal MUX_BLOCK_FNC_1_MUXF55 : STD_LOGIC; 
  signal N1670 : STD_LOGIC; 
  signal MUX_BLOCK_FNC_1_MUXF513 : STD_LOGIC; 
  signal CHOICE3040 : STD_LOGIC; 
  signal CHOICE2978 : STD_LOGIC; 
  signal CHOICE2946 : STD_LOGIC; 
  signal N1587 : STD_LOGIC; 
  signal CHOICE3042 : STD_LOGIC; 
  signal MUX_BLOCK_FNC_1_MUXF54 : STD_LOGIC; 
  signal CHOICE2918 : STD_LOGIC; 
  signal CHOICE2931 : STD_LOGIC; 
  signal CHOICE3027 : STD_LOGIC; 
  signal CHOICE2962 : STD_LOGIC; 
  signal N1576 : STD_LOGIC; 
  signal CHOICE3021 : STD_LOGIC; 
  signal CHOICE3084 : STD_LOGIC; 
  signal CHOICE3119 : STD_LOGIC; 
  signal MUX_BLOCK_FNC_1_MUXF510 : STD_LOGIC; 
  signal CUR_14_rt : STD_LOGIC; 
  signal MUX_BLOCK_FNC_1_MUXF53 : STD_LOGIC; 
  signal CUR_3_rt : STD_LOGIC; 
  signal AA_15_OBUF : STD_LOGIC; 
  signal AA_14_OBUF : STD_LOGIC; 
  signal AA_13_OBUF : STD_LOGIC; 
  signal AA_12_OBUF : STD_LOGIC; 
  signal AA_11_OBUF : STD_LOGIC; 
  signal AA_10_OBUF : STD_LOGIC; 
  signal AA_9_OBUF : STD_LOGIC; 
  signal AA_8_OBUF : STD_LOGIC; 
  signal AA_7_OBUF : STD_LOGIC; 
  signal AA_6_OBUF : STD_LOGIC; 
  signal AA_5_OBUF : STD_LOGIC; 
  signal AA_4_OBUF : STD_LOGIC; 
  signal AA_3_OBUF : STD_LOGIC; 
  signal AA_2_OBUF : STD_LOGIC; 
  signal AA_1_OBUF : STD_LOGIC; 
  signal AA_0_OBUF : STD_LOGIC; 
  signal LED_7_OBUF : STD_LOGIC; 
  signal LED_6_OBUF : STD_LOGIC; 
  signal LED_5_OBUF : STD_LOGIC; 
  signal LED_4_OBUF : STD_LOGIC; 
  signal LED_3_OBUF : STD_LOGIC; 
  signal LED_2_OBUF : STD_LOGIC; 
  signal LED_1_OBUF : STD_LOGIC; 
  signal LED_0_OBUF : STD_LOGIC; 
  signal MUX_BLOCK_FNC_1_MUXF51 : STD_LOGIC; 
  signal MUX_BLOCK_FNC_1_MUXF515 : STD_LOGIC; 
  signal MUX_BLOCK_FNC_1_MUXF514 : STD_LOGIC; 
  signal INS_27_Q : STD_LOGIC; 
  signal INS_26_Q : STD_LOGIC; 
  signal CUR_10_rt : STD_LOGIC; 
  signal INS_24_Q : STD_LOGIC; 
  signal INS_23_Q : STD_LOGIC; 
  signal INS_22_Q : STD_LOGIC; 
  signal INS_21_Q : STD_LOGIC; 
  signal INS_19_Q : STD_LOGIC; 
  signal INS_18_Q : STD_LOGIC; 
  signal INS_17_Q : STD_LOGIC; 
  signal INS_16_Q : STD_LOGIC; 
  signal INS_15_Q : STD_LOGIC; 
  signal INS_14_Q : STD_LOGIC; 
  signal INS_13_Q : STD_LOGIC; 
  signal INS_12_Q : STD_LOGIC; 
  signal INS_11_Q : STD_LOGIC; 
  signal INS_10_Q : STD_LOGIC; 
  signal INS_9_Q : STD_LOGIC; 
  signal INS_8_Q : STD_LOGIC; 
  signal INS_7_Q : STD_LOGIC; 
  signal INS_6_Q : STD_LOGIC; 
  signal CUR_4_rt : STD_LOGIC; 
  signal INS_4_Q : STD_LOGIC; 
  signal CUR_11_rt : STD_LOGIC; 
  signal CUR_12_rt : STD_LOGIC; 
  signal INS_1_Q : STD_LOGIC; 
  signal INS_0_Q : STD_LOGIC; 
  signal N1672 : STD_LOGIC; 
  signal CHOICE3008 : STD_LOGIC; 
  signal CHOICE2900 : STD_LOGIC; 
  signal CHOICE2925 : STD_LOGIC; 
  signal CUR_1_rt : STD_LOGIC; 
  signal CHOICE2912 : STD_LOGIC; 
  signal CHOICE3096 : STD_LOGIC; 
  signal CHOICE3070 : STD_LOGIC; 
  signal N1564 : STD_LOGIC; 
  signal CUR_13_rt : STD_LOGIC; 
  signal CHOICE3053 : STD_LOGIC; 
  signal CHOICE3120 : STD_LOGIC; 
  signal CHOICE2968 : STD_LOGIC; 
  signal CHOICE2890 : STD_LOGIC; 
  signal MUX_BLOCK_FNC_1_MUXF59 : STD_LOGIC; 
  signal MUX_BLOCK_FNC_1_MUXF512 : STD_LOGIC; 
  signal MUX_BLOCK_FNC_1_MUXF5 : STD_LOGIC; 
  signal INS_5_Q : STD_LOGIC; 
  signal INS_3_Q : STD_LOGIC; 
  signal INS_2_Q : STD_LOGIC; 
  signal N1574 : STD_LOGIC; 
  signal CHOICE3135 : STD_LOGIC; 
  signal CHOICE3074 : STD_LOGIC; 
  signal CHOICE3000 : STD_LOGIC; 
  signal CHOICE2888 : STD_LOGIC; 
  signal CHOICE2976 : STD_LOGIC; 
  signal CHOICE3107 : STD_LOGIC; 
  signal CHOICE3105 : STD_LOGIC; 
  signal CHOICE2916 : STD_LOGIC; 
  signal CHOICE3131 : STD_LOGIC; 
  signal CHOICE3092 : STD_LOGIC; 
  signal CHOICE2902 : STD_LOGIC; 
  signal N1572 : STD_LOGIC; 
  signal CHOICE2886 : STD_LOGIC; 
  signal N1596 : STD_LOGIC; 
  signal CHOICE3085 : STD_LOGIC; 
  signal CHOICE2875 : STD_LOGIC; 
  signal N1569 : STD_LOGIC; 
  signal N1570 : STD_LOGIC; 
  signal MUX_BLOCK_FNC_1_MUXF58 : STD_LOGIC; 
  signal CUR_2_rt : STD_LOGIC; 
  signal N4 : STD_LOGIC; 
  signal cpu_n0011_0_cyo : STD_LOGIC; 
  signal cpu_n0011_1_cyo : STD_LOGIC; 
  signal cpu_n0011_2_cyo : STD_LOGIC; 
  signal cpu_n0011_3_cyo : STD_LOGIC; 
  signal cpu_n0011_4_cyo : STD_LOGIC; 
  signal cpu_n0011_5_cyo : STD_LOGIC; 
  signal cpu_n0011_6_cyo : STD_LOGIC; 
  signal cpu_n0011_7_cyo : STD_LOGIC; 
  signal cpu_n0011_8_cyo : STD_LOGIC; 
  signal cpu_n0011_9_cyo : STD_LOGIC; 
  signal cpu_n0011_10_cyo : STD_LOGIC; 
  signal cpu_n0011_11_cyo : STD_LOGIC; 
  signal cpu_n0011_12_cyo : STD_LOGIC; 
  signal cpu_n0011_13_cyo : STD_LOGIC; 
  signal cpu_n0011_14_cyo : STD_LOGIC; 
  signal N87 : STD_LOGIC; 
  signal N5 : STD_LOGIC; 
  signal cpu_n0023_16_cyo : STD_LOGIC; 
  signal N6 : STD_LOGIC; 
  signal cpu_n0023_17_cyo : STD_LOGIC; 
  signal N7 : STD_LOGIC; 
  signal cpu_n0023_18_cyo : STD_LOGIC; 
  signal N8 : STD_LOGIC; 
  signal cpu_n0023_19_cyo : STD_LOGIC; 
  signal N9 : STD_LOGIC; 
  signal cpu_n0023_20_cyo : STD_LOGIC; 
  signal N10 : STD_LOGIC; 
  signal cpu_n0023_21_cyo : STD_LOGIC; 
  signal N11 : STD_LOGIC; 
  signal cpu_n0023_22_cyo : STD_LOGIC; 
  signal N12 : STD_LOGIC; 
  signal cpu_n0023_23_cyo : STD_LOGIC; 
  signal N13 : STD_LOGIC; 
  signal cpu_n0023_24_cyo : STD_LOGIC; 
  signal N14 : STD_LOGIC; 
  signal cpu_n0023_25_cyo : STD_LOGIC; 
  signal N15 : STD_LOGIC; 
  signal cpu_n0023_26_cyo : STD_LOGIC; 
  signal N16 : STD_LOGIC; 
  signal cpu_n0023_27_cyo : STD_LOGIC; 
  signal N17 : STD_LOGIC; 
  signal cpu_n0023_28_cyo : STD_LOGIC; 
  signal N18 : STD_LOGIC; 
  signal cpu_n0023_29_cyo : STD_LOGIC; 
  signal N19 : STD_LOGIC; 
  signal cpu_n0023_30_cyo : STD_LOGIC; 
  signal N20 : STD_LOGIC; 
  signal MUX_BLOCK_FNC_1_MUXF52 : STD_LOGIC; 
  signal N23 : STD_LOGIC; 
  signal N24 : STD_LOGIC; 
  signal N66 : STD_LOGIC; 
  signal N114 : STD_LOGIC; 
  signal N68 : STD_LOGIC; 
  signal N28 : STD_LOGIC; 
  signal N37 : STD_LOGIC; 
  signal CHOICE3063 : STD_LOGIC; 
  signal N67 : STD_LOGIC; 
  signal N115 : STD_LOGIC; 
  signal N90 : STD_LOGIC; 
  signal N161 : STD_LOGIC; 
  signal N171 : STD_LOGIC; 
  signal N181 : STD_LOGIC; 
  signal N33 : STD_LOGIC; 
  signal INS_3_1 : STD_LOGIC; 
  signal N186 : STD_LOGIC; 
  signal N191 : STD_LOGIC; 
  signal N192 : STD_LOGIC; 
  signal N1567 : STD_LOGIC; 
  signal CHOICE2800 : STD_LOGIC; 
  signal N1594 : STD_LOGIC; 
  signal N1566 : STD_LOGIC; 
  signal CHOICE2674 : STD_LOGIC; 
  signal N1592 : STD_LOGIC; 
  signal CHOICE2798 : STD_LOGIC; 
  signal CHOICE2689 : STD_LOGIC; 
  signal CHOICE2826 : STD_LOGIC; 
  signal CHOICE2696 : STD_LOGIC; 
  signal CHOICE2854 : STD_LOGIC; 
  signal CHOICE2775 : STD_LOGIC; 
  signal CHOICE2745 : STD_LOGIC; 
  signal CHOICE2683 : STD_LOGIC; 
  signal CHOICE2720 : STD_LOGIC; 
  signal CHOICE2704 : STD_LOGIC; 
  signal CHOICE2743 : STD_LOGIC; 
  signal CHOICE2784 : STD_LOGIC; 
  signal N1582 : STD_LOGIC; 
  signal CHOICE2718 : STD_LOGIC; 
  signal CHOICE2708 : STD_LOGIC; 
  signal CHOICE2812 : STD_LOGIC; 
  signal CHOICE2858 : STD_LOGIC; 
  signal CHOICE2802 : STD_LOGIC; 
  signal CHOICE2747 : STD_LOGIC; 
  signal CHOICE3059 : STD_LOGIC; 
  signal CHOICE2680 : STD_LOGIC; 
  signal N1586 : STD_LOGIC; 
  signal CHOICE2667 : STD_LOGIC; 
  signal CHOICE2694 : STD_LOGIC; 
  signal CHOICE2935 : STD_LOGIC; 
  signal CHOICE2769 : STD_LOGIC; 
  signal CHOICE2830 : STD_LOGIC; 
  signal N1584 : STD_LOGIC; 
  signal CHOICE2856 : STD_LOGIC; 
  signal CHOICE2716 : STD_LOGIC; 
  signal CHOICE2828 : STD_LOGIC; 
  signal CHOICE2757 : STD_LOGIC; 
  signal CHOICE2839 : STD_LOGIC; 
  signal CHOICE2773 : STD_LOGIC; 
  signal CHOICE2942 : STD_LOGIC; 
  signal CHOICE2972 : STD_LOGIC; 
  signal CHOICE3109 : STD_LOGIC; 
  signal CHOICE3127 : STD_LOGIC; 
  signal CHOICE2994 : STD_LOGIC; 
  signal INS_5_1 : STD_LOGIC; 
  signal CHOICE2944 : STD_LOGIC; 
  signal CHOICE3099 : STD_LOGIC; 
  signal CHOICE3145 : STD_LOGIC; 
  signal N1579 : STD_LOGIC; 
  signal CHOICE3143 : STD_LOGIC; 
  signal CHOICE2908 : STD_LOGIC; 
  signal INS_2_1 : STD_LOGIC; 
  signal INS_3_2 : STD_LOGIC; 
  signal N1710 : STD_LOGIC; 
  signal N1711 : STD_LOGIC; 
  signal N1712 : STD_LOGIC; 
  signal N1713 : STD_LOGIC; 
  signal N1714 : STD_LOGIC; 
  signal N1715 : STD_LOGIC; 
  signal N1716 : STD_LOGIC; 
  signal N1717 : STD_LOGIC; 
  signal N1718 : STD_LOGIC; 
  signal N1719 : STD_LOGIC; 
  signal N1720 : STD_LOGIC; 
  signal N1721 : STD_LOGIC; 
  signal N1722 : STD_LOGIC; 
  signal N1723 : STD_LOGIC; 
  signal N1724 : STD_LOGIC; 
  signal N1725 : STD_LOGIC; 
  signal N1726 : STD_LOGIC; 
  signal N1727 : STD_LOGIC; 
  signal N1728 : STD_LOGIC; 
  signal N1729 : STD_LOGIC; 
  signal N1730 : STD_LOGIC; 
  signal N1731 : STD_LOGIC; 
  signal N1732 : STD_LOGIC; 
  signal N1733 : STD_LOGIC; 
  signal N1734 : STD_LOGIC; 
  signal N1735 : STD_LOGIC; 
  signal N1736 : STD_LOGIC; 
  signal N1737 : STD_LOGIC; 
  signal N1738 : STD_LOGIC; 
  signal N1739 : STD_LOGIC; 
  signal N1740 : STD_LOGIC; 
  signal N1741 : STD_LOGIC; 
  signal N1742 : STD_LOGIC; 
  signal N1743 : STD_LOGIC; 
  signal N1744 : STD_LOGIC; 
  signal N1745 : STD_LOGIC; 
  signal N1746 : STD_LOGIC; 
  signal N1747 : STD_LOGIC; 
  signal N1748 : STD_LOGIC; 
  signal N1749 : STD_LOGIC; 
  signal N1750 : STD_LOGIC; 
  signal N1751 : STD_LOGIC; 
  signal N1752 : STD_LOGIC; 
  signal N1753 : STD_LOGIC; 
  signal N1754 : STD_LOGIC; 
  signal N1755 : STD_LOGIC; 
  signal N1756 : STD_LOGIC; 
  signal N1757 : STD_LOGIC; 
  signal N1758 : STD_LOGIC; 
  signal N1759 : STD_LOGIC; 
  signal N1760 : STD_LOGIC; 
  signal N1761 : STD_LOGIC; 
  signal N1762 : STD_LOGIC; 
  signal N1763 : STD_LOGIC; 
  signal N1764 : STD_LOGIC; 
  signal N1765 : STD_LOGIC; 
  signal N1766 : STD_LOGIC; 
  signal N1767 : STD_LOGIC; 
  signal N1768 : STD_LOGIC; 
  signal N1769 : STD_LOGIC; 
  signal N1770 : STD_LOGIC; 
  signal N1771 : STD_LOGIC; 
  signal N1772 : STD_LOGIC; 
  signal N1773 : STD_LOGIC; 
  signal N1774 : STD_LOGIC; 
  signal N1775 : STD_LOGIC; 
  signal N1776 : STD_LOGIC; 
  signal N1777 : STD_LOGIC; 
  signal N1778 : STD_LOGIC; 
  signal N1779 : STD_LOGIC; 
  signal N1780 : STD_LOGIC; 
  signal N1781 : STD_LOGIC; 
  signal N1782 : STD_LOGIC; 
  signal N1783 : STD_LOGIC; 
  signal N1784 : STD_LOGIC; 
  signal N1785 : STD_LOGIC; 
  signal N1786 : STD_LOGIC; 
  signal N1787 : STD_LOGIC; 
  signal N1788 : STD_LOGIC; 
  signal N1789 : STD_LOGIC; 
  signal N1790 : STD_LOGIC; 
  signal N1791 : STD_LOGIC; 
  signal N1792 : STD_LOGIC; 
  signal N1793 : STD_LOGIC; 
  signal N1794 : STD_LOGIC; 
  signal N1795 : STD_LOGIC; 
  signal N1796 : STD_LOGIC; 
  signal N1797 : STD_LOGIC; 
  signal N1798 : STD_LOGIC; 
  signal N1799 : STD_LOGIC; 
  signal N1800 : STD_LOGIC; 
  signal NLW_Mram_REG_inst_ramx1d_13_SPO_UNCONNECTED : STD_LOGIC; 
  signal NLW_Mram_REG_ren_inst_ramx1d_29_SPO_UNCONNECTED : STD_LOGIC; 
  signal NLW_Mram_REG_ren_inst_ramx1d_22_SPO_UNCONNECTED : STD_LOGIC; 
  signal NLW_Mram_REG_ren_inst_ramx1d_26_SPO_UNCONNECTED : STD_LOGIC; 
  signal NLW_Mram_REG_inst_ramx1d_1_SPO_UNCONNECTED : STD_LOGIC; 
  signal NLW_Mram_REG_inst_ramx1d_5_SPO_UNCONNECTED : STD_LOGIC; 
  signal NLW_Mram_REG_inst_ramx1d_9_SPO_UNCONNECTED : STD_LOGIC; 
  signal NLW_Mram_REG_ren_inst_ramx1d_30_SPO_UNCONNECTED : STD_LOGIC; 
  signal NLW_Mram_REG_ren_inst_ramx1d_18_SPO_UNCONNECTED : STD_LOGIC; 
  signal NLW_Mram_REG_ren_inst_ramx1d_23_SPO_UNCONNECTED : STD_LOGIC; 
  signal NLW_Mram_REG_ren_inst_ramx1d_27_SPO_UNCONNECTED : STD_LOGIC; 
  signal NLW_Mram_REG_inst_ramx1d_14_SPO_UNCONNECTED : STD_LOGIC; 
  signal NLW_Mram_REG_inst_ramx1d_2_SPO_UNCONNECTED : STD_LOGIC; 
  signal NLW_Mram_REG_inst_ramx1d_6_SPO_UNCONNECTED : STD_LOGIC; 
  signal NLW_Mram_REG_inst_ramx1d_10_SPO_UNCONNECTED : STD_LOGIC; 
  signal NLW_Mram_REG_ren_inst_ramx1d_31_SPO_UNCONNECTED : STD_LOGIC; 
  signal NLW_Mram_REG_ren_inst_ramx1d_19_SPO_UNCONNECTED : STD_LOGIC; 
  signal NLW_Mram_REG_ren_inst_ramx1d_28_SPO_UNCONNECTED : STD_LOGIC; 
  signal NLW_Mram_REG_ren_inst_ramx1d_25_SPO_UNCONNECTED : STD_LOGIC; 
  signal NLW_Mram_REG_ren_inst_ramx1d_24_SPO_UNCONNECTED : STD_LOGIC; 
  signal NLW_Mram_REG_ren_inst_ramx1d_21_SPO_UNCONNECTED : STD_LOGIC; 
  signal NLW_Mram_REG_ren_inst_ramx1d_20_SPO_UNCONNECTED : STD_LOGIC; 
  signal NLW_Mram_REG_ren_inst_ramx1d_17_SPO_UNCONNECTED : STD_LOGIC; 
  signal NLW_Mram_REG_ren_inst_ramx1d_16_SPO_UNCONNECTED : STD_LOGIC; 
  signal NLW_Mram_REG_inst_ramx1d_12_SPO_UNCONNECTED : STD_LOGIC; 
  signal NLW_Mram_REG_inst_ramx1d_11_SPO_UNCONNECTED : STD_LOGIC; 
  signal NLW_Mram_REG_inst_ramx1d_8_SPO_UNCONNECTED : STD_LOGIC; 
  signal NLW_Mram_REG_inst_ramx1d_7_SPO_UNCONNECTED : STD_LOGIC; 
  signal NLW_Mram_REG_inst_ramx1d_4_SPO_UNCONNECTED : STD_LOGIC; 
  signal NLW_Mram_REG_inst_ramx1d_3_SPO_UNCONNECTED : STD_LOGIC; 
  signal NLW_Mram_REG_inst_ramx1d_0_SPO_UNCONNECTED : STD_LOGIC; 
  signal NLW_Mram_REG_inst_ramx1d_15_SPO_UNCONNECTED : STD_LOGIC; 
  signal Q_n0023 : STD_LOGIC_VECTOR ( 31 downto 16 ); 
  signal Mshift_n0008_Sh : STD_LOGIC_VECTOR ( 10 downto 1 ); 
  signal CUR : STD_LOGIC_VECTOR ( 15 downto 0 ); 
  signal ACCUM : STD_LOGIC_VECTOR ( 15 downto 0 ); 
  signal LFT : STD_LOGIC_VECTOR ( 15 downto 0 ); 
  signal RGT : STD_LOGIC_VECTOR ( 15 downto 0 ); 
  signal Q_n0011 : STD_LOGIC_VECTOR ( 15 downto 1 ); 
  signal Mshift_n0009_Sh : STD_LOGIC_VECTOR ( 14 downto 5 ); 
begin
  FNC_2_132_G : LUT4_L
    generic map(
      INIT => X"A820"
    )
    port map (
      I0 => RGT(3),
      I1 => RGT(2),
      I2 => N181,
      I3 => N161,
      LO => N1711
    );
  XRWA_OBUF : OBUF
    port map (
      I => CEA2_OBUF,
      O => XRWA
    );
  FNC_1_rn_411 : LUT4
    generic map(
      INIT => X"5668"
    )
    port map (
      I0 => INS_3_Q,
      I1 => INS_2_Q,
      I2 => LFT(13),
      I3 => RGT(13),
      O => MUX_BLOCK_FNC_1_MUXF54
    );
  IOA_26_IBUF_0 : IBUF
    port map (
      I => IOA(26),
      O => IOA_26_IBUF
    );
  IOA_9_IBUF_1 : IBUF
    port map (
      I => IOA(9),
      O => IOA_9_IBUF
    );
  IOA_18_IBUF_2 : IBUF
    port map (
      I => IOA(18),
      O => IOA_18_IBUF
    );
  IOA_16_IBUF_3 : IBUF
    port map (
      I => IOA(16),
      O => IOA_16_IBUF
    );
  CEHA1X_OBUF : OBUF
    port map (
      I => CEA2X_OBUF,
      O => CEHA1X
    );
  IOA_6_IBUF_4 : IBUF
    port map (
      I => IOA(6),
      O => IOA_6_IBUF
    );
  Mshift_n0009_Sh_12_11_G : LUT3_L
    generic map(
      INIT => X"E4"
    )
    port map (
      I0 => RGT(0),
      I1 => LFT(14),
      I2 => LFT(15),
      LO => N1713
    );
  IOA_5_IBUF_5 : IBUF
    port map (
      I => IOA(5),
      O => IOA_5_IBUF
    );
  IOA_8_IBUF_6 : IBUF
    port map (
      I => IOA(8),
      O => IOA_8_IBUF
    );
  CEA2_OBUF_7 : OBUF
    port map (
      I => CEA2_OBUF,
      O => CEA2
    );
  Mshift_n0008_Sh_3_1_G : LUT3_L
    generic map(
      INIT => X"E4"
    )
    port map (
      I0 => RGT(1),
      I1 => LFT(2),
      I2 => LFT(0),
      LO => N1715
    );
  IOA_17_IBUF_8 : IBUF
    port map (
      I => IOA(17),
      O => IOA_17_IBUF
    );
  Q_n00051 : LUT3
    generic map(
      INIT => X"FE"
    )
    port map (
      I0 => INS_5_1,
      I1 => INS_3_1,
      I2 => INS_2_1,
      O => Q_n0005
    );
  Mshift_n0009_Sh_10_11_G : LUT3_L
    generic map(
      INIT => X"E4"
    )
    port map (
      I0 => RGT(0),
      I1 => LFT(12),
      I2 => LFT(13),
      LO => N1717
    );
  XST_GND : GND
    port map (
      G => CEA2X_OBUF
    );
  NXT_1_1 : LUT4
    generic map(
      INIT => X"ABA8"
    )
    port map (
      I0 => INS_1_Q,
      I1 => INS_26_Q,
      I2 => INS_27_Q,
      I3 => Q_n0011(1),
      O => AA_1_OBUF
    );
  FNC_2_11541_G : LUT4_L
    generic map(
      INIT => X"5140"
    )
    port map (
      I0 => RGT(3),
      I1 => INS_2_Q,
      I2 => Mshift_n0009_Sh(9),
      I3 => Mshift_n0008_Sh(1),
      LO => N1719
    );
  FNC_2_14291_G : LUT3_L
    generic map(
      INIT => X"E4"
    )
    port map (
      I0 => INS_2_Q,
      I1 => Mshift_n0008_Sh(4),
      I2 => Mshift_n0009_Sh(12),
      LO => N1721
    );
  FNC_2_12132 : LUT4
    generic map(
      INIT => X"DDD8"
    )
    port map (
      I0 => INS_5_Q,
      I1 => MUX_BLOCK_FNC_1_MUXF512,
      I2 => CHOICE2802,
      I3 => N1795,
      O => ACCUM(6)
    );
  INS_23 : FD
    port map (
      D => IOA_23_IBUF,
      C => CLK_BUFGP,
      Q => INS_23_Q
    );
  NXT_2_1 : LUT4
    generic map(
      INIT => X"ABA8"
    )
    port map (
      I0 => INS_2_Q,
      I1 => INS_26_Q,
      I2 => INS_27_Q,
      I3 => Q_n0011(2),
      O => AA_2_OBUF
    );
  NXT_3_1 : LUT4
    generic map(
      INIT => X"ABA8"
    )
    port map (
      I0 => INS_3_Q,
      I1 => INS_26_Q,
      I2 => INS_27_Q,
      I3 => Q_n0011(3),
      O => AA_3_OBUF
    );
  NXT_4_1 : LUT4
    generic map(
      INIT => X"ABA8"
    )
    port map (
      I0 => INS_4_Q,
      I1 => INS_26_Q,
      I2 => INS_27_Q,
      I3 => Q_n0011(4),
      O => AA_4_OBUF
    );
  NXT_5_1 : LUT4
    generic map(
      INIT => X"ABA8"
    )
    port map (
      I0 => INS_5_Q,
      I1 => INS_26_Q,
      I2 => INS_27_Q,
      I3 => Q_n0011(5),
      O => AA_5_OBUF
    );
  NXT_6_1 : LUT4
    generic map(
      INIT => X"ABA8"
    )
    port map (
      I0 => INS_6_Q,
      I1 => INS_26_Q,
      I2 => INS_27_Q,
      I3 => Q_n0011(6),
      O => AA_6_OBUF
    );
  NXT_7_1 : LUT4
    generic map(
      INIT => X"ABA8"
    )
    port map (
      I0 => INS_7_Q,
      I1 => INS_26_Q,
      I2 => INS_27_Q,
      I3 => Q_n0011(7),
      O => AA_7_OBUF
    );
  NXT_8_1 : LUT4
    generic map(
      INIT => X"ABA8"
    )
    port map (
      I0 => INS_8_Q,
      I1 => INS_26_Q,
      I2 => INS_27_Q,
      I3 => Q_n0011(8),
      O => AA_8_OBUF
    );
  NXT_9_1 : LUT4
    generic map(
      INIT => X"ABA8"
    )
    port map (
      I0 => INS_9_Q,
      I1 => INS_26_Q,
      I2 => INS_27_Q,
      I3 => Q_n0011(9),
      O => AA_9_OBUF
    );
  NXT_10_1 : LUT4
    generic map(
      INIT => X"ABA8"
    )
    port map (
      I0 => INS_10_Q,
      I1 => INS_26_Q,
      I2 => INS_27_Q,
      I3 => Q_n0011(10),
      O => AA_10_OBUF
    );
  NXT_11_1 : LUT4
    generic map(
      INIT => X"ABA8"
    )
    port map (
      I0 => INS_11_Q,
      I1 => INS_26_Q,
      I2 => INS_27_Q,
      I3 => Q_n0011(11),
      O => AA_11_OBUF
    );
  NXT_12_1 : LUT4
    generic map(
      INIT => X"ABA8"
    )
    port map (
      I0 => INS_12_Q,
      I1 => INS_26_Q,
      I2 => INS_27_Q,
      I3 => Q_n0011(12),
      O => AA_12_OBUF
    );
  NXT_13_1 : LUT4
    generic map(
      INIT => X"ABA8"
    )
    port map (
      I0 => INS_13_Q,
      I1 => INS_26_Q,
      I2 => INS_27_Q,
      I3 => Q_n0011(13),
      O => AA_13_OBUF
    );
  NXT_14_1 : LUT4
    generic map(
      INIT => X"ABA8"
    )
    port map (
      I0 => INS_14_Q,
      I1 => INS_26_Q,
      I2 => INS_27_Q,
      I3 => Q_n0011(14),
      O => AA_14_OBUF
    );
  NXT_15_1 : LUT4
    generic map(
      INIT => X"ABA8"
    )
    port map (
      I0 => INS_15_Q,
      I1 => INS_26_Q,
      I2 => INS_27_Q,
      I3 => Q_n0011(15),
      O => AA_15_OBUF
    );
  CLKMA11_INV_0 : INV
    port map (
      I => CLK_BUFGP,
      O => CLKMA1_OBUF
    );
  RC : ROC
    port map (
      O => RST
    );
  Mram_REG_inst_ramx1d_13 : RAM16X1D
    port map (
      A0 => INS_21_Q,
      A1 => INS_22_Q,
      A2 => INS_23_Q,
      A3 => INS_24_Q,
      D => ACCUM(13),
      DPRA0 => INS_16_Q,
      DPRA1 => INS_17_Q,
      DPRA2 => INS_18_Q,
      DPRA3 => INS_19_Q,
      WCLK => CLK_BUFGP,
      WE => Q_n0003,
      SPO => NLW_Mram_REG_inst_ramx1d_13_SPO_UNCONNECTED,
      DPO => LFT(13)
    );
  Mram_REG_ren_inst_ramx1d_29 : RAM16X1D
    port map (
      A0 => INS_21_Q,
      A1 => INS_22_Q,
      A2 => INS_23_Q,
      A3 => INS_24_Q,
      D => ACCUM(13),
      DPRA0 => INS_11_Q,
      DPRA1 => INS_12_Q,
      DPRA2 => INS_13_Q,
      DPRA3 => INS_14_Q,
      WCLK => CLK_BUFGP,
      WE => Q_n0003,
      SPO => NLW_Mram_REG_ren_inst_ramx1d_29_SPO_UNCONNECTED,
      DPO => RGT(13)
    );
  CUR_15 : FDP
    port map (
      D => AA_15_OBUF,
      PRE => RST,
      C => CLK_BUFGP,
      Q => CUR(15)
    );
  INS_27 : FD
    port map (
      D => IOA_27_IBUF,
      C => CLK_BUFGP,
      Q => INS_27_Q
    );
  FNC_2_13571_G : LUT4_L
    generic map(
      INIT => X"5140"
    )
    port map (
      I0 => RGT(3),
      I1 => INS_2_Q,
      I2 => Mshift_n0009_Sh(11),
      I3 => Mshift_n0008_Sh(3),
      LO => N1723
    );
  FNC_2_10141_G : LUT3_L
    generic map(
      INIT => X"E4"
    )
    port map (
      I0 => RGT(2),
      I1 => N171,
      I2 => N181,
      LO => N1725
    );
  cpu_n0023_31_xor : XORCY
    port map (
      CI => cpu_n0023_30_cyo,
      LI => N20,
      O => Q_n0023(31)
    );
  cpu_n0011_15_xor : XORCY
    port map (
      CI => cpu_n0011_14_cyo,
      LI => CUR(15),
      O => Q_n0011(15)
    );
  Mshift_n0008_Sh_4_1_G : LUT3_L
    generic map(
      INIT => X"E4"
    )
    port map (
      I0 => RGT(1),
      I1 => LFT(3),
      I2 => LFT(1),
      LO => N1727
    );
  FNC_2_3151_G : LUT4_L
    generic map(
      INIT => X"A820"
    )
    port map (
      I0 => RGT(2),
      I1 => RGT(0),
      I2 => LFT(6),
      I3 => LFT(5),
      LO => N1729
    );
  XST_VCC : VCC
    port map (
      P => CEA2_OBUF
    );
  FNC_2_51611_G : LUT4_L
    generic map(
      INIT => X"F3D1"
    )
    port map (
      I0 => INS_3_Q,
      I1 => INS_5_Q,
      I2 => MUX_BLOCK_FNC_1_MUXF55,
      I3 => CHOICE3008,
      LO => N1731
    );
  FNC_2_2271_G : LUT4_L
    generic map(
      INIT => X"5140"
    )
    port map (
      I0 => RGT(3),
      I1 => RGT(2),
      I2 => N23,
      I3 => N24,
      LO => N1733
    );
  FNC_2_8141_G : LUT4_L
    generic map(
      INIT => X"A820"
    )
    port map (
      I0 => RGT(2),
      I1 => RGT(0),
      I2 => LFT(8),
      I3 => LFT(9),
      LO => N1735
    );
  Mshift_n0009_Sh_6_11_G : LUT3_L
    generic map(
      INIT => X"E4"
    )
    port map (
      I0 => RGT(0),
      I1 => LFT(8),
      I2 => LFT(9),
      LO => N1737
    );
  FNC_2_7141_G : LUT4_L
    generic map(
      INIT => X"A820"
    )
    port map (
      I0 => RGT(2),
      I1 => RGT(0),
      I2 => LFT(7),
      I3 => LFT(8),
      LO => N1739
    );
  Mshift_n0008_Sh_5_1_G : LUT3_L
    generic map(
      INIT => X"E4"
    )
    port map (
      I0 => RGT(1),
      I1 => LFT(4),
      I2 => LFT(2),
      LO => N1741
    );
  FNC_2_12541_G : LUT4_L
    generic map(
      INIT => X"5140"
    )
    port map (
      I0 => RGT(3),
      I1 => INS_2_Q,
      I2 => Mshift_n0009_Sh(10),
      I3 => Mshift_n0008_Sh(2),
      LO => N1743
    );
  FNC_2_15551_G : LUT4_L
    generic map(
      INIT => X"5140"
    )
    port map (
      I0 => RGT(3),
      I1 => INS_2_Q,
      I2 => Mshift_n0009_Sh(13),
      I3 => Mshift_n0008_Sh(5),
      LO => N1745
    );
  Mshift_n0009_Sh_9_11_G : LUT3_L
    generic map(
      INIT => X"E4"
    )
    port map (
      I0 => RGT(0),
      I1 => LFT(11),
      I2 => LFT(12),
      LO => N1747
    );
  IOA_4_IBUF_9 : IBUF
    port map (
      I => IOA(4),
      O => IOA_4_IBUF
    );
  INS_24 : FD
    port map (
      D => IOA_24_IBUF,
      C => CLK_BUFGP,
      Q => INS_24_Q
    );
  FNC_2_3301_G : LUT4_L
    generic map(
      INIT => X"5140"
    )
    port map (
      I0 => RGT(2),
      I1 => RGT(0),
      I2 => LFT(9),
      I3 => LFT(10),
      LO => N1749
    );
  FNC_2_921_G : LUT4_L
    generic map(
      INIT => X"A820"
    )
    port map (
      I0 => RGT(2),
      I1 => RGT(0),
      I2 => LFT(9),
      I3 => LFT(10),
      LO => N1751
    );
  FNC_2_5271_G : LUT4_L
    generic map(
      INIT => X"A820"
    )
    port map (
      I0 => RGT(2),
      I1 => RGT(0),
      I2 => LFT(8),
      I3 => LFT(7),
      LO => N1753
    );
  FNC_2_3113_G : LUT4_L
    generic map(
      INIT => X"5140"
    )
    port map (
      I0 => RGT(2),
      I1 => RGT(1),
      I2 => LFT(3),
      I3 => LFT(1),
      LO => N1755
    );
  LED_7_1 : LUT4
    generic map(
      INIT => X"2227"
    )
    port map (
      I0 => INS_5_Q,
      I1 => MUX_BLOCK_FNC_1_MUXF513,
      I2 => CHOICE2858,
      I3 => CHOICE2856,
      O => LED_7_OBUF
    );
  LED_6_1 : LUT4
    generic map(
      INIT => X"2227"
    )
    port map (
      I0 => INS_5_Q,
      I1 => MUX_BLOCK_FNC_1_MUXF512,
      I2 => CHOICE2802,
      I3 => CHOICE2800,
      O => LED_6_OBUF
    );
  LED_5_1 : LUT4
    generic map(
      INIT => X"2227"
    )
    port map (
      I0 => INS_5_Q,
      I1 => MUX_BLOCK_FNC_1_MUXF511,
      I2 => CHOICE2747,
      I3 => CHOICE2745,
      O => LED_5_OBUF
    );
  LED_4_1 : LUT4
    generic map(
      INIT => X"2227"
    )
    port map (
      I0 => INS_5_Q,
      I1 => MUX_BLOCK_FNC_1_MUXF510,
      I2 => CHOICE2720,
      I3 => CHOICE2718,
      O => LED_4_OBUF
    );
  LED_3_1 : LUT4
    generic map(
      INIT => X"2227"
    )
    port map (
      I0 => INS_5_Q,
      I1 => MUX_BLOCK_FNC_1_MUXF59,
      I2 => CHOICE2946,
      I3 => CHOICE2944,
      O => LED_3_OBUF
    );
  LED_2_1 : LUT4
    generic map(
      INIT => X"2227"
    )
    port map (
      I0 => INS_5_Q,
      I1 => MUX_BLOCK_FNC_1_MUXF58,
      I2 => CHOICE3074,
      I3 => CHOICE3072,
      O => LED_2_OBUF
    );
  LED_1_1 : LUT4
    generic map(
      INIT => X"2227"
    )
    port map (
      I0 => INS_5_Q,
      I1 => MUX_BLOCK_FNC_1_MUXF57,
      I2 => CHOICE3042,
      I3 => CHOICE3040,
      O => LED_1_OBUF
    );
  Q_n00031 : LUT2
    generic map(
      INIT => X"1"
    )
    port map (
      I0 => INS_26_Q,
      I1 => INS_27_Q,
      O => Q_n0003
    );
  FNC_1_rn_711 : LUT4
    generic map(
      INIT => X"5668"
    )
    port map (
      I0 => INS_3_Q,
      I1 => INS_2_Q,
      I2 => LFT(1),
      I3 => RGT(1),
      O => MUX_BLOCK_FNC_1_MUXF57
    );
  FNC_1_rn_311 : LUT4
    generic map(
      INIT => X"5668"
    )
    port map (
      I0 => INS_3_Q,
      I1 => INS_2_Q,
      I2 => LFT(12),
      I3 => RGT(12),
      O => MUX_BLOCK_FNC_1_MUXF53
    );
  FNC_1_rn_611 : LUT4
    generic map(
      INIT => X"5668"
    )
    port map (
      I0 => INS_3_Q,
      I1 => INS_2_Q,
      I2 => LFT(15),
      I3 => RGT(15),
      O => MUX_BLOCK_FNC_1_MUXF56
    );
  FNC_1_rn_911 : LUT4
    generic map(
      INIT => X"5668"
    )
    port map (
      I0 => INS_3_Q,
      I1 => INS_2_Q,
      I2 => LFT(3),
      I3 => RGT(3),
      O => MUX_BLOCK_FNC_1_MUXF59
    );
  FNC_1_rn_1411 : LUT4
    generic map(
      INIT => X"5668"
    )
    port map (
      I0 => INS_3_Q,
      I1 => INS_2_Q,
      I2 => LFT(8),
      I3 => RGT(8),
      O => MUX_BLOCK_FNC_1_MUXF514
    );
  FNC_1_rn_1011 : LUT4
    generic map(
      INIT => X"5668"
    )
    port map (
      I0 => INS_3_Q,
      I1 => INS_2_Q,
      I2 => LFT(4),
      I3 => RGT(4),
      O => MUX_BLOCK_FNC_1_MUXF510
    );
  FNC_1_rn_1511 : LUT4
    generic map(
      INIT => X"5668"
    )
    port map (
      I0 => INS_3_Q,
      I1 => INS_2_Q,
      I2 => LFT(9),
      I3 => RGT(9),
      O => MUX_BLOCK_FNC_1_MUXF515
    );
  FNC_1_rn_811 : LUT4
    generic map(
      INIT => X"5668"
    )
    port map (
      I0 => INS_3_Q,
      I1 => INS_2_Q,
      I2 => LFT(2),
      I3 => RGT(2),
      O => MUX_BLOCK_FNC_1_MUXF58
    );
  FNC_1_rn_161 : LUT4
    generic map(
      INIT => X"5668"
    )
    port map (
      I0 => INS_3_Q,
      I1 => INS_2_Q,
      I2 => LFT(10),
      I3 => RGT(10),
      O => MUX_BLOCK_FNC_1_MUXF51
    );
  FNC_1_rn_1111 : LUT4
    generic map(
      INIT => X"5668"
    )
    port map (
      I0 => INS_3_Q,
      I1 => INS_2_Q,
      I2 => LFT(5),
      I3 => RGT(5),
      O => MUX_BLOCK_FNC_1_MUXF511
    );
  LED_0_1 : LUT4
    generic map(
      INIT => X"2227"
    )
    port map (
      I0 => INS_5_Q,
      I1 => MUX_BLOCK_FNC_1_MUXF5,
      I2 => CHOICE3109,
      I3 => CHOICE3107,
      O => LED_0_OBUF
    );
  FNC_1_rn_1311 : LUT4
    generic map(
      INIT => X"5668"
    )
    port map (
      I0 => INS_3_Q,
      I1 => INS_2_Q,
      I2 => LFT(7),
      I3 => RGT(7),
      O => MUX_BLOCK_FNC_1_MUXF513
    );
  IOA_7_IBUF_10 : IBUF
    port map (
      I => IOA(7),
      O => IOA_7_IBUF
    );
  FNC_1_rn_011 : LUT4
    generic map(
      INIT => X"5668"
    )
    port map (
      I0 => INS_3_Q,
      I1 => INS_2_Q,
      I2 => LFT(0),
      I3 => RGT(0),
      O => MUX_BLOCK_FNC_1_MUXF5
    );
  FNC_1_rn_1211 : LUT4
    generic map(
      INIT => X"5668"
    )
    port map (
      I0 => INS_3_Q,
      I1 => INS_2_Q,
      I2 => LFT(6),
      I3 => RGT(6),
      O => MUX_BLOCK_FNC_1_MUXF512
    );
  FNC_2_6131_G : LUT4_L
    generic map(
      INIT => X"A820"
    )
    port map (
      I0 => RGT(3),
      I1 => RGT(1),
      I2 => N191,
      I3 => N192,
      LO => N1757
    );
  Mshift_n0008_Sh_6_1_G : LUT3_L
    generic map(
      INIT => X"E4"
    )
    port map (
      I0 => RGT(0),
      I1 => LFT(4),
      I2 => LFT(3),
      LO => N1759
    );
  Mram_REG_ren_inst_ramx1d_22 : RAM16X1D
    port map (
      A0 => INS_21_Q,
      A1 => INS_22_Q,
      A2 => INS_23_Q,
      A3 => INS_24_Q,
      D => ACCUM(6),
      DPRA0 => INS_11_Q,
      DPRA1 => INS_12_Q,
      DPRA2 => INS_13_Q,
      DPRA3 => INS_14_Q,
      WCLK => CLK_BUFGP,
      WE => Q_n0003,
      SPO => NLW_Mram_REG_ren_inst_ramx1d_22_SPO_UNCONNECTED,
      DPO => RGT(6)
    );
  Mram_REG_ren_inst_ramx1d_26 : RAM16X1D
    port map (
      A0 => INS_21_Q,
      A1 => INS_22_Q,
      A2 => INS_23_Q,
      A3 => INS_24_Q,
      D => ACCUM(10),
      DPRA0 => INS_11_Q,
      DPRA1 => INS_12_Q,
      DPRA2 => INS_13_Q,
      DPRA3 => INS_14_Q,
      WCLK => CLK_BUFGP,
      WE => Q_n0003,
      SPO => NLW_Mram_REG_ren_inst_ramx1d_26_SPO_UNCONNECTED,
      DPO => RGT(10)
    );
  FNC_2_4271_G : LUT4_L
    generic map(
      INIT => X"A820"
    )
    port map (
      I0 => RGT(2),
      I1 => RGT(0),
      I2 => LFT(7),
      I3 => LFT(6),
      LO => N1761
    );
  Mshift_n0008_Sh_9_11_G : LUT3_L
    generic map(
      INIT => X"E4"
    )
    port map (
      I0 => RGT(0),
      I1 => LFT(7),
      I2 => LFT(6),
      LO => N1763
    );
  Ker331 : LUT3
    generic map(
      INIT => X"AC"
    )
    port map (
      I0 => LFT(5),
      I1 => LFT(7),
      I2 => RGT(1),
      O => N33
    );
  Mshift_n0009_Sh_11_11_G : LUT3_L
    generic map(
      INIT => X"E4"
    )
    port map (
      I0 => RGT(0),
      I1 => LFT(13),
      I2 => LFT(14),
      LO => N1765
    );
  Mshift_n0009_Sh_5_11_G : LUT3_L
    generic map(
      INIT => X"E4"
    )
    port map (
      I0 => RGT(0),
      I1 => LFT(7),
      I2 => LFT(8),
      LO => N1767
    );
  FNC_2_15132 : LUT4
    generic map(
      INIT => X"DDD8"
    )
    port map (
      I0 => INS_5_Q,
      I1 => MUX_BLOCK_FNC_1_MUXF515,
      I2 => CHOICE2830,
      I3 => CHOICE2828,
      O => ACCUM(9)
    );
  Mshift_n0008_Sh_8_11_G : LUT3_L
    generic map(
      INIT => X"E4"
    )
    port map (
      I0 => RGT(0),
      I1 => LFT(6),
      I2 => LFT(5),
      LO => N1769
    );
  Mshift_n0008_Sh_10_11_G : LUT3_L
    generic map(
      INIT => X"E4"
    )
    port map (
      I0 => RGT(0),
      I1 => LFT(8),
      I2 => LFT(7),
      LO => N1771
    );
  Mram_REG_inst_ramx1d_1 : RAM16X1D
    port map (
      A0 => INS_21_Q,
      A1 => INS_22_Q,
      A2 => INS_23_Q,
      A3 => INS_24_Q,
      D => ACCUM(1),
      DPRA0 => INS_16_Q,
      DPRA1 => INS_17_Q,
      DPRA2 => INS_18_Q,
      DPRA3 => INS_19_Q,
      WCLK => CLK_BUFGP,
      WE => Q_n0003,
      SPO => NLW_Mram_REG_inst_ramx1d_1_SPO_UNCONNECTED,
      DPO => LFT(1)
    );
  Mram_REG_inst_ramx1d_5 : RAM16X1D
    port map (
      A0 => INS_21_Q,
      A1 => INS_22_Q,
      A2 => INS_23_Q,
      A3 => INS_24_Q,
      D => ACCUM(5),
      DPRA0 => INS_16_Q,
      DPRA1 => INS_17_Q,
      DPRA2 => INS_18_Q,
      DPRA3 => INS_19_Q,
      WCLK => CLK_BUFGP,
      WE => Q_n0003,
      SPO => NLW_Mram_REG_inst_ramx1d_5_SPO_UNCONNECTED,
      DPO => LFT(5)
    );
  Mram_REG_inst_ramx1d_9 : RAM16X1D
    port map (
      A0 => INS_21_Q,
      A1 => INS_22_Q,
      A2 => INS_23_Q,
      A3 => INS_24_Q,
      D => ACCUM(9),
      DPRA0 => INS_16_Q,
      DPRA1 => INS_17_Q,
      DPRA2 => INS_18_Q,
      DPRA3 => INS_19_Q,
      WCLK => CLK_BUFGP,
      WE => Q_n0003,
      SPO => NLW_Mram_REG_inst_ramx1d_9_SPO_UNCONNECTED,
      DPO => LFT(9)
    );
  Mram_REG_ren_inst_ramx1d_30 : RAM16X1D
    port map (
      A0 => INS_21_Q,
      A1 => INS_22_Q,
      A2 => INS_23_Q,
      A3 => INS_24_Q,
      D => ACCUM(14),
      DPRA0 => INS_11_Q,
      DPRA1 => INS_12_Q,
      DPRA2 => INS_13_Q,
      DPRA3 => INS_14_Q,
      WCLK => CLK_BUFGP,
      WE => Q_n0003,
      SPO => NLW_Mram_REG_ren_inst_ramx1d_30_SPO_UNCONNECTED,
      DPO => RGT(14)
    );
  Mram_REG_ren_inst_ramx1d_18 : RAM16X1D
    port map (
      A0 => INS_21_Q,
      A1 => INS_22_Q,
      A2 => INS_23_Q,
      A3 => INS_24_Q,
      D => ACCUM(2),
      DPRA0 => INS_11_Q,
      DPRA1 => INS_12_Q,
      DPRA2 => INS_13_Q,
      DPRA3 => INS_14_Q,
      WCLK => CLK_BUFGP,
      WE => Q_n0003,
      SPO => NLW_Mram_REG_ren_inst_ramx1d_18_SPO_UNCONNECTED,
      DPO => RGT(2)
    );
  Mshift_n0009_Sh_14_1 : LUT4_D
    generic map(
      INIT => X"00CA"
    )
    port map (
      I0 => LFT(14),
      I1 => LFT(15),
      I2 => RGT(0),
      I3 => RGT(1),
      LO => N1788,
      O => Mshift_n0009_Sh(14)
    );
  Mram_REG_ren_inst_ramx1d_23 : RAM16X1D
    port map (
      A0 => INS_21_Q,
      A1 => INS_22_Q,
      A2 => INS_23_Q,
      A3 => INS_24_Q,
      D => ACCUM(7),
      DPRA0 => INS_11_Q,
      DPRA1 => INS_12_Q,
      DPRA2 => INS_13_Q,
      DPRA3 => INS_14_Q,
      WCLK => CLK_BUFGP,
      WE => Q_n0003,
      SPO => NLW_Mram_REG_ren_inst_ramx1d_23_SPO_UNCONNECTED,
      DPO => RGT(7)
    );
  Mram_REG_ren_inst_ramx1d_27 : RAM16X1D
    port map (
      A0 => INS_21_Q,
      A1 => INS_22_Q,
      A2 => INS_23_Q,
      A3 => INS_24_Q,
      D => ACCUM(11),
      DPRA0 => INS_11_Q,
      DPRA1 => INS_12_Q,
      DPRA2 => INS_13_Q,
      DPRA3 => INS_14_Q,
      WCLK => CLK_BUFGP,
      WE => Q_n0003,
      SPO => NLW_Mram_REG_ren_inst_ramx1d_27_SPO_UNCONNECTED,
      DPO => RGT(11)
    );
  Mshift_n0009_Sh_8_11_G : LUT3_L
    generic map(
      INIT => X"E4"
    )
    port map (
      I0 => RGT(0),
      I1 => LFT(10),
      I2 => LFT(11),
      LO => N1773
    );
  Mshift_n0008_Sh_2_Q : LUT4
    generic map(
      INIT => X"085D"
    )
    port map (
      I0 => RGT(1),
      I1 => LFT(0),
      I2 => RGT(0),
      I3 => N186,
      O => Mshift_n0008_Sh(2)
    );
  CELA1X_OBUF : OBUF
    port map (
      I => CEA2X_OBUF,
      O => CELA1X
    );
  FNC_2_1401_G : LUT3_L
    generic map(
      INIT => X"E4"
    )
    port map (
      I0 => INS_2_Q,
      I1 => Mshift_n0008_Sh(6),
      I2 => Mshift_n0009_Sh(14),
      LO => N1775
    );
  Mshift_n0009_Sh_7_11_G : LUT3_L
    generic map(
      INIT => X"E4"
    )
    port map (
      I0 => RGT(0),
      I1 => LFT(9),
      I2 => LFT(10),
      LO => N1777
    );
  FNC_2_4421_G : LUT4_L
    generic map(
      INIT => X"5140"
    )
    port map (
      I0 => RGT(2),
      I1 => RGT(0),
      I2 => LFT(10),
      I3 => LFT(11),
      LO => N1779
    );
  FNC_2_5421_G : LUT4_L
    generic map(
      INIT => X"5140"
    )
    port map (
      I0 => RGT(2),
      I1 => RGT(0),
      I2 => LFT(11),
      I3 => LFT(12),
      LO => N1781
    );
  Mram_REG_inst_ramx1d_14 : RAM16X1D
    port map (
      A0 => INS_21_Q,
      A1 => INS_22_Q,
      A2 => INS_23_Q,
      A3 => INS_24_Q,
      D => ACCUM(14),
      DPRA0 => INS_16_Q,
      DPRA1 => INS_17_Q,
      DPRA2 => INS_18_Q,
      DPRA3 => INS_19_Q,
      WCLK => CLK_BUFGP,
      WE => Q_n0003,
      SPO => NLW_Mram_REG_inst_ramx1d_14_SPO_UNCONNECTED,
      DPO => LFT(14)
    );
  Mram_REG_inst_ramx1d_2 : RAM16X1D
    port map (
      A0 => INS_21_Q,
      A1 => INS_22_Q,
      A2 => INS_23_Q,
      A3 => INS_24_Q,
      D => ACCUM(2),
      DPRA0 => INS_16_Q,
      DPRA1 => INS_17_Q,
      DPRA2 => INS_18_Q,
      DPRA3 => INS_19_Q,
      WCLK => CLK_BUFGP,
      WE => Q_n0003,
      SPO => NLW_Mram_REG_inst_ramx1d_2_SPO_UNCONNECTED,
      DPO => LFT(2)
    );
  Mram_REG_inst_ramx1d_6 : RAM16X1D
    port map (
      A0 => INS_21_Q,
      A1 => INS_22_Q,
      A2 => INS_23_Q,
      A3 => INS_24_Q,
      D => ACCUM(6),
      DPRA0 => INS_16_Q,
      DPRA1 => INS_17_Q,
      DPRA2 => INS_18_Q,
      DPRA3 => INS_19_Q,
      WCLK => CLK_BUFGP,
      WE => Q_n0003,
      SPO => NLW_Mram_REG_inst_ramx1d_6_SPO_UNCONNECTED,
      DPO => LFT(6)
    );
  Mram_REG_inst_ramx1d_10 : RAM16X1D
    port map (
      A0 => INS_21_Q,
      A1 => INS_22_Q,
      A2 => INS_23_Q,
      A3 => INS_24_Q,
      D => ACCUM(10),
      DPRA0 => INS_16_Q,
      DPRA1 => INS_17_Q,
      DPRA2 => INS_18_Q,
      DPRA3 => INS_19_Q,
      WCLK => CLK_BUFGP,
      WE => Q_n0003,
      SPO => NLW_Mram_REG_inst_ramx1d_10_SPO_UNCONNECTED,
      DPO => LFT(10)
    );
  Mram_REG_ren_inst_ramx1d_31 : RAM16X1D
    port map (
      A0 => INS_21_Q,
      A1 => INS_22_Q,
      A2 => INS_23_Q,
      A3 => INS_24_Q,
      D => ACCUM(15),
      DPRA0 => INS_11_Q,
      DPRA1 => INS_12_Q,
      DPRA2 => INS_13_Q,
      DPRA3 => INS_14_Q,
      WCLK => CLK_BUFGP,
      WE => Q_n0003,
      SPO => NLW_Mram_REG_ren_inst_ramx1d_31_SPO_UNCONNECTED,
      DPO => RGT(15)
    );
  Mram_REG_ren_inst_ramx1d_19 : RAM16X1D
    port map (
      A0 => INS_21_Q,
      A1 => INS_22_Q,
      A2 => INS_23_Q,
      A3 => INS_24_Q,
      D => ACCUM(3),
      DPRA0 => INS_11_Q,
      DPRA1 => INS_12_Q,
      DPRA2 => INS_13_Q,
      DPRA3 => INS_14_Q,
      WCLK => CLK_BUFGP,
      WE => Q_n0003,
      SPO => NLW_Mram_REG_ren_inst_ramx1d_19_SPO_UNCONNECTED,
      DPO => RGT(3)
    );
  Ker871 : LUT4_L
    generic map(
      INIT => X"B830"
    )
    port map (
      I0 => LFT(0),
      I1 => RGT(2),
      I2 => Mshift_n0008_Sh(4),
      I3 => N115,
      LO => N87
    );
  Mshift_n0008_Sh_7_11_G : LUT3_L
    generic map(
      INIT => X"E4"
    )
    port map (
      I0 => RGT(0),
      I1 => LFT(5),
      I2 => LFT(4),
      LO => N1783
    );
  CUR_0 : FDP
    port map (
      D => AA_0_OBUF,
      PRE => RST,
      C => CLK_BUFGP,
      Q => CUR(0)
    );
  CUR_1 : FDP
    port map (
      D => AA_1_OBUF,
      PRE => RST,
      C => CLK_BUFGP,
      Q => CUR(1)
    );
  CUR_2 : FDP
    port map (
      D => AA_2_OBUF,
      PRE => RST,
      C => CLK_BUFGP,
      Q => CUR(2)
    );
  CUR_3 : FDP
    port map (
      D => AA_3_OBUF,
      PRE => RST,
      C => CLK_BUFGP,
      Q => CUR(3)
    );
  CUR_4 : FDP
    port map (
      D => AA_4_OBUF,
      PRE => RST,
      C => CLK_BUFGP,
      Q => CUR(4)
    );
  CUR_5 : FDP
    port map (
      D => AA_5_OBUF,
      PRE => RST,
      C => CLK_BUFGP,
      Q => CUR(5)
    );
  CUR_6 : FDP
    port map (
      D => AA_6_OBUF,
      PRE => RST,
      C => CLK_BUFGP,
      Q => CUR(6)
    );
  CUR_7 : FDP
    port map (
      D => AA_7_OBUF,
      PRE => RST,
      C => CLK_BUFGP,
      Q => CUR(7)
    );
  CUR_8 : FDP
    port map (
      D => AA_8_OBUF,
      PRE => RST,
      C => CLK_BUFGP,
      Q => CUR(8)
    );
  CUR_9 : FDP
    port map (
      D => AA_9_OBUF,
      PRE => RST,
      C => CLK_BUFGP,
      Q => CUR(9)
    );
  CUR_10 : FDP
    port map (
      D => AA_10_OBUF,
      PRE => RST,
      C => CLK_BUFGP,
      Q => CUR(10)
    );
  CUR_11 : FDP
    port map (
      D => AA_11_OBUF,
      PRE => RST,
      C => CLK_BUFGP,
      Q => CUR(11)
    );
  CUR_12 : FDP
    port map (
      D => AA_12_OBUF,
      PRE => RST,
      C => CLK_BUFGP,
      Q => CUR(12)
    );
  CUR_13 : FDP
    port map (
      D => AA_13_OBUF,
      PRE => RST,
      C => CLK_BUFGP,
      Q => CUR(13)
    );
  CUR_14 : FDP
    port map (
      D => AA_14_OBUF,
      PRE => RST,
      C => CLK_BUFGP,
      Q => CUR(14)
    );
  INS_0 : FD
    port map (
      D => IOA_0_IBUF,
      C => CLK_BUFGP,
      Q => INS_0_Q
    );
  INS_1 : FD
    port map (
      D => IOA_1_IBUF,
      C => CLK_BUFGP,
      Q => INS_1_Q
    );
  INS_2 : FD
    port map (
      D => IOA_2_IBUF,
      C => CLK_BUFGP,
      Q => INS_2_Q
    );
  INS_3 : FD
    port map (
      D => IOA_3_IBUF,
      C => CLK_BUFGP,
      Q => INS_3_Q
    );
  INS_4 : FD
    port map (
      D => IOA_4_IBUF,
      C => CLK_BUFGP,
      Q => INS_4_Q
    );
  INS_5 : FD
    port map (
      D => IOA_5_IBUF,
      C => CLK_BUFGP,
      Q => INS_5_Q
    );
  INS_6 : FD
    port map (
      D => IOA_6_IBUF,
      C => CLK_BUFGP,
      Q => INS_6_Q
    );
  INS_7 : FD
    port map (
      D => IOA_7_IBUF,
      C => CLK_BUFGP,
      Q => INS_7_Q
    );
  INS_8 : FD
    port map (
      D => IOA_8_IBUF,
      C => CLK_BUFGP,
      Q => INS_8_Q
    );
  INS_9 : FD
    port map (
      D => IOA_9_IBUF,
      C => CLK_BUFGP,
      Q => INS_9_Q
    );
  INS_10 : FD
    port map (
      D => IOA_10_IBUF,
      C => CLK_BUFGP,
      Q => INS_10_Q
    );
  INS_11 : FD
    port map (
      D => IOA_11_IBUF,
      C => CLK_BUFGP,
      Q => INS_11_Q
    );
  INS_12 : FD
    port map (
      D => IOA_12_IBUF,
      C => CLK_BUFGP,
      Q => INS_12_Q
    );
  INS_13 : FD
    port map (
      D => IOA_13_IBUF,
      C => CLK_BUFGP,
      Q => INS_13_Q
    );
  INS_14 : FD
    port map (
      D => IOA_14_IBUF,
      C => CLK_BUFGP,
      Q => INS_14_Q
    );
  INS_15 : FD
    port map (
      D => IOA_15_IBUF,
      C => CLK_BUFGP,
      Q => INS_15_Q
    );
  INS_16 : FD
    port map (
      D => IOA_16_IBUF,
      C => CLK_BUFGP,
      Q => INS_16_Q
    );
  INS_17 : FD
    port map (
      D => IOA_17_IBUF,
      C => CLK_BUFGP,
      Q => INS_17_Q
    );
  INS_18 : FD
    port map (
      D => IOA_18_IBUF,
      C => CLK_BUFGP,
      Q => INS_18_Q
    );
  INS_19 : FD
    port map (
      D => IOA_19_IBUF,
      C => CLK_BUFGP,
      Q => INS_19_Q
    );
  INS_26 : FD
    port map (
      D => IOA_26_IBUF,
      C => CLK_BUFGP,
      Q => INS_26_Q
    );
  INS_21 : FD
    port map (
      D => IOA_21_IBUF,
      C => CLK_BUFGP,
      Q => INS_21_Q
    );
  INS_22 : FD
    port map (
      D => IOA_22_IBUF,
      C => CLK_BUFGP,
      Q => INS_22_Q
    );
  IOA_19_IBUF_11 : IBUF
    port map (
      I => IOA(19),
      O => IOA_19_IBUF
    );
  IOA_0_IBUF_12 : IBUF
    port map (
      I => IOA(0),
      O => IOA_0_IBUF
    );
  CLK_BUFGP_13 : BUFGP
    port map (
      I => CLK,
      O => CLK_BUFGP
    );
  NXT_0_1 : LUT4
    generic map(
      INIT => X"EF01"
    )
    port map (
      I0 => INS_26_Q,
      I1 => INS_27_Q,
      I2 => CUR(0),
      I3 => INS_0_Q,
      O => AA_0_OBUF
    );
  FNC_2_184 : LUT4_L
    generic map(
      INIT => X"CC40"
    )
    port map (
      I0 => RGT(3),
      I1 => N114,
      I2 => CHOICE2769,
      I3 => CHOICE2757,
      LO => CHOICE2773
    );
  FNC_2_829 : LUT4
    generic map(
      INIT => X"5140"
    )
    port map (
      I0 => RGT(2),
      I1 => RGT(0),
      I2 => N67,
      I3 => N1790,
      O => CHOICE3059
    );
  CEA2X_OBUF_14 : OBUF
    port map (
      I => CEA2X_OBUF,
      O => CEA2X
    );
  FNC_2_426_SW0 : LUT3_L
    generic map(
      INIT => X"D8"
    )
    port map (
      I0 => RGT(2),
      I1 => Mshift_n0008_Sh(1),
      I2 => Mshift_n0008_Sh(5),
      LO => N1572
    );
  FNC_2_131 : LUT2
    generic map(
      INIT => X"2"
    )
    port map (
      I0 => Q_n0023(16),
      I1 => INS_3_Q,
      O => CHOICE3109
    );
  AA_18_OBUF : OBUF
    port map (
      I => CEA2X_OBUF,
      O => AA(18)
    );
  CEA_OBUF : OBUF
    port map (
      I => CEA2X_OBUF,
      O => CEA
    );
  IOA_10_IBUF_15 : IBUF
    port map (
      I => IOA(10),
      O => IOA_10_IBUF
    );
  INS_5_1_16 : FD
    port map (
      D => IOA_5_IBUF,
      C => CLK_BUFGP,
      Q => INS_5_1
    );
  ZZA_OBUF : OBUF
    port map (
      I => CEA2X_OBUF,
      O => ZZA
    );
  FNC_2_7108 : LUT4_D
    generic map(
      INIT => X"8C80"
    )
    port map (
      I0 => INS_2_Q,
      I1 => N114,
      I2 => N1672,
      I3 => N1576,
      LO => N1789,
      O => CHOICE3040
    );
  cpu_n0011_0_lut_INV_0 : INV
    port map (
      I => CUR(0),
      O => N4
    );
  cpu_n0011_0_cy : MUXCY
    port map (
      CI => CEA2X_OBUF,
      DI => CEA2_OBUF,
      S => N4,
      O => cpu_n0011_0_cyo
    );
  LED_0_OBUF_17 : OBUF
    port map (
      I => LED_0_OBUF,
      O => LED(0)
    );
  cpu_n0011_1_cy : MUXCY
    port map (
      CI => cpu_n0011_0_cyo,
      DI => CEA2X_OBUF,
      S => CUR_1_rt,
      O => cpu_n0011_1_cyo
    );
  cpu_n0011_1_xor : XORCY
    port map (
      CI => cpu_n0011_0_cyo,
      LI => CUR_1_rt,
      O => Q_n0011(1)
    );
  cpu_n0011_2_cy : MUXCY
    port map (
      CI => cpu_n0011_1_cyo,
      DI => CEA2X_OBUF,
      S => CUR_2_rt,
      O => cpu_n0011_2_cyo
    );
  cpu_n0011_2_xor : XORCY
    port map (
      CI => cpu_n0011_1_cyo,
      LI => CUR_2_rt,
      O => Q_n0011(2)
    );
  cpu_n0011_3_cy : MUXCY
    port map (
      CI => cpu_n0011_2_cyo,
      DI => CEA2X_OBUF,
      S => CUR_3_rt,
      O => cpu_n0011_3_cyo
    );
  cpu_n0011_3_xor : XORCY
    port map (
      CI => cpu_n0011_2_cyo,
      LI => CUR_3_rt,
      O => Q_n0011(3)
    );
  cpu_n0011_4_cy : MUXCY
    port map (
      CI => cpu_n0011_3_cyo,
      DI => CEA2X_OBUF,
      S => CUR_4_rt,
      O => cpu_n0011_4_cyo
    );
  cpu_n0011_4_xor : XORCY
    port map (
      CI => cpu_n0011_3_cyo,
      LI => CUR_4_rt,
      O => Q_n0011(4)
    );
  cpu_n0011_5_cy : MUXCY
    port map (
      CI => cpu_n0011_4_cyo,
      DI => CEA2X_OBUF,
      S => CUR_5_rt,
      O => cpu_n0011_5_cyo
    );
  cpu_n0011_5_xor : XORCY
    port map (
      CI => cpu_n0011_4_cyo,
      LI => CUR_5_rt,
      O => Q_n0011(5)
    );
  cpu_n0011_6_cy : MUXCY
    port map (
      CI => cpu_n0011_5_cyo,
      DI => CEA2X_OBUF,
      S => CUR_6_rt,
      O => cpu_n0011_6_cyo
    );
  cpu_n0011_6_xor : XORCY
    port map (
      CI => cpu_n0011_5_cyo,
      LI => CUR_6_rt,
      O => Q_n0011(6)
    );
  cpu_n0011_7_cy : MUXCY
    port map (
      CI => cpu_n0011_6_cyo,
      DI => CEA2X_OBUF,
      S => CUR_7_rt,
      O => cpu_n0011_7_cyo
    );
  cpu_n0011_7_xor : XORCY
    port map (
      CI => cpu_n0011_6_cyo,
      LI => CUR_7_rt,
      O => Q_n0011(7)
    );
  cpu_n0011_8_cy : MUXCY
    port map (
      CI => cpu_n0011_7_cyo,
      DI => CEA2X_OBUF,
      S => CUR_8_rt,
      O => cpu_n0011_8_cyo
    );
  cpu_n0011_8_xor : XORCY
    port map (
      CI => cpu_n0011_7_cyo,
      LI => CUR_8_rt,
      O => Q_n0011(8)
    );
  cpu_n0011_9_cy : MUXCY
    port map (
      CI => cpu_n0011_8_cyo,
      DI => CEA2X_OBUF,
      S => CUR_9_rt,
      O => cpu_n0011_9_cyo
    );
  cpu_n0011_9_xor : XORCY
    port map (
      CI => cpu_n0011_8_cyo,
      LI => CUR_9_rt,
      O => Q_n0011(9)
    );
  cpu_n0011_10_cy : MUXCY
    port map (
      CI => cpu_n0011_9_cyo,
      DI => CEA2X_OBUF,
      S => CUR_10_rt,
      O => cpu_n0011_10_cyo
    );
  cpu_n0011_10_xor : XORCY
    port map (
      CI => cpu_n0011_9_cyo,
      LI => CUR_10_rt,
      O => Q_n0011(10)
    );
  cpu_n0011_11_cy : MUXCY
    port map (
      CI => cpu_n0011_10_cyo,
      DI => CEA2X_OBUF,
      S => CUR_11_rt,
      O => cpu_n0011_11_cyo
    );
  cpu_n0011_11_xor : XORCY
    port map (
      CI => cpu_n0011_10_cyo,
      LI => CUR_11_rt,
      O => Q_n0011(11)
    );
  cpu_n0011_12_cy : MUXCY
    port map (
      CI => cpu_n0011_11_cyo,
      DI => CEA2X_OBUF,
      S => CUR_12_rt,
      O => cpu_n0011_12_cyo
    );
  cpu_n0011_12_xor : XORCY
    port map (
      CI => cpu_n0011_11_cyo,
      LI => CUR_12_rt,
      O => Q_n0011(12)
    );
  cpu_n0011_13_cy : MUXCY
    port map (
      CI => cpu_n0011_12_cyo,
      DI => CEA2X_OBUF,
      S => CUR_13_rt,
      O => cpu_n0011_13_cyo
    );
  cpu_n0011_13_xor : XORCY
    port map (
      CI => cpu_n0011_12_cyo,
      LI => CUR_13_rt,
      O => Q_n0011(13)
    );
  cpu_n0011_14_cy : MUXCY
    port map (
      CI => cpu_n0011_13_cyo,
      DI => CEA2X_OBUF,
      S => CUR_14_rt,
      O => cpu_n0011_14_cyo
    );
  cpu_n0011_14_xor : XORCY
    port map (
      CI => cpu_n0011_13_cyo,
      LI => CUR_14_rt,
      O => Q_n0011(14)
    );
  FNC_2_4126 : LUT2
    generic map(
      INIT => X"4"
    )
    port map (
      I0 => INS_3_Q,
      I1 => Q_n0023(29),
      O => CHOICE2978
    );
  cpu_n0023_16_lut : LUT3_L
    generic map(
      INIT => X"96"
    )
    port map (
      I0 => Q_n0005,
      I1 => LFT(0),
      I2 => RGT(0),
      LO => N5
    );
  cpu_n0023_16_cy : MUXCY
    port map (
      CI => Q_n0005,
      DI => LFT(0),
      S => N5,
      O => cpu_n0023_16_cyo
    );
  cpu_n0023_16_xor : XORCY
    port map (
      CI => Q_n0005,
      LI => N5,
      O => Q_n0023(16)
    );
  cpu_n0023_17_lut : LUT3_L
    generic map(
      INIT => X"96"
    )
    port map (
      I0 => Q_n0005,
      I1 => LFT(1),
      I2 => RGT(1),
      LO => N6
    );
  cpu_n0023_17_cy : MUXCY
    port map (
      CI => cpu_n0023_16_cyo,
      DI => LFT(1),
      S => N6,
      O => cpu_n0023_17_cyo
    );
  cpu_n0023_17_xor : XORCY
    port map (
      CI => cpu_n0023_16_cyo,
      LI => N6,
      O => Q_n0023(17)
    );
  cpu_n0023_18_lut : LUT3_L
    generic map(
      INIT => X"96"
    )
    port map (
      I0 => Q_n0005,
      I1 => LFT(2),
      I2 => RGT(2),
      LO => N7
    );
  cpu_n0023_18_cy : MUXCY
    port map (
      CI => cpu_n0023_17_cyo,
      DI => LFT(2),
      S => N7,
      O => cpu_n0023_18_cyo
    );
  cpu_n0023_18_xor : XORCY
    port map (
      CI => cpu_n0023_17_cyo,
      LI => N7,
      O => Q_n0023(18)
    );
  cpu_n0023_19_lut : LUT3_L
    generic map(
      INIT => X"96"
    )
    port map (
      I0 => Q_n0005,
      I1 => LFT(3),
      I2 => RGT(3),
      LO => N8
    );
  cpu_n0023_19_cy : MUXCY
    port map (
      CI => cpu_n0023_18_cyo,
      DI => LFT(3),
      S => N8,
      O => cpu_n0023_19_cyo
    );
  cpu_n0023_19_xor : XORCY
    port map (
      CI => cpu_n0023_18_cyo,
      LI => N8,
      O => Q_n0023(19)
    );
  cpu_n0023_20_lut : LUT3_L
    generic map(
      INIT => X"96"
    )
    port map (
      I0 => RGT(4),
      I1 => Q_n0005,
      I2 => LFT(4),
      LO => N9
    );
  cpu_n0023_20_cy : MUXCY
    port map (
      CI => cpu_n0023_19_cyo,
      DI => LFT(4),
      S => N9,
      O => cpu_n0023_20_cyo
    );
  cpu_n0023_20_xor : XORCY
    port map (
      CI => cpu_n0023_19_cyo,
      LI => N9,
      O => Q_n0023(20)
    );
  cpu_n0023_21_lut : LUT3_L
    generic map(
      INIT => X"96"
    )
    port map (
      I0 => RGT(5),
      I1 => Q_n0005,
      I2 => LFT(5),
      LO => N10
    );
  cpu_n0023_21_cy : MUXCY
    port map (
      CI => cpu_n0023_20_cyo,
      DI => LFT(5),
      S => N10,
      O => cpu_n0023_21_cyo
    );
  cpu_n0023_21_xor : XORCY
    port map (
      CI => cpu_n0023_20_cyo,
      LI => N10,
      O => Q_n0023(21)
    );
  cpu_n0023_22_lut : LUT3_L
    generic map(
      INIT => X"96"
    )
    port map (
      I0 => RGT(6),
      I1 => Q_n0005,
      I2 => LFT(6),
      LO => N11
    );
  cpu_n0023_22_cy : MUXCY
    port map (
      CI => cpu_n0023_21_cyo,
      DI => LFT(6),
      S => N11,
      O => cpu_n0023_22_cyo
    );
  cpu_n0023_22_xor : XORCY
    port map (
      CI => cpu_n0023_21_cyo,
      LI => N11,
      O => Q_n0023(22)
    );
  cpu_n0023_23_lut : LUT3_L
    generic map(
      INIT => X"96"
    )
    port map (
      I0 => RGT(7),
      I1 => Q_n0005,
      I2 => LFT(7),
      LO => N12
    );
  cpu_n0023_23_cy : MUXCY
    port map (
      CI => cpu_n0023_22_cyo,
      DI => LFT(7),
      S => N12,
      O => cpu_n0023_23_cyo
    );
  cpu_n0023_23_xor : XORCY
    port map (
      CI => cpu_n0023_22_cyo,
      LI => N12,
      O => Q_n0023(23)
    );
  cpu_n0023_24_lut : LUT3_L
    generic map(
      INIT => X"96"
    )
    port map (
      I0 => RGT(8),
      I1 => Q_n0005,
      I2 => LFT(8),
      LO => N13
    );
  cpu_n0023_24_cy : MUXCY
    port map (
      CI => cpu_n0023_23_cyo,
      DI => LFT(8),
      S => N13,
      O => cpu_n0023_24_cyo
    );
  cpu_n0023_24_xor : XORCY
    port map (
      CI => cpu_n0023_23_cyo,
      LI => N13,
      O => Q_n0023(24)
    );
  cpu_n0023_25_lut : LUT3_L
    generic map(
      INIT => X"96"
    )
    port map (
      I0 => RGT(9),
      I1 => Q_n0005,
      I2 => LFT(9),
      LO => N14
    );
  cpu_n0023_25_cy : MUXCY
    port map (
      CI => cpu_n0023_24_cyo,
      DI => LFT(9),
      S => N14,
      O => cpu_n0023_25_cyo
    );
  cpu_n0023_25_xor : XORCY
    port map (
      CI => cpu_n0023_24_cyo,
      LI => N14,
      O => Q_n0023(25)
    );
  cpu_n0023_26_lut : LUT3_L
    generic map(
      INIT => X"96"
    )
    port map (
      I0 => RGT(10),
      I1 => Q_n0005,
      I2 => LFT(10),
      LO => N15
    );
  cpu_n0023_26_cy : MUXCY
    port map (
      CI => cpu_n0023_25_cyo,
      DI => LFT(10),
      S => N15,
      O => cpu_n0023_26_cyo
    );
  cpu_n0023_26_xor : XORCY
    port map (
      CI => cpu_n0023_25_cyo,
      LI => N15,
      O => Q_n0023(26)
    );
  cpu_n0023_27_lut : LUT3_L
    generic map(
      INIT => X"96"
    )
    port map (
      I0 => RGT(11),
      I1 => Q_n0005,
      I2 => LFT(11),
      LO => N16
    );
  cpu_n0023_27_cy : MUXCY
    port map (
      CI => cpu_n0023_26_cyo,
      DI => LFT(11),
      S => N16,
      O => cpu_n0023_27_cyo
    );
  cpu_n0023_27_xor : XORCY
    port map (
      CI => cpu_n0023_26_cyo,
      LI => N16,
      O => Q_n0023(27)
    );
  cpu_n0023_28_lut : LUT3_L
    generic map(
      INIT => X"96"
    )
    port map (
      I0 => RGT(12),
      I1 => Q_n0005,
      I2 => LFT(12),
      LO => N17
    );
  cpu_n0023_28_cy : MUXCY
    port map (
      CI => cpu_n0023_27_cyo,
      DI => LFT(12),
      S => N17,
      O => cpu_n0023_28_cyo
    );
  cpu_n0023_28_xor : XORCY
    port map (
      CI => cpu_n0023_27_cyo,
      LI => N17,
      O => Q_n0023(28)
    );
  cpu_n0023_29_lut : LUT3_L
    generic map(
      INIT => X"96"
    )
    port map (
      I0 => LFT(13),
      I1 => RGT(13),
      I2 => Q_n0005,
      LO => N18
    );
  cpu_n0023_29_cy : MUXCY
    port map (
      CI => cpu_n0023_28_cyo,
      DI => LFT(13),
      S => N18,
      O => cpu_n0023_29_cyo
    );
  cpu_n0023_29_xor : XORCY
    port map (
      CI => cpu_n0023_28_cyo,
      LI => N18,
      O => Q_n0023(29)
    );
  cpu_n0023_30_lut : LUT3_L
    generic map(
      INIT => X"96"
    )
    port map (
      I0 => LFT(14),
      I1 => RGT(14),
      I2 => Q_n0005,
      LO => N19
    );
  cpu_n0023_30_cy : MUXCY
    port map (
      CI => cpu_n0023_29_cyo,
      DI => LFT(14),
      S => N19,
      O => cpu_n0023_30_cyo
    );
  cpu_n0023_30_xor : XORCY
    port map (
      CI => cpu_n0023_29_cyo,
      LI => N19,
      O => Q_n0023(30)
    );
  cpu_n0023_31_lut : LUT3_L
    generic map(
      INIT => X"96"
    )
    port map (
      I0 => LFT(15),
      I1 => RGT(15),
      I2 => Q_n0005,
      LO => N20
    );
  AA_16_OBUF : OBUF
    port map (
      I => CEA2X_OBUF,
      O => AA(16)
    );
  FNC_2_1471 : LUT4
    generic map(
      INIT => X"0002"
    )
    port map (
      I0 => LFT(0),
      I1 => RGT(0),
      I2 => RGT(1),
      I3 => N1670,
      O => CHOICE2886
    );
  FNC_2_752_SW0_SW1 : LUT4
    generic map(
      INIT => X"DDCD"
    )
    port map (
      I0 => INS_2_Q,
      I1 => RGT(3),
      I2 => Mshift_n0008_Sh(1),
      I3 => RGT(2),
      O => N1587
    );
  FNC_2_631_G : LUT4_L
    generic map(
      INIT => X"5140"
    )
    port map (
      I0 => RGT(2),
      I1 => RGT(1),
      I2 => LFT(12),
      I3 => LFT(14),
      LO => N1785
    );
  Mshift_n0009_Sh_13_1 : LUT4
    generic map(
      INIT => X"22F0"
    )
    port map (
      I0 => LFT(14),
      I1 => RGT(1),
      I2 => N1792,
      I3 => RGT(0),
      O => Mshift_n0009_Sh(13)
    );
  IOA_11_IBUF_18 : IBUF
    port map (
      I => IOA(11),
      O => IOA_11_IBUF
    );
  FNC_2_14 : LUT4_L
    generic map(
      INIT => X"A820"
    )
    port map (
      I0 => RGT(2),
      I1 => RGT(0),
      I2 => N29,
      I3 => N171,
      LO => CHOICE3085
    );
  FNC_2_659 : LUT4
    generic map(
      INIT => X"F3F2"
    )
    port map (
      I0 => CHOICE3127,
      I1 => RGT(3),
      I2 => CHOICE3119,
      I3 => CHOICE3120,
      O => CHOICE3131
    );
  LED_5_OBUF_19 : OBUF
    port map (
      I => LED_5_OBUF,
      O => LED(5)
    );
  FNC_2_7155 : LUT4
    generic map(
      INIT => X"DDD8"
    )
    port map (
      I0 => INS_5_Q,
      I1 => MUX_BLOCK_FNC_1_MUXF57,
      I2 => CHOICE3042,
      I3 => N1789,
      O => ACCUM(1)
    );
  LED_7_OBUF_20 : OBUF
    port map (
      I => LED_7_OBUF,
      O => LED(7)
    );
  LED_4_OBUF_21 : OBUF
    port map (
      I => LED_4_OBUF,
      O => LED(4)
    );
  FNC_2_5111_SW0 : LUT4_L
    generic map(
      INIT => X"1FBF"
    )
    port map (
      I0 => RGT(2),
      I1 => Mshift_n0008_Sh(6),
      I2 => RGT(3),
      I3 => Mshift_n0008_Sh(2),
      LO => N1596
    );
  FNC_2_6121 : LUT4_L
    generic map(
      INIT => X"DC00"
    )
    port map (
      I0 => INS_2_Q,
      I1 => CHOICE3141,
      I2 => CHOICE3131,
      I3 => N114,
      LO => CHOICE3143
    );
  FNC_2_591 : LUT4
    generic map(
      INIT => X"F3F2"
    )
    port map (
      I0 => CHOICE3092,
      I1 => RGT(3),
      I2 => CHOICE3084,
      I3 => CHOICE3085,
      O => CHOICE3096
    );
  Ker281 : LUT3_D
    generic map(
      INIT => X"AC"
    )
    port map (
      I0 => LFT(4),
      I1 => LFT(2),
      I2 => RGT(1),
      LO => N1790,
      O => N28
    );
  AA_14_OBUF_22 : OBUF
    port map (
      I => AA_14_OBUF,
      O => AA(14)
    );
  CLKMA0_OBUF : OBUF
    port map (
      I => CLKMA1_OBUF,
      O => CLKMA0
    );
  FNC_2_7122 : LUT2
    generic map(
      INIT => X"4"
    )
    port map (
      I0 => INS_3_Q,
      I1 => Q_n0023(17),
      O => CHOICE3042
    );
  IOA_3_IBUF_23 : IBUF
    port map (
      I => IOA(3),
      O => IOA_3_IBUF
    );
  CUR_14_rt_24 : LUT1
    generic map(
      INIT => X"2"
    )
    port map (
      I0 => CUR(14),
      O => CUR_14_rt
    );
  FNC_2_9139 : LUT4
    generic map(
      INIT => X"DDD8"
    )
    port map (
      I0 => INS_5_Q,
      I1 => MUX_BLOCK_FNC_1_MUXF59,
      I2 => CHOICE2946,
      I3 => N1800,
      O => ACCUM(3)
    );
  FNC_2_973 : LUT4
    generic map(
      INIT => X"0010"
    )
    port map (
      I0 => INS_2_Q,
      I1 => RGT(3),
      I2 => Mshift_n0008_Sh(3),
      I3 => RGT(2),
      O => CHOICE2942
    );
  LED_3_OBUF_25 : OBUF
    port map (
      I => LED_3_OBUF,
      O => LED(3)
    );
  CUR_13_rt_26 : LUT1
    generic map(
      INIT => X"2"
    )
    port map (
      I0 => CUR(13),
      O => CUR_13_rt
    );
  CUR_12_rt_27 : LUT1
    generic map(
      INIT => X"2"
    )
    port map (
      I0 => CUR(12),
      O => CUR_12_rt
    );
  CUR_11_rt_28 : LUT1
    generic map(
      INIT => X"2"
    )
    port map (
      I0 => CUR(11),
      O => CUR_11_rt
    );
  Ker231 : LUT3
    generic map(
      INIT => X"AC"
    )
    port map (
      I0 => LFT(4),
      I1 => LFT(6),
      I2 => RGT(1),
      O => N23
    );
  AA_17_OBUF : OBUF
    port map (
      I => CEA2X_OBUF,
      O => AA(17)
    );
  Mram_REG_ren_inst_ramx1d_28 : RAM16X1D
    port map (
      A0 => INS_21_Q,
      A1 => INS_22_Q,
      A2 => INS_23_Q,
      A3 => INS_24_Q,
      D => ACCUM(12),
      DPRA0 => INS_11_Q,
      DPRA1 => INS_12_Q,
      DPRA2 => INS_13_Q,
      DPRA3 => INS_14_Q,
      WCLK => CLK_BUFGP,
      WE => Q_n0003,
      SPO => NLW_Mram_REG_ren_inst_ramx1d_28_SPO_UNCONNECTED,
      DPO => RGT(12)
    );
  CUR_10_rt_29 : LUT1
    generic map(
      INIT => X"2"
    )
    port map (
      I0 => CUR(10),
      O => CUR_10_rt
    );
  CUR_9_rt_30 : LUT1
    generic map(
      INIT => X"2"
    )
    port map (
      I0 => CUR(9),
      O => CUR_9_rt
    );
  CUR_8_rt_31 : LUT1
    generic map(
      INIT => X"2"
    )
    port map (
      I0 => CUR(8),
      O => CUR_8_rt
    );
  FNC_2_890 : LUT4
    generic map(
      INIT => X"0010"
    )
    port map (
      I0 => INS_2_Q,
      I1 => RGT(3),
      I2 => Mshift_n0008_Sh(2),
      I3 => RGT(2),
      O => CHOICE3070
    );
  Mram_REG_ren_inst_ramx1d_25 : RAM16X1D
    port map (
      A0 => INS_21_Q,
      A1 => INS_22_Q,
      A2 => INS_23_Q,
      A3 => INS_24_Q,
      D => ACCUM(9),
      DPRA0 => INS_11_Q,
      DPRA1 => INS_12_Q,
      DPRA2 => INS_13_Q,
      DPRA3 => INS_14_Q,
      WCLK => CLK_BUFGP,
      WE => Q_n0003,
      SPO => NLW_Mram_REG_ren_inst_ramx1d_25_SPO_UNCONNECTED,
      DPO => RGT(9)
    );
  Mram_REG_ren_inst_ramx1d_24 : RAM16X1D
    port map (
      A0 => INS_21_Q,
      A1 => INS_22_Q,
      A2 => INS_23_Q,
      A3 => INS_24_Q,
      D => ACCUM(8),
      DPRA0 => INS_11_Q,
      DPRA1 => INS_12_Q,
      DPRA2 => INS_13_Q,
      DPRA3 => INS_14_Q,
      WCLK => CLK_BUFGP,
      WE => Q_n0003,
      SPO => NLW_Mram_REG_ren_inst_ramx1d_24_SPO_UNCONNECTED,
      DPO => RGT(8)
    );
  CUR_7_rt_32 : LUT1
    generic map(
      INIT => X"2"
    )
    port map (
      I0 => CUR(7),
      O => CUR_7_rt
    );
  CUR_6_rt_33 : LUT1
    generic map(
      INIT => X"2"
    )
    port map (
      I0 => CUR(6),
      O => CUR_6_rt
    );
  CUR_5_rt_34 : LUT1
    generic map(
      INIT => X"2"
    )
    port map (
      I0 => CUR(5),
      O => CUR_5_rt
    );
  FNC_2_6169 : LUT4
    generic map(
      INIT => X"DDD8"
    )
    port map (
      I0 => INS_5_Q,
      I1 => MUX_BLOCK_FNC_1_MUXF56,
      I2 => CHOICE3145,
      I3 => CHOICE3143,
      O => ACCUM(15)
    );
  Mram_REG_ren_inst_ramx1d_21 : RAM16X1D
    port map (
      A0 => INS_21_Q,
      A1 => INS_22_Q,
      A2 => INS_23_Q,
      A3 => INS_24_Q,
      D => ACCUM(5),
      DPRA0 => INS_11_Q,
      DPRA1 => INS_12_Q,
      DPRA2 => INS_13_Q,
      DPRA3 => INS_14_Q,
      WCLK => CLK_BUFGP,
      WE => Q_n0003,
      SPO => NLW_Mram_REG_ren_inst_ramx1d_21_SPO_UNCONNECTED,
      DPO => RGT(5)
    );
  Mram_REG_ren_inst_ramx1d_20 : RAM16X1D
    port map (
      A0 => INS_21_Q,
      A1 => INS_22_Q,
      A2 => INS_23_Q,
      A3 => INS_24_Q,
      D => ACCUM(4),
      DPRA0 => INS_11_Q,
      DPRA1 => INS_12_Q,
      DPRA2 => INS_13_Q,
      DPRA3 => INS_14_Q,
      WCLK => CLK_BUFGP,
      WE => Q_n0003,
      SPO => NLW_Mram_REG_ren_inst_ramx1d_20_SPO_UNCONNECTED,
      DPO => RGT(4)
    );
  CUR_4_rt_35 : LUT1
    generic map(
      INIT => X"2"
    )
    port map (
      I0 => CUR(4),
      O => CUR_4_rt
    );
  CUR_3_rt_36 : LUT1
    generic map(
      INIT => X"2"
    )
    port map (
      I0 => CUR(3),
      O => CUR_3_rt
    );
  CUR_2_rt_37 : LUT1
    generic map(
      INIT => X"2"
    )
    port map (
      I0 => CUR(2),
      O => CUR_2_rt
    );
  FNC_2_353 : LUT4
    generic map(
      INIT => X"F5E4"
    )
    port map (
      I0 => RGT(3),
      I1 => CHOICE2902,
      I2 => N87,
      I3 => CHOICE2908,
      O => CHOICE2912
    );
  Mram_REG_ren_inst_ramx1d_17 : RAM16X1D
    port map (
      A0 => INS_21_Q,
      A1 => INS_22_Q,
      A2 => INS_23_Q,
      A3 => INS_24_Q,
      D => ACCUM(1),
      DPRA0 => INS_11_Q,
      DPRA1 => INS_12_Q,
      DPRA2 => INS_13_Q,
      DPRA3 => INS_14_Q,
      WCLK => CLK_BUFGP,
      WE => Q_n0003,
      SPO => NLW_Mram_REG_ren_inst_ramx1d_17_SPO_UNCONNECTED,
      DPO => RGT(1)
    );
  Mram_REG_ren_inst_ramx1d_16 : RAM16X1D
    port map (
      A0 => INS_21_Q,
      A1 => INS_22_Q,
      A2 => INS_23_Q,
      A3 => INS_24_Q,
      D => ACCUM(0),
      DPRA0 => INS_11_Q,
      DPRA1 => INS_12_Q,
      DPRA2 => INS_13_Q,
      DPRA3 => INS_14_Q,
      WCLK => CLK_BUFGP,
      WE => Q_n0003,
      SPO => NLW_Mram_REG_ren_inst_ramx1d_16_SPO_UNCONNECTED,
      DPO => RGT(0)
    );
  CUR_1_rt_38 : LUT1
    generic map(
      INIT => X"2"
    )
    port map (
      I0 => CUR(1),
      O => CUR_1_rt
    );
  BWA_0_OBUF : OBUF
    port map (
      I => CEA2_OBUF,
      O => BWA(0)
    );
  BWA_1_OBUF : OBUF
    port map (
      I => CEA2_OBUF,
      O => BWA(1)
    );
  FNC_2_8156 : LUT4
    generic map(
      INIT => X"DDD8"
    )
    port map (
      I0 => INS_5_Q,
      I1 => MUX_BLOCK_FNC_1_MUXF58,
      I2 => CHOICE3074,
      I3 => N1794,
      O => ACCUM(2)
    );
  Mram_REG_inst_ramx1d_12 : RAM16X1D
    port map (
      A0 => INS_21_Q,
      A1 => INS_22_Q,
      A2 => INS_23_Q,
      A3 => INS_24_Q,
      D => ACCUM(12),
      DPRA0 => INS_16_Q,
      DPRA1 => INS_17_Q,
      DPRA2 => INS_18_Q,
      DPRA3 => INS_19_Q,
      WCLK => CLK_BUFGP,
      WE => Q_n0003,
      SPO => NLW_Mram_REG_inst_ramx1d_12_SPO_UNCONNECTED,
      DPO => LFT(12)
    );
  Mram_REG_inst_ramx1d_11 : RAM16X1D
    port map (
      A0 => INS_21_Q,
      A1 => INS_22_Q,
      A2 => INS_23_Q,
      A3 => INS_24_Q,
      D => ACCUM(11),
      DPRA0 => INS_16_Q,
      DPRA1 => INS_17_Q,
      DPRA2 => INS_18_Q,
      DPRA3 => INS_19_Q,
      WCLK => CLK_BUFGP,
      WE => Q_n0003,
      SPO => NLW_Mram_REG_inst_ramx1d_11_SPO_UNCONNECTED,
      DPO => LFT(11)
    );
  BWA_2_OBUF : OBUF
    port map (
      I => CEA2_OBUF,
      O => BWA(2)
    );
  BWA_3_OBUF : OBUF
    port map (
      I => CEA2_OBUF,
      O => BWA(3)
    );
  AA_0_OBUF_39 : OBUF
    port map (
      I => AA_0_OBUF,
      O => AA(0)
    );
  FNC_2_10113 : LUT4
    generic map(
      INIT => X"DDD8"
    )
    port map (
      I0 => INS_5_Q,
      I1 => MUX_BLOCK_FNC_1_MUXF510,
      I2 => CHOICE2720,
      I3 => N1796,
      O => ACCUM(4)
    );
  Mram_REG_inst_ramx1d_8 : RAM16X1D
    port map (
      A0 => INS_21_Q,
      A1 => INS_22_Q,
      A2 => INS_23_Q,
      A3 => INS_24_Q,
      D => ACCUM(8),
      DPRA0 => INS_16_Q,
      DPRA1 => INS_17_Q,
      DPRA2 => INS_18_Q,
      DPRA3 => INS_19_Q,
      WCLK => CLK_BUFGP,
      WE => Q_n0003,
      SPO => NLW_Mram_REG_inst_ramx1d_8_SPO_UNCONNECTED,
      DPO => LFT(8)
    );
  Mram_REG_inst_ramx1d_7 : RAM16X1D
    port map (
      A0 => INS_21_Q,
      A1 => INS_22_Q,
      A2 => INS_23_Q,
      A3 => INS_24_Q,
      D => ACCUM(7),
      DPRA0 => INS_16_Q,
      DPRA1 => INS_17_Q,
      DPRA2 => INS_18_Q,
      DPRA3 => INS_19_Q,
      WCLK => CLK_BUFGP,
      WE => Q_n0003,
      SPO => NLW_Mram_REG_inst_ramx1d_7_SPO_UNCONNECTED,
      DPO => LFT(7)
    );
  AA_1_OBUF_40 : OBUF
    port map (
      I => AA_1_OBUF,
      O => AA(1)
    );
  AA_2_OBUF_41 : OBUF
    port map (
      I => AA_2_OBUF,
      O => AA(2)
    );
  AA_3_OBUF_42 : OBUF
    port map (
      I => AA_3_OBUF,
      O => AA(3)
    );
  Ker241 : LUT3
    generic map(
      INIT => X"CA"
    )
    port map (
      I0 => LFT(10),
      I1 => LFT(8),
      I2 => RGT(1),
      O => N24
    );
  Mram_REG_inst_ramx1d_4 : RAM16X1D
    port map (
      A0 => INS_21_Q,
      A1 => INS_22_Q,
      A2 => INS_23_Q,
      A3 => INS_24_Q,
      D => ACCUM(4),
      DPRA0 => INS_16_Q,
      DPRA1 => INS_17_Q,
      DPRA2 => INS_18_Q,
      DPRA3 => INS_19_Q,
      WCLK => CLK_BUFGP,
      WE => Q_n0003,
      SPO => NLW_Mram_REG_inst_ramx1d_4_SPO_UNCONNECTED,
      DPO => LFT(4)
    );
  Mram_REG_inst_ramx1d_3 : RAM16X1D
    port map (
      A0 => INS_21_Q,
      A1 => INS_22_Q,
      A2 => INS_23_Q,
      A3 => INS_24_Q,
      D => ACCUM(3),
      DPRA0 => INS_16_Q,
      DPRA1 => INS_17_Q,
      DPRA2 => INS_18_Q,
      DPRA3 => INS_19_Q,
      WCLK => CLK_BUFGP,
      WE => Q_n0003,
      SPO => NLW_Mram_REG_inst_ramx1d_3_SPO_UNCONNECTED,
      DPO => LFT(3)
    );
  AA_4_OBUF_43 : OBUF
    port map (
      I => AA_4_OBUF,
      O => AA(4)
    );
  AA_5_OBUF_44 : OBUF
    port map (
      I => AA_5_OBUF,
      O => AA(5)
    );
  AA_6_OBUF_45 : OBUF
    port map (
      I => AA_6_OBUF,
      O => AA(6)
    );
  FNC_2_11132 : LUT4
    generic map(
      INIT => X"DDD8"
    )
    port map (
      I0 => INS_5_Q,
      I1 => MUX_BLOCK_FNC_1_MUXF511,
      I2 => CHOICE2747,
      I3 => N1797,
      O => ACCUM(5)
    );
  Mram_REG_inst_ramx1d_0 : RAM16X1D
    port map (
      A0 => INS_21_Q,
      A1 => INS_22_Q,
      A2 => INS_23_Q,
      A3 => INS_24_Q,
      D => ACCUM(0),
      DPRA0 => INS_16_Q,
      DPRA1 => INS_17_Q,
      DPRA2 => INS_18_Q,
      DPRA3 => INS_19_Q,
      WCLK => CLK_BUFGP,
      WE => Q_n0003,
      SPO => NLW_Mram_REG_inst_ramx1d_0_SPO_UNCONNECTED,
      DPO => LFT(0)
    );
  Mram_REG_inst_ramx1d_15 : RAM16X1D
    port map (
      A0 => INS_21_Q,
      A1 => INS_22_Q,
      A2 => INS_23_Q,
      A3 => INS_24_Q,
      D => ACCUM(15),
      DPRA0 => INS_16_Q,
      DPRA1 => INS_17_Q,
      DPRA2 => INS_18_Q,
      DPRA3 => INS_19_Q,
      WCLK => CLK_BUFGP,
      WE => Q_n0003,
      SPO => NLW_Mram_REG_inst_ramx1d_15_SPO_UNCONNECTED,
      DPO => LFT(15)
    );
  AA_7_OBUF_46 : OBUF
    port map (
      I => AA_7_OBUF,
      O => AA(7)
    );
  AA_8_OBUF_47 : OBUF
    port map (
      I => AA_8_OBUF,
      O => AA(8)
    );
  AA_9_OBUF_48 : OBUF
    port map (
      I => AA_9_OBUF,
      O => AA(9)
    );
  Ker291 : LUT3_D
    generic map(
      INIT => X"CA"
    )
    port map (
      I0 => LFT(4),
      I1 => LFT(6),
      I2 => RGT(1),
      LO => N1791,
      O => N29
    );
  AA_10_OBUF_49 : OBUF
    port map (
      I => AA_10_OBUF,
      O => AA(10)
    );
  FNC_2_688 : LUT2_L
    generic map(
      INIT => X"2"
    )
    port map (
      I0 => LFT(15),
      I1 => RGT(1),
      LO => CHOICE3135
    );
  AA_11_OBUF_50 : OBUF
    port map (
      I => AA_11_OBUF,
      O => AA(11)
    );
  AA_12_OBUF_51 : OBUF
    port map (
      I => AA_12_OBUF,
      O => AA(12)
    );
  AA_13_OBUF_52 : OBUF
    port map (
      I => AA_13_OBUF,
      O => AA(13)
    );
  Ker351 : LUT3
    generic map(
      INIT => X"AC"
    )
    port map (
      I0 => LFT(14),
      I1 => LFT(12),
      I2 => RGT(1),
      O => N35
    );
  FNC_2_4161 : LUT4
    generic map(
      INIT => X"DDD8"
    )
    port map (
      I0 => INS_5_Q,
      I1 => MUX_BLOCK_FNC_1_MUXF54,
      I2 => CHOICE2978,
      I3 => CHOICE2976,
      O => ACCUM(13)
    );
  FNC_2_917 : LUT4
    generic map(
      INIT => X"5140"
    )
    port map (
      I0 => RGT(2),
      I1 => RGT(0),
      I2 => N1791,
      I3 => N67,
      O => CHOICE2931
    );
  FNC_2_14144 : LUT4
    generic map(
      INIT => X"DDD8"
    )
    port map (
      I0 => INS_5_Q,
      I1 => MUX_BLOCK_FNC_1_MUXF514,
      I2 => CHOICE2890,
      I3 => CHOICE2888,
      O => ACCUM(8)
    );
  Ker661 : LUT3
    generic map(
      INIT => X"CA"
    )
    port map (
      I0 => LFT(1),
      I1 => LFT(3),
      I2 => RGT(1),
      O => N66
    );
  FNC_2_1471_SW0 : LUT3_L
    generic map(
      INIT => X"FB"
    )
    port map (
      I0 => RGT(2),
      I1 => RGT(3),
      I2 => INS_2_Q,
      LO => N1670
    );
  AA_15_OBUF_53 : OBUF
    port map (
      I => AA_15_OBUF,
      O => AA(15)
    );
  Ker871_SW1 : LUT2
    generic map(
      INIT => X"E"
    )
    port map (
      I0 => RGT(3),
      I1 => INS_2_Q,
      O => N1567
    );
  Ker681 : LUT3
    generic map(
      INIT => X"CA"
    )
    port map (
      I0 => LFT(11),
      I1 => LFT(9),
      I2 => RGT(1),
      O => N68
    );
  FNC_2_3144 : LUT4
    generic map(
      INIT => X"DDD8"
    )
    port map (
      I0 => INS_5_Q,
      I1 => MUX_BLOCK_FNC_1_MUXF53,
      I2 => CHOICE2918,
      I3 => CHOICE2916,
      O => ACCUM(12)
    );
  FNC_2_2120 : LUT4
    generic map(
      INIT => X"DDD8"
    )
    port map (
      I0 => INS_5_Q,
      I1 => MUX_BLOCK_FNC_1_MUXF52,
      I2 => CHOICE2696,
      I3 => CHOICE2694,
      O => ACCUM(11)
    );
  FNC_2_13134 : LUT4
    generic map(
      INIT => X"DDD8"
    )
    port map (
      I0 => INS_5_Q,
      I1 => MUX_BLOCK_FNC_1_MUXF513,
      I2 => CHOICE2858,
      I3 => N1799,
      O => ACCUM(7)
    );
  Ker371 : LUT3
    generic map(
      INIT => X"AC"
    )
    port map (
      I0 => LFT(10),
      I1 => LFT(8),
      I2 => RGT(1),
      O => N37
    );
  FNC_2_11331 : LUT4
    generic map(
      INIT => X"DDD8"
    )
    port map (
      I0 => INS_5_Q,
      I1 => MUX_BLOCK_FNC_1_MUXF51,
      I2 => CHOICE2775,
      I3 => CHOICE2773,
      O => ACCUM(10)
    );
  Ker671 : LUT3
    generic map(
      INIT => X"CA"
    )
    port map (
      I0 => LFT(3),
      I1 => LFT(5),
      I2 => RGT(1),
      O => N67
    );
  Ker1151 : LUT2
    generic map(
      INIT => X"1"
    )
    port map (
      I0 => RGT(1),
      I1 => RGT(0),
      O => N115
    );
  Ker901 : LUT4_L
    generic map(
      INIT => X"B830"
    )
    port map (
      I0 => LFT(15),
      I1 => RGT(2),
      I2 => Mshift_n0009_Sh(11),
      I3 => N115,
      LO => N90
    );
  Ker161 : LUT3_D
    generic map(
      INIT => X"AC"
    )
    port map (
      I0 => LFT(15),
      I1 => LFT(13),
      I2 => RGT(1),
      LO => N1792,
      O => N161
    );
  Ker171 : LUT3
    generic map(
      INIT => X"CA"
    )
    port map (
      I0 => LFT(5),
      I1 => LFT(7),
      I2 => RGT(1),
      O => N171
    );
  Ker181 : LUT3
    generic map(
      INIT => X"AC"
    )
    port map (
      I0 => LFT(11),
      I1 => LFT(9),
      I2 => RGT(1),
      O => N181
    );
  Mshift_n0008_Sh_1_1 : LUT4_D
    generic map(
      INIT => X"00CA"
    )
    port map (
      I0 => LFT(1),
      I1 => LFT(0),
      I2 => RGT(0),
      I3 => RGT(1),
      LO => N1793,
      O => Mshift_n0008_Sh(1)
    );
  Ker871_SW0 : LUT4_L
    generic map(
      INIT => X"FFBF"
    )
    port map (
      I0 => INS_2_Q,
      I1 => LFT(0),
      I2 => N115,
      I3 => RGT(3),
      LO => N1566
    );
  FNC_2_8109 : LUT4_D
    generic map(
      INIT => X"A888"
    )
    port map (
      I0 => N114,
      I1 => CHOICE3070,
      I2 => INS_2_Q,
      I3 => CHOICE3063,
      LO => N1794,
      O => CHOICE3072
    );
  FNC_2_752_SW0_SW0 : LUT4
    generic map(
      INIT => X"FFEF"
    )
    port map (
      I0 => INS_2_Q,
      I1 => RGT(3),
      I2 => N1793,
      I3 => RGT(2),
      O => N1586
    );
  FNC_2_614 : LUT4_L
    generic map(
      INIT => X"A820"
    )
    port map (
      I0 => RGT(2),
      I1 => RGT(0),
      I2 => N68,
      I3 => N24,
      LO => CHOICE3120
    );
  Mshift_n0008_Sh_2_SW0 : LUT3_L
    generic map(
      INIT => X"53"
    )
    port map (
      I0 => LFT(1),
      I1 => LFT(2),
      I2 => RGT(0),
      LO => N186
    );
  FNC_2_5111 : LUT4
    generic map(
      INIT => X"C044"
    )
    port map (
      I0 => INS_2_Q,
      I1 => N114,
      I2 => N1579,
      I3 => N1596,
      O => CHOICE3008
    );
  AA_19_OBUF : OBUF
    port map (
      I => CEA2X_OBUF,
      O => AA(19)
    );
  Mshift_n0008_Sh_3_SW0 : LUT3
    generic map(
      INIT => X"AC"
    )
    port map (
      I0 => LFT(2),
      I1 => LFT(3),
      I2 => RGT(0),
      O => N191
    );
  Mshift_n0008_Sh_3_SW1 : LUT3
    generic map(
      INIT => X"CA"
    )
    port map (
      I0 => LFT(1),
      I1 => LFT(0),
      I2 => RGT(0),
      O => N192
    );
  FNC_2_852 : LUT4
    generic map(
      INIT => X"F5E4"
    )
    port map (
      I0 => RGT(3),
      I1 => CHOICE3053,
      I2 => N1574,
      I3 => CHOICE3059,
      O => CHOICE3063
    );
  LED_1_OBUF_54 : OBUF
    port map (
      I => LED_1_OBUF,
      O => LED(1)
    );
  FNC_2_1049 : LUT4
    generic map(
      INIT => X"02CE"
    )
    port map (
      I0 => Mshift_n0008_Sh(4),
      I1 => RGT(2),
      I2 => N1567,
      I3 => N1566,
      O => CHOICE2716
    );
  FNC_2_1282 : LUT3_D
    generic map(
      INIT => X"A8"
    )
    port map (
      I0 => N114,
      I1 => CHOICE2784,
      I2 => CHOICE2798,
      LO => N1795,
      O => CHOICE2800
    );
  IOA_12_IBUF_55 : IBUF
    port map (
      I => IOA(12),
      O => IOA_12_IBUF
    );
  FNC_2_940 : LUT4
    generic map(
      INIT => X"F5E4"
    )
    port map (
      I0 => RGT(3),
      I1 => CHOICE2925,
      I2 => N90,
      I3 => CHOICE2931,
      O => CHOICE2935
    );
  FNC_2_861 : LUT2_L
    generic map(
      INIT => X"2"
    )
    port map (
      I0 => LFT(0),
      I1 => RGT(1),
      LO => CHOICE3099
    );
  FNC_2_3109 : LUT2
    generic map(
      INIT => X"4"
    )
    port map (
      I0 => INS_3_Q,
      I1 => Q_n0023(28),
      O => CHOICE2918
    );
  Ker11457_SW0 : LUT4_L
    generic map(
      INIT => X"FFFD"
    )
    port map (
      I0 => INS_3_2,
      I1 => RGT(6),
      I2 => RGT(14),
      I3 => RGT(7),
      LO => N1594
    );
  FNC_2_4111 : LUT4_L
    generic map(
      INIT => X"CC40"
    )
    port map (
      I0 => INS_2_Q,
      I1 => N114,
      I2 => CHOICE2972,
      I3 => CHOICE2956,
      LO => CHOICE2976
    );
  Ker11444 : LUT4
    generic map(
      INIT => X"0001"
    )
    port map (
      I0 => RGT(11),
      I1 => RGT(10),
      I2 => RGT(9),
      I3 => RGT(8),
      O => CHOICE2674
    );
  Ker901_SW0 : LUT4_L
    generic map(
      INIT => X"FF7F"
    )
    port map (
      I0 => INS_2_Q,
      I1 => LFT(15),
      I2 => N115,
      I3 => RGT(3),
      LO => N1569
    );
  INS_2_1_56 : FD
    port map (
      D => IOA_2_IBUF,
      C => CLK_BUFGP,
      Q => INS_2_1
    );
  FNC_2_411 : LUT4
    generic map(
      INIT => X"0020"
    )
    port map (
      I0 => INS_2_Q,
      I1 => RGT(2),
      I2 => Mshift_n0009_Sh(13),
      I3 => RGT(3),
      O => CHOICE2956
    );
  LED_2_OBUF_57 : OBUF
    port map (
      I => LED_2_OBUF,
      O => LED(2)
    );
  FNC_2_1066 : LUT4_D
    generic map(
      INIT => X"A888"
    )
    port map (
      I0 => N114,
      I1 => CHOICE2716,
      I2 => INS_2_Q,
      I3 => N1582,
      LO => N1796,
      O => CHOICE2718
    );
  ADVLDA_OBUF : OBUF
    port map (
      I => CEA2X_OBUF,
      O => ADVLDA
    );
  FNC_2_13100 : LUT2
    generic map(
      INIT => X"4"
    )
    port map (
      I0 => INS_3_Q,
      I1 => Q_n0023(23),
      O => CHOICE2858
    );
  FNC_2_15111 : LUT4
    generic map(
      INIT => X"0020"
    )
    port map (
      I0 => RGT(3),
      I1 => INS_2_Q,
      I2 => Mshift_n0008_Sh(1),
      I3 => RGT(2),
      O => CHOICE2812
    );
  INS_3_1_58 : FD
    port map (
      D => IOA_3_IBUF,
      C => CLK_BUFGP,
      Q => INS_3_1
    );
  FNC_2_7108_SW0 : LUT4
    generic map(
      INIT => X"A820"
    )
    port map (
      I0 => RGT(3),
      I1 => RGT(2),
      I2 => Mshift_n0009_Sh(9),
      I3 => Mshift_n0009_Sh(13),
      O => N1672
    );
  OEAX_OBUF : OBUF
    port map (
      I => CEA2X_OBUF,
      O => OEAX
    );
  FNC_2_1598 : LUT2
    generic map(
      INIT => X"4"
    )
    port map (
      I0 => INS_3_Q,
      I1 => Q_n0023(25),
      O => CHOICE2830
    );
  FNC_2_9106 : LUT2
    generic map(
      INIT => X"4"
    )
    port map (
      I0 => INS_3_Q,
      I1 => Q_n0023(19),
      O => CHOICE2946
    );
  FNC_2_729 : LUT4_L
    generic map(
      INIT => X"5140"
    )
    port map (
      I0 => RGT(2),
      I1 => RGT(0),
      I2 => N28,
      I3 => N66,
      LO => CHOICE3027
    );
  FNC_2_163 : LUT4
    generic map(
      INIT => X"DDD8"
    )
    port map (
      I0 => INS_5_Q,
      I1 => MUX_BLOCK_FNC_1_MUXF5,
      I2 => CHOICE3109,
      I3 => N1798,
      O => ACCUM(0)
    );
  LBOA_OBUF : OBUF
    port map (
      I => CEA2_OBUF,
      O => LBOA
    );
  FNC_2_11110 : LUT4
    generic map(
      INIT => X"0020"
    )
    port map (
      I0 => RGT(3),
      I1 => INS_2_Q,
      I2 => Mshift_n0008_Sh(2),
      I3 => RGT(2),
      O => CHOICE2757
    );
  FNC_2_241_SW0 : LUT2
    generic map(
      INIT => X"1"
    )
    port map (
      I0 => CHOICE2683,
      I1 => CHOICE2689,
      O => N1584
    );
  FNC_2_8123 : LUT2
    generic map(
      INIT => X"4"
    )
    port map (
      I0 => INS_3_Q,
      I1 => Q_n0023(18),
      O => CHOICE3074
    );
  FNC_2_1081 : LUT2
    generic map(
      INIT => X"4"
    )
    port map (
      I0 => INS_3_Q,
      I1 => Q_n0023(20),
      O => CHOICE2720
    );
  FNC_2_1198 : LUT2
    generic map(
      INIT => X"4"
    )
    port map (
      I0 => INS_3_Q,
      I1 => Q_n0023(21),
      O => CHOICE2747
    );
  FNC_2_1583 : LUT3_L
    generic map(
      INIT => X"A8"
    )
    port map (
      I0 => N114,
      I1 => CHOICE2812,
      I2 => CHOICE2826,
      LO => CHOICE2828
    );
  FNC_2_26 : LUT4
    generic map(
      INIT => X"02CE"
    )
    port map (
      I0 => Mshift_n0009_Sh(11),
      I1 => RGT(2),
      I2 => N1570,
      I3 => N1569,
      O => CHOICE2680
    );
  IOA_13_IBUF_59 : IBUF
    port map (
      I => IOA(13),
      O => IOA_13_IBUF
    );
  IOA_27_IBUF_60 : IBUF
    port map (
      I => IOA(27),
      O => IOA_27_IBUF
    );
  FNC_2_1035_SW0 : LUT3
    generic map(
      INIT => X"DC"
    )
    port map (
      I0 => RGT(3),
      I1 => CHOICE2704,
      I2 => CHOICE2708,
      O => N1582
    );
  IOA_24_IBUF_61 : IBUF
    port map (
      I => IOA(24),
      O => IOA_24_IBUF
    );
  FNC_2_106 : LUT4_L
    generic map(
      INIT => X"0E04"
    )
    port map (
      I0 => RGT(0),
      I1 => N35,
      I2 => N1564,
      I3 => N161,
      LO => CHOICE2704
    );
  FNC_2_138 : LUT4
    generic map(
      INIT => X"2000"
    )
    port map (
      I0 => RGT(3),
      I1 => RGT(2),
      I2 => LFT(15),
      I3 => INS_2_Q,
      O => CHOICE2839
    );
  FNC_2_1210 : LUT4
    generic map(
      INIT => X"2000"
    )
    port map (
      I0 => RGT(3),
      I1 => RGT(2),
      I2 => INS_2_Q,
      I3 => N1788,
      O => CHOICE2784
    );
  Mshift_n0008_Sh_3_SW2 : LUT2
    generic map(
      INIT => X"B"
    )
    port map (
      I0 => RGT(2),
      I1 => RGT(3),
      O => N1564
    );
  FNC_2_268 : LUT4_L
    generic map(
      INIT => X"AA02"
    )
    port map (
      I0 => N114,
      I1 => INS_2_Q,
      I2 => N1584,
      I3 => CHOICE2680,
      LO => CHOICE2694
    );
  FNC_2_212 : LUT4_L
    generic map(
      INIT => X"0E04"
    )
    port map (
      I0 => RGT(1),
      I1 => N191,
      I2 => N1564,
      I3 => N192,
      LO => CHOICE2683
    );
  FNC_2_1496 : LUT4_L
    generic map(
      INIT => X"DC00"
    )
    port map (
      I0 => RGT(3),
      I1 => CHOICE2886,
      I2 => CHOICE2875,
      I3 => N114,
      LO => CHOICE2888
    );
  FNC_2_1298 : LUT2
    generic map(
      INIT => X"4"
    )
    port map (
      I0 => INS_3_Q,
      I1 => Q_n0023(22),
      O => CHOICE2802
    );
  Ker11431 : LUT4
    generic map(
      INIT => X"0001"
    )
    port map (
      I0 => RGT(13),
      I1 => RGT(4),
      I2 => RGT(15),
      I3 => RGT(12),
      O => CHOICE2667
    );
  IOA_23_IBUF_62 : IBUF
    port map (
      I => IOA(23),
      O => IOA_23_IBUF
    );
  LED_6_OBUF_63 : OBUF
    port map (
      I => LED_6_OBUF,
      O => LED(6)
    );
  Ker901_SW1 : LUT2
    generic map(
      INIT => X"B"
    )
    port map (
      I0 => RGT(3),
      I1 => INS_2_Q,
      O => N1570
    );
  FNC_2_1182 : LUT4_D
    generic map(
      INIT => X"AA08"
    )
    port map (
      I0 => N114,
      I1 => Mshift_n0009_Sh(13),
      I2 => N1592,
      I3 => CHOICE2743,
      LO => N1797,
      O => CHOICE2745
    );
  IOA_22_IBUF_64 : IBUF
    port map (
      I => IOA(22),
      O => IOA_22_IBUF
    );
  FNC_2_284 : LUT2
    generic map(
      INIT => X"4"
    )
    port map (
      I0 => INS_3_Q,
      I1 => Q_n0023(27),
      O => CHOICE2696
    );
  IOA_21_IBUF_65 : IBUF
    port map (
      I => IOA(21),
      O => IOA_21_IBUF
    );
  IOA_1_IBUF_66 : IBUF
    port map (
      I => IOA(1),
      O => IOA_1_IBUF
    );
  FNC_2_1110_SW0 : LUT3
    generic map(
      INIT => X"DF"
    )
    port map (
      I0 => RGT(3),
      I1 => RGT(2),
      I2 => INS_2_Q,
      O => N1592
    );
  Ker11457 : LUT4
    generic map(
      INIT => X"1000"
    )
    port map (
      I0 => RGT(5),
      I1 => N1594,
      I2 => CHOICE2667,
      I3 => CHOICE2674,
      O => N114
    );
  FNC_2_199 : LUT2
    generic map(
      INIT => X"4"
    )
    port map (
      I0 => INS_3_Q,
      I1 => Q_n0023(26),
      O => CHOICE2775
    );
  FNC_2_118 : LUT4_D
    generic map(
      INIT => X"A888"
    )
    port map (
      I0 => N114,
      I1 => CHOICE3105,
      I2 => INS_2_Q,
      I3 => CHOICE3096,
      LO => N1798,
      O => CHOICE3107
    );
  IOA_15_IBUF_67 : IBUF
    port map (
      I => IOA(15),
      O => IOA_15_IBUF
    );
  FNC_2_813_SW0 : LUT3_L
    generic map(
      INIT => X"D8"
    )
    port map (
      I0 => RGT(2),
      I1 => Mshift_n0009_Sh(14),
      I2 => Mshift_n0009_Sh(10),
      LO => N1574
    );
  FNC_2_6102 : LUT4
    generic map(
      INIT => X"0002"
    )
    port map (
      I0 => CHOICE3135,
      I1 => RGT(3),
      I2 => RGT(2),
      I3 => RGT(0),
      O => CHOICE3141
    );
  CLKMA1_OBUF_68 : OBUF
    port map (
      I => CLKMA1_OBUF,
      O => CLKMA1
    );
  FNC_2_14110 : LUT2
    generic map(
      INIT => X"4"
    )
    port map (
      I0 => INS_3_Q,
      I1 => Q_n0023(24),
      O => CHOICE2890
    );
  FNC_2_752_SW0 : LUT4
    generic map(
      INIT => X"0E1F"
    )
    port map (
      I0 => CHOICE3021,
      I1 => CHOICE3027,
      I2 => N1587,
      I3 => N1586,
      O => N1576
    );
  FNC_2_1385 : LUT4_D
    generic map(
      INIT => X"F800"
    )
    port map (
      I0 => CHOICE2839,
      I1 => N115,
      I2 => CHOICE2854,
      I3 => N114,
      LO => N1799,
      O => CHOICE2856
    );
  FNC_2_394 : LUT4_L
    generic map(
      INIT => X"CC40"
    )
    port map (
      I0 => INS_2_Q,
      I1 => N114,
      I2 => CHOICE2912,
      I3 => CHOICE2900,
      LO => CHOICE2916
    );
  FNC_2_311 : LUT4
    generic map(
      INIT => X"0020"
    )
    port map (
      I0 => INS_2_Q,
      I1 => RGT(3),
      I2 => Mshift_n0009_Sh(12),
      I3 => RGT(2),
      O => CHOICE2900
    );
  IOA_2_IBUF_69 : IBUF
    port map (
      I => IOA(2),
      O => IOA_2_IBUF
    );
  FNC_2_465 : LUT4
    generic map(
      INIT => X"F5E4"
    )
    port map (
      I0 => RGT(3),
      I1 => CHOICE2962,
      I2 => N1572,
      I3 => CHOICE2968,
      O => CHOICE2972
    );
  FNC_2_1001 : LUT4
    generic map(
      INIT => X"0002"
    )
    port map (
      I0 => CHOICE3099,
      I1 => RGT(3),
      I2 => RGT(2),
      I3 => RGT(0),
      O => CHOICE3105
    );
  FNC_1_rn_511 : LUT4
    generic map(
      INIT => X"5668"
    )
    port map (
      I0 => INS_3_Q,
      I1 => INS_2_Q,
      I2 => LFT(14),
      I3 => RGT(14),
      O => MUX_BLOCK_FNC_1_MUXF55
    );
  IOA_14_IBUF_70 : IBUF
    port map (
      I => IOA(14),
      O => IOA_14_IBUF
    );
  FNC_2_992 : LUT4_D
    generic map(
      INIT => X"A888"
    )
    port map (
      I0 => N114,
      I1 => CHOICE2942,
      I2 => INS_2_Q,
      I3 => CHOICE2935,
      LO => N1800,
      O => CHOICE2944
    );
  FNC_2_6135 : LUT2
    generic map(
      INIT => X"4"
    )
    port map (
      I0 => INS_3_Q,
      I1 => Q_n0023(31),
      O => CHOICE3145
    );
  FNC_1_rn_211 : LUT4
    generic map(
      INIT => X"5668"
    )
    port map (
      I0 => INS_3_Q,
      I1 => INS_2_Q,
      I2 => LFT(11),
      I3 => RGT(11),
      O => MUX_BLOCK_FNC_1_MUXF52
    );
  FNC_2_565_SW0_G : LUT3_L
    generic map(
      INIT => X"04"
    )
    port map (
      I0 => RGT(2),
      I1 => Mshift_n0009_Sh(14),
      I2 => RGT(3),
      LO => N1787
    );
  INS_3_2_71 : FD
    port map (
      D => IOA_3_IBUF,
      C => CLK_BUFGP,
      Q => INS_3_2
    );
  FNC_2_132 : MUXF5
    port map (
      I0 => N1710,
      I1 => N1711,
      S => RGT(0),
      O => CHOICE3084
    );
  FNC_2_132_F : LUT4_L
    generic map(
      INIT => X"A820"
    )
    port map (
      I0 => RGT(3),
      I1 => RGT(2),
      I2 => N37,
      I3 => N35,
      LO => N1710
    );
  Mshift_n0009_Sh_12_11 : MUXF5
    port map (
      I0 => N1712,
      I1 => N1713,
      S => RGT(1),
      O => Mshift_n0009_Sh(12)
    );
  Mshift_n0009_Sh_12_11_F : LUT3_L
    generic map(
      INIT => X"E4"
    )
    port map (
      I0 => RGT(0),
      I1 => LFT(12),
      I2 => LFT(13),
      LO => N1712
    );
  Mshift_n0008_Sh_3_1 : MUXF5
    port map (
      I0 => N1714,
      I1 => N1715,
      S => RGT(0),
      O => Mshift_n0008_Sh(3)
    );
  Mshift_n0008_Sh_3_1_F : LUT3_L
    generic map(
      INIT => X"E4"
    )
    port map (
      I0 => RGT(1),
      I1 => LFT(3),
      I2 => LFT(1),
      LO => N1714
    );
  Mshift_n0009_Sh_10_11 : MUXF5
    port map (
      I0 => N1716,
      I1 => N1717,
      S => RGT(1),
      O => Mshift_n0009_Sh(10)
    );
  Mshift_n0009_Sh_10_11_F : LUT3_L
    generic map(
      INIT => X"E4"
    )
    port map (
      I0 => RGT(0),
      I1 => LFT(10),
      I2 => LFT(11),
      LO => N1716
    );
  FNC_2_11541 : MUXF5
    port map (
      I0 => N1718,
      I1 => N1719,
      S => RGT(2),
      O => CHOICE2743
    );
  FNC_2_11541_F : LUT4_L
    generic map(
      INIT => X"5140"
    )
    port map (
      I0 => RGT(3),
      I1 => INS_2_Q,
      I2 => Mshift_n0009_Sh(5),
      I3 => Mshift_n0008_Sh(5),
      LO => N1718
    );
  FNC_2_14291 : MUXF5
    port map (
      I0 => N1720,
      I1 => N1721,
      S => RGT(2),
      O => CHOICE2875
    );
  FNC_2_14291_F : LUT3_L
    generic map(
      INIT => X"E4"
    )
    port map (
      I0 => INS_2_Q,
      I1 => Mshift_n0008_Sh(8),
      I2 => Mshift_n0009_Sh(8),
      LO => N1720
    );
  FNC_2_13571 : MUXF5
    port map (
      I0 => N1722,
      I1 => N1723,
      S => RGT(2),
      O => CHOICE2854
    );
  FNC_2_13571_F : LUT4_L
    generic map(
      INIT => X"5140"
    )
    port map (
      I0 => RGT(3),
      I1 => INS_2_Q,
      I2 => Mshift_n0009_Sh(7),
      I3 => Mshift_n0008_Sh(7),
      LO => N1722
    );
  FNC_2_10141 : MUXF5
    port map (
      I0 => N1724,
      I1 => N1725,
      S => RGT(0),
      O => CHOICE2708
    );
  FNC_2_10141_F : LUT3_L
    generic map(
      INIT => X"E4"
    )
    port map (
      I0 => RGT(2),
      I1 => N29,
      I2 => N37,
      LO => N1724
    );
  Mshift_n0008_Sh_4_1 : MUXF5
    port map (
      I0 => N1726,
      I1 => N1727,
      S => RGT(0),
      O => Mshift_n0008_Sh(4)
    );
  Mshift_n0008_Sh_4_1_F : LUT3_L
    generic map(
      INIT => X"E4"
    )
    port map (
      I0 => RGT(1),
      I1 => LFT(4),
      I2 => LFT(2),
      LO => N1726
    );
  FNC_2_3151 : MUXF5
    port map (
      I0 => N1728,
      I1 => N1729,
      S => RGT(1),
      O => CHOICE2902
    );
  FNC_2_3151_F : LUT4_L
    generic map(
      INIT => X"A820"
    )
    port map (
      I0 => RGT(2),
      I1 => RGT(0),
      I2 => LFT(8),
      I3 => LFT(7),
      LO => N1728
    );
  FNC_2_51611 : MUXF5
    port map (
      I0 => N1730,
      I1 => N1731,
      S => Q_n0023(30),
      O => ACCUM(14)
    );
  FNC_2_51611_F : LUT3_L
    generic map(
      INIT => X"E4"
    )
    port map (
      I0 => INS_5_Q,
      I1 => CHOICE3008,
      I2 => MUX_BLOCK_FNC_1_MUXF55,
      LO => N1730
    );
  FNC_2_2271 : MUXF5
    port map (
      I0 => N1732,
      I1 => N1733,
      S => RGT(0),
      O => CHOICE2689
    );
  FNC_2_2271_F : LUT4_L
    generic map(
      INIT => X"5140"
    )
    port map (
      I0 => RGT(3),
      I1 => RGT(2),
      I2 => N33,
      I3 => N68,
      LO => N1732
    );
  FNC_2_8141 : MUXF5
    port map (
      I0 => N1734,
      I1 => N1735,
      S => RGT(1),
      O => CHOICE3053
    );
  FNC_2_8141_F : LUT4_L
    generic map(
      INIT => X"A820"
    )
    port map (
      I0 => RGT(2),
      I1 => RGT(0),
      I2 => LFT(6),
      I3 => LFT(7),
      LO => N1734
    );
  Mshift_n0009_Sh_6_11 : MUXF5
    port map (
      I0 => N1736,
      I1 => N1737,
      S => RGT(1),
      O => Mshift_n0009_Sh(6)
    );
  Mshift_n0009_Sh_6_11_F : LUT3_L
    generic map(
      INIT => X"E4"
    )
    port map (
      I0 => RGT(0),
      I1 => LFT(6),
      I2 => LFT(7),
      LO => N1736
    );
  FNC_2_7141 : MUXF5
    port map (
      I0 => N1738,
      I1 => N1739,
      S => RGT(1),
      O => CHOICE3021
    );
  FNC_2_7141_F : LUT4_L
    generic map(
      INIT => X"A820"
    )
    port map (
      I0 => RGT(2),
      I1 => RGT(0),
      I2 => LFT(5),
      I3 => LFT(6),
      LO => N1738
    );
  Mshift_n0008_Sh_5_1 : MUXF5
    port map (
      I0 => N1740,
      I1 => N1741,
      S => RGT(0),
      O => Mshift_n0008_Sh(5)
    );
  Mshift_n0008_Sh_5_1_F : LUT3_L
    generic map(
      INIT => X"E4"
    )
    port map (
      I0 => RGT(1),
      I1 => LFT(5),
      I2 => LFT(3),
      LO => N1740
    );
  FNC_2_12541 : MUXF5
    port map (
      I0 => N1742,
      I1 => N1743,
      S => RGT(2),
      O => CHOICE2798
    );
  FNC_2_12541_F : LUT4_L
    generic map(
      INIT => X"5140"
    )
    port map (
      I0 => RGT(3),
      I1 => INS_2_Q,
      I2 => Mshift_n0009_Sh(6),
      I3 => Mshift_n0008_Sh(6),
      LO => N1742
    );
  FNC_2_15551 : MUXF5
    port map (
      I0 => N1744,
      I1 => N1745,
      S => RGT(2),
      O => CHOICE2826
    );
  FNC_2_15551_F : LUT4_L
    generic map(
      INIT => X"5140"
    )
    port map (
      I0 => RGT(3),
      I1 => INS_2_Q,
      I2 => Mshift_n0009_Sh(9),
      I3 => Mshift_n0008_Sh(9),
      LO => N1744
    );
  Mshift_n0009_Sh_9_11 : MUXF5
    port map (
      I0 => N1746,
      I1 => N1747,
      S => RGT(1),
      O => Mshift_n0009_Sh(9)
    );
  Mshift_n0009_Sh_9_11_F : LUT3_L
    generic map(
      INIT => X"E4"
    )
    port map (
      I0 => RGT(0),
      I1 => LFT(9),
      I2 => LFT(10),
      LO => N1746
    );
  FNC_2_3301 : MUXF5
    port map (
      I0 => N1748,
      I1 => N1749,
      S => RGT(1),
      O => CHOICE2908
    );
  FNC_2_3301_F : LUT4_L
    generic map(
      INIT => X"5140"
    )
    port map (
      I0 => RGT(2),
      I1 => RGT(0),
      I2 => LFT(11),
      I3 => LFT(12),
      LO => N1748
    );
  FNC_2_921 : MUXF5
    port map (
      I0 => N1750,
      I1 => N1751,
      S => RGT(1),
      O => CHOICE2925
    );
  FNC_2_921_F : LUT4_L
    generic map(
      INIT => X"A820"
    )
    port map (
      I0 => RGT(2),
      I1 => RGT(0),
      I2 => LFT(7),
      I3 => LFT(8),
      LO => N1750
    );
  FNC_2_5271 : MUXF5
    port map (
      I0 => N1752,
      I1 => N1753,
      S => RGT(1),
      O => CHOICE2994
    );
  FNC_2_5271_F : LUT4_L
    generic map(
      INIT => X"A820"
    )
    port map (
      I0 => RGT(2),
      I1 => RGT(0),
      I2 => LFT(10),
      I3 => LFT(9),
      LO => N1752
    );
  FNC_2_3113 : MUXF5
    port map (
      I0 => N1754,
      I1 => N1755,
      S => RGT(0),
      O => CHOICE3092
    );
  FNC_2_3113_F : LUT3_L
    generic map(
      INIT => X"08"
    )
    port map (
      I0 => RGT(1),
      I1 => LFT(2),
      I2 => RGT(2),
      LO => N1754
    );
  FNC_2_6131 : MUXF5
    port map (
      I0 => N1756,
      I1 => N1757,
      S => RGT(2),
      O => CHOICE3119
    );
  FNC_2_6131_F : LUT4_L
    generic map(
      INIT => X"A820"
    )
    port map (
      I0 => RGT(3),
      I1 => RGT(0),
      I2 => N33,
      I3 => N23,
      LO => N1756
    );
  Mshift_n0008_Sh_6_1 : MUXF5
    port map (
      I0 => N1758,
      I1 => N1759,
      S => RGT(1),
      O => Mshift_n0008_Sh(6)
    );
  Mshift_n0008_Sh_6_1_F : LUT3_L
    generic map(
      INIT => X"E4"
    )
    port map (
      I0 => RGT(0),
      I1 => LFT(6),
      I2 => LFT(5),
      LO => N1758
    );
  FNC_2_4271 : MUXF5
    port map (
      I0 => N1760,
      I1 => N1761,
      S => RGT(1),
      O => CHOICE2962
    );
  FNC_2_4271_F : LUT4_L
    generic map(
      INIT => X"A820"
    )
    port map (
      I0 => RGT(2),
      I1 => RGT(0),
      I2 => LFT(9),
      I3 => LFT(8),
      LO => N1760
    );
  Mshift_n0008_Sh_9_11 : MUXF5
    port map (
      I0 => N1762,
      I1 => N1763,
      S => RGT(1),
      O => Mshift_n0008_Sh(9)
    );
  Mshift_n0008_Sh_9_11_F : LUT3_L
    generic map(
      INIT => X"E4"
    )
    port map (
      I0 => RGT(0),
      I1 => LFT(9),
      I2 => LFT(8),
      LO => N1762
    );
  Mshift_n0009_Sh_11_11 : MUXF5
    port map (
      I0 => N1764,
      I1 => N1765,
      S => RGT(1),
      O => Mshift_n0009_Sh(11)
    );
  Mshift_n0009_Sh_11_11_F : LUT3_L
    generic map(
      INIT => X"E4"
    )
    port map (
      I0 => RGT(0),
      I1 => LFT(11),
      I2 => LFT(12),
      LO => N1764
    );
  Mshift_n0009_Sh_5_11 : MUXF5
    port map (
      I0 => N1766,
      I1 => N1767,
      S => RGT(1),
      O => Mshift_n0009_Sh(5)
    );
  Mshift_n0009_Sh_5_11_F : LUT3_L
    generic map(
      INIT => X"E4"
    )
    port map (
      I0 => RGT(0),
      I1 => LFT(5),
      I2 => LFT(6),
      LO => N1766
    );
  Mshift_n0008_Sh_8_11 : MUXF5
    port map (
      I0 => N1768,
      I1 => N1769,
      S => RGT(1),
      O => Mshift_n0008_Sh(8)
    );
  Mshift_n0008_Sh_8_11_F : LUT3_L
    generic map(
      INIT => X"E4"
    )
    port map (
      I0 => RGT(0),
      I1 => LFT(8),
      I2 => LFT(7),
      LO => N1768
    );
  Mshift_n0008_Sh_10_11 : MUXF5
    port map (
      I0 => N1770,
      I1 => N1771,
      S => RGT(1),
      O => Mshift_n0008_Sh(10)
    );
  Mshift_n0008_Sh_10_11_F : LUT3_L
    generic map(
      INIT => X"E4"
    )
    port map (
      I0 => RGT(0),
      I1 => LFT(10),
      I2 => LFT(9),
      LO => N1770
    );
  Mshift_n0009_Sh_8_11 : MUXF5
    port map (
      I0 => N1772,
      I1 => N1773,
      S => RGT(1),
      O => Mshift_n0009_Sh(8)
    );
  Mshift_n0009_Sh_8_11_F : LUT3_L
    generic map(
      INIT => X"E4"
    )
    port map (
      I0 => RGT(0),
      I1 => LFT(8),
      I2 => LFT(9),
      LO => N1772
    );
  FNC_2_1401 : MUXF5
    port map (
      I0 => N1774,
      I1 => N1775,
      S => RGT(2),
      O => CHOICE2769
    );
  FNC_2_1401_F : LUT3_L
    generic map(
      INIT => X"E4"
    )
    port map (
      I0 => INS_2_Q,
      I1 => Mshift_n0008_Sh(10),
      I2 => Mshift_n0009_Sh(10),
      LO => N1774
    );
  Mshift_n0009_Sh_7_11 : MUXF5
    port map (
      I0 => N1776,
      I1 => N1777,
      S => RGT(1),
      O => Mshift_n0009_Sh(7)
    );
  Mshift_n0009_Sh_7_11_F : LUT3_L
    generic map(
      INIT => X"E4"
    )
    port map (
      I0 => RGT(0),
      I1 => LFT(7),
      I2 => LFT(8),
      LO => N1776
    );
  FNC_2_4421 : MUXF5
    port map (
      I0 => N1778,
      I1 => N1779,
      S => RGT(1),
      O => CHOICE2968
    );
  FNC_2_4421_F : LUT4_L
    generic map(
      INIT => X"5140"
    )
    port map (
      I0 => RGT(2),
      I1 => RGT(0),
      I2 => LFT(12),
      I3 => LFT(13),
      LO => N1778
    );
  FNC_2_5421 : MUXF5
    port map (
      I0 => N1780,
      I1 => N1781,
      S => RGT(1),
      O => CHOICE3000
    );
  FNC_2_5421_F : LUT4_L
    generic map(
      INIT => X"5140"
    )
    port map (
      I0 => RGT(2),
      I1 => RGT(0),
      I2 => LFT(13),
      I3 => LFT(14),
      LO => N1780
    );
  Mshift_n0008_Sh_7_11 : MUXF5
    port map (
      I0 => N1782,
      I1 => N1783,
      S => RGT(1),
      O => Mshift_n0008_Sh(7)
    );
  Mshift_n0008_Sh_7_11_F : LUT3_L
    generic map(
      INIT => X"E4"
    )
    port map (
      I0 => RGT(0),
      I1 => LFT(7),
      I2 => LFT(6),
      LO => N1782
    );
  FNC_2_631 : MUXF5
    port map (
      I0 => N1784,
      I1 => N1785,
      S => RGT(0),
      O => CHOICE3127
    );
  FNC_2_631_F : LUT3_L
    generic map(
      INIT => X"08"
    )
    port map (
      I0 => RGT(1),
      I1 => LFT(13),
      I2 => RGT(2),
      LO => N1784
    );
  FNC_2_565_SW0 : MUXF5
    port map (
      I0 => N1786,
      I1 => N1787,
      S => INS_2_Q,
      O => N1579
    );
  FNC_2_565_SW0_F : LUT3_L
    generic map(
      INIT => X"32"
    )
    port map (
      I0 => CHOICE3000,
      I1 => RGT(3),
      I2 => CHOICE2994,
      LO => N1786
    );

end Structure;

